// This file was automatically generated by bifcl from /builddir/build/BUILD/zeek-3.0.1/src/analyzer/protocol/dns/events.bif (plugin mode).


#include "events.bif.h"

EventHandlerPtr dns_message; 
void BifEvent::generate_dns_message(analyzer::Analyzer* analyzer, Connection* c, int is_orig, Val* msg, bro_uint_t len)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_message is NULL, which should happen *before*
	// BifEvent::generate_dns_message is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::dns_message, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        msg,
	        val_mgr->GetCount(len),
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr dns_request; 
void BifEvent::generate_dns_request(analyzer::Analyzer* analyzer, Connection* c, Val* msg, StringVal* query, bro_uint_t qtype, bro_uint_t qclass)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_request is NULL, which should happen *before*
	// BifEvent::generate_dns_request is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::dns_request, val_list{
	        c->BuildConnVal(),
	        msg,
	        query,
	        val_mgr->GetCount(qtype),
	        val_mgr->GetCount(qclass),
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr dns_rejected; 
void BifEvent::generate_dns_rejected(analyzer::Analyzer* analyzer, Connection* c, Val* msg, StringVal* query, bro_uint_t qtype, bro_uint_t qclass)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_rejected is NULL, which should happen *before*
	// BifEvent::generate_dns_rejected is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::dns_rejected, val_list{
	        c->BuildConnVal(),
	        msg,
	        query,
	        val_mgr->GetCount(qtype),
	        val_mgr->GetCount(qclass),
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr dns_query_reply; 
void BifEvent::generate_dns_query_reply(analyzer::Analyzer* analyzer, Connection* c, Val* msg, StringVal* query, bro_uint_t qtype, bro_uint_t qclass)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_query_reply is NULL, which should happen *before*
	// BifEvent::generate_dns_query_reply is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::dns_query_reply, val_list{
	        c->BuildConnVal(),
	        msg,
	        query,
	        val_mgr->GetCount(qtype),
	        val_mgr->GetCount(qclass),
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr dns_A_reply; 
void BifEvent::generate_dns_A_reply(analyzer::Analyzer* analyzer, Connection* c, Val* msg, Val* ans, AddrVal* a)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_A_reply is NULL, which should happen *before*
	// BifEvent::generate_dns_A_reply is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::dns_A_reply, val_list{
	        c->BuildConnVal(),
	        msg,
	        ans,
	        a,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr dns_AAAA_reply; 
void BifEvent::generate_dns_AAAA_reply(analyzer::Analyzer* analyzer, Connection* c, Val* msg, Val* ans, AddrVal* a)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_AAAA_reply is NULL, which should happen *before*
	// BifEvent::generate_dns_AAAA_reply is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::dns_AAAA_reply, val_list{
	        c->BuildConnVal(),
	        msg,
	        ans,
	        a,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr dns_A6_reply; 
void BifEvent::generate_dns_A6_reply(analyzer::Analyzer* analyzer, Connection* c, Val* msg, Val* ans, AddrVal* a)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_A6_reply is NULL, which should happen *before*
	// BifEvent::generate_dns_A6_reply is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::dns_A6_reply, val_list{
	        c->BuildConnVal(),
	        msg,
	        ans,
	        a,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr dns_NS_reply; 
void BifEvent::generate_dns_NS_reply(analyzer::Analyzer* analyzer, Connection* c, Val* msg, Val* ans, StringVal* name)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_NS_reply is NULL, which should happen *before*
	// BifEvent::generate_dns_NS_reply is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::dns_NS_reply, val_list{
	        c->BuildConnVal(),
	        msg,
	        ans,
	        name,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr dns_CNAME_reply; 
void BifEvent::generate_dns_CNAME_reply(analyzer::Analyzer* analyzer, Connection* c, Val* msg, Val* ans, StringVal* name)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_CNAME_reply is NULL, which should happen *before*
	// BifEvent::generate_dns_CNAME_reply is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::dns_CNAME_reply, val_list{
	        c->BuildConnVal(),
	        msg,
	        ans,
	        name,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr dns_PTR_reply; 
void BifEvent::generate_dns_PTR_reply(analyzer::Analyzer* analyzer, Connection* c, Val* msg, Val* ans, StringVal* name)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_PTR_reply is NULL, which should happen *before*
	// BifEvent::generate_dns_PTR_reply is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::dns_PTR_reply, val_list{
	        c->BuildConnVal(),
	        msg,
	        ans,
	        name,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr dns_SOA_reply; 
void BifEvent::generate_dns_SOA_reply(analyzer::Analyzer* analyzer, Connection* c, Val* msg, Val* ans, Val* soa)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_SOA_reply is NULL, which should happen *before*
	// BifEvent::generate_dns_SOA_reply is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::dns_SOA_reply, val_list{
	        c->BuildConnVal(),
	        msg,
	        ans,
	        soa,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr dns_WKS_reply; 
void BifEvent::generate_dns_WKS_reply(analyzer::Analyzer* analyzer, Connection* c, Val* msg, Val* ans)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_WKS_reply is NULL, which should happen *before*
	// BifEvent::generate_dns_WKS_reply is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::dns_WKS_reply, val_list{
	        c->BuildConnVal(),
	        msg,
	        ans,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr dns_HINFO_reply; 
void BifEvent::generate_dns_HINFO_reply(analyzer::Analyzer* analyzer, Connection* c, Val* msg, Val* ans)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_HINFO_reply is NULL, which should happen *before*
	// BifEvent::generate_dns_HINFO_reply is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::dns_HINFO_reply, val_list{
	        c->BuildConnVal(),
	        msg,
	        ans,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr dns_MX_reply; 
void BifEvent::generate_dns_MX_reply(analyzer::Analyzer* analyzer, Connection* c, Val* msg, Val* ans, StringVal* name, bro_uint_t preference)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_MX_reply is NULL, which should happen *before*
	// BifEvent::generate_dns_MX_reply is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::dns_MX_reply, val_list{
	        c->BuildConnVal(),
	        msg,
	        ans,
	        name,
	        val_mgr->GetCount(preference),
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr dns_TXT_reply; 
void BifEvent::generate_dns_TXT_reply(analyzer::Analyzer* analyzer, Connection* c, Val* msg, Val* ans, Val* strs)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_TXT_reply is NULL, which should happen *before*
	// BifEvent::generate_dns_TXT_reply is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::dns_TXT_reply, val_list{
	        c->BuildConnVal(),
	        msg,
	        ans,
	        strs,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr dns_SPF_reply; 
void BifEvent::generate_dns_SPF_reply(analyzer::Analyzer* analyzer, Connection* c, Val* msg, Val* ans, Val* strs)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_SPF_reply is NULL, which should happen *before*
	// BifEvent::generate_dns_SPF_reply is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::dns_SPF_reply, val_list{
	        c->BuildConnVal(),
	        msg,
	        ans,
	        strs,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr dns_CAA_reply; 
void BifEvent::generate_dns_CAA_reply(analyzer::Analyzer* analyzer, Connection* c, Val* msg, Val* ans, bro_uint_t flags, StringVal* tag, StringVal* value)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_CAA_reply is NULL, which should happen *before*
	// BifEvent::generate_dns_CAA_reply is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::dns_CAA_reply, val_list{
	        c->BuildConnVal(),
	        msg,
	        ans,
	        val_mgr->GetCount(flags),
	        tag,
	        value,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr dns_SRV_reply; 
void BifEvent::generate_dns_SRV_reply(analyzer::Analyzer* analyzer, Connection* c, Val* msg, Val* ans, StringVal* target, bro_uint_t priority, bro_uint_t weight, bro_uint_t p)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_SRV_reply is NULL, which should happen *before*
	// BifEvent::generate_dns_SRV_reply is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::dns_SRV_reply, val_list{
	        c->BuildConnVal(),
	        msg,
	        ans,
	        target,
	        val_mgr->GetCount(priority),
	        val_mgr->GetCount(weight),
	        val_mgr->GetCount(p),
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr dns_unknown_reply; 
void BifEvent::generate_dns_unknown_reply(analyzer::Analyzer* analyzer, Connection* c, Val* msg, Val* ans)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_unknown_reply is NULL, which should happen *before*
	// BifEvent::generate_dns_unknown_reply is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::dns_unknown_reply, val_list{
	        c->BuildConnVal(),
	        msg,
	        ans,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr dns_EDNS_addl; 
void BifEvent::generate_dns_EDNS_addl(analyzer::Analyzer* analyzer, Connection* c, Val* msg, Val* ans)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_EDNS_addl is NULL, which should happen *before*
	// BifEvent::generate_dns_EDNS_addl is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::dns_EDNS_addl, val_list{
	        c->BuildConnVal(),
	        msg,
	        ans,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr dns_TSIG_addl; 
void BifEvent::generate_dns_TSIG_addl(analyzer::Analyzer* analyzer, Connection* c, Val* msg, Val* ans)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_TSIG_addl is NULL, which should happen *before*
	// BifEvent::generate_dns_TSIG_addl is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::dns_TSIG_addl, val_list{
	        c->BuildConnVal(),
	        msg,
	        ans,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr dns_RRSIG; 
void BifEvent::generate_dns_RRSIG(analyzer::Analyzer* analyzer, Connection* c, Val* msg, Val* ans, Val* rrsig)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_RRSIG is NULL, which should happen *before*
	// BifEvent::generate_dns_RRSIG is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::dns_RRSIG, val_list{
	        c->BuildConnVal(),
	        msg,
	        ans,
	        rrsig,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr dns_DNSKEY; 
void BifEvent::generate_dns_DNSKEY(analyzer::Analyzer* analyzer, Connection* c, Val* msg, Val* ans, Val* dnskey)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_DNSKEY is NULL, which should happen *before*
	// BifEvent::generate_dns_DNSKEY is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::dns_DNSKEY, val_list{
	        c->BuildConnVal(),
	        msg,
	        ans,
	        dnskey,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr dns_NSEC; 
void BifEvent::generate_dns_NSEC(analyzer::Analyzer* analyzer, Connection* c, Val* msg, Val* ans, StringVal* next_name, Val* bitmaps)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_NSEC is NULL, which should happen *before*
	// BifEvent::generate_dns_NSEC is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::dns_NSEC, val_list{
	        c->BuildConnVal(),
	        msg,
	        ans,
	        next_name,
	        bitmaps,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr dns_NSEC3; 
void BifEvent::generate_dns_NSEC3(analyzer::Analyzer* analyzer, Connection* c, Val* msg, Val* ans, Val* nsec3)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_NSEC3 is NULL, which should happen *before*
	// BifEvent::generate_dns_NSEC3 is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::dns_NSEC3, val_list{
	        c->BuildConnVal(),
	        msg,
	        ans,
	        nsec3,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr dns_DS; 
void BifEvent::generate_dns_DS(analyzer::Analyzer* analyzer, Connection* c, Val* msg, Val* ans, Val* ds)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_DS is NULL, which should happen *before*
	// BifEvent::generate_dns_DS is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::dns_DS, val_list{
	        c->BuildConnVal(),
	        msg,
	        ans,
	        ds,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr dns_end; 
void BifEvent::generate_dns_end(analyzer::Analyzer* analyzer, Connection* c, Val* msg)
	{
	// Note that it is intentional that here we do not
	// check if ::dns_end is NULL, which should happen *before*
	// BifEvent::generate_dns_end is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::dns_end, val_list{
	        c->BuildConnVal(),
	        msg,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
