// This file was automatically generated by bifcl from /builddir/build/BUILD/zeek-3.0.1/src/analyzer/protocol/http/events.bif (plugin mode).


#include "events.bif.h"

EventHandlerPtr http_request; 
void BifEvent::generate_http_request(analyzer::Analyzer* analyzer, Connection* c, StringVal* method, StringVal* original_URI, StringVal* unescaped_URI, StringVal* version)
	{
	// Note that it is intentional that here we do not
	// check if ::http_request is NULL, which should happen *before*
	// BifEvent::generate_http_request is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::http_request, val_list{
	        c->BuildConnVal(),
	        method,
	        original_URI,
	        unescaped_URI,
	        version,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr http_reply; 
void BifEvent::generate_http_reply(analyzer::Analyzer* analyzer, Connection* c, StringVal* version, bro_uint_t code, StringVal* reason)
	{
	// Note that it is intentional that here we do not
	// check if ::http_reply is NULL, which should happen *before*
	// BifEvent::generate_http_reply is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::http_reply, val_list{
	        c->BuildConnVal(),
	        version,
	        val_mgr->GetCount(code),
	        reason,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr http_header; 
void BifEvent::generate_http_header(analyzer::Analyzer* analyzer, Connection* c, int is_orig, StringVal* name, StringVal* value)
	{
	// Note that it is intentional that here we do not
	// check if ::http_header is NULL, which should happen *before*
	// BifEvent::generate_http_header is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::http_header, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        name,
	        value,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr http_all_headers; 
void BifEvent::generate_http_all_headers(analyzer::Analyzer* analyzer, Connection* c, int is_orig, Val* hlist)
	{
	// Note that it is intentional that here we do not
	// check if ::http_all_headers is NULL, which should happen *before*
	// BifEvent::generate_http_all_headers is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::http_all_headers, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        hlist,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr http_begin_entity; 
void BifEvent::generate_http_begin_entity(analyzer::Analyzer* analyzer, Connection* c, int is_orig)
	{
	// Note that it is intentional that here we do not
	// check if ::http_begin_entity is NULL, which should happen *before*
	// BifEvent::generate_http_begin_entity is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::http_begin_entity, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr http_end_entity; 
void BifEvent::generate_http_end_entity(analyzer::Analyzer* analyzer, Connection* c, int is_orig)
	{
	// Note that it is intentional that here we do not
	// check if ::http_end_entity is NULL, which should happen *before*
	// BifEvent::generate_http_end_entity is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::http_end_entity, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr http_entity_data; 
void BifEvent::generate_http_entity_data(analyzer::Analyzer* analyzer, Connection* c, int is_orig, bro_uint_t length, StringVal* data)
	{
	// Note that it is intentional that here we do not
	// check if ::http_entity_data is NULL, which should happen *before*
	// BifEvent::generate_http_entity_data is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::http_entity_data, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        val_mgr->GetCount(length),
	        data,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr http_content_type; 
void BifEvent::generate_http_content_type(analyzer::Analyzer* analyzer, Connection* c, int is_orig, StringVal* ty, StringVal* subty)
	{
	// Note that it is intentional that here we do not
	// check if ::http_content_type is NULL, which should happen *before*
	// BifEvent::generate_http_content_type is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::http_content_type, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        ty,
	        subty,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr http_message_done; 
void BifEvent::generate_http_message_done(analyzer::Analyzer* analyzer, Connection* c, int is_orig, Val* stat)
	{
	// Note that it is intentional that here we do not
	// check if ::http_message_done is NULL, which should happen *before*
	// BifEvent::generate_http_message_done is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::http_message_done, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        stat,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr http_event; 
void BifEvent::generate_http_event(analyzer::Analyzer* analyzer, Connection* c, StringVal* event_type, StringVal* detail)
	{
	// Note that it is intentional that here we do not
	// check if ::http_event is NULL, which should happen *before*
	// BifEvent::generate_http_event is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::http_event, val_list{
	        c->BuildConnVal(),
	        event_type,
	        detail,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr http_stats; 
void BifEvent::generate_http_stats(analyzer::Analyzer* analyzer, Connection* c, Val* stats)
	{
	// Note that it is intentional that here we do not
	// check if ::http_stats is NULL, which should happen *before*
	// BifEvent::generate_http_stats is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::http_stats, val_list{
	        c->BuildConnVal(),
	        stats,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr http_connection_upgrade; 
void BifEvent::generate_http_connection_upgrade(analyzer::Analyzer* analyzer, Connection* c, StringVal* protocol)
	{
	// Note that it is intentional that here we do not
	// check if ::http_connection_upgrade is NULL, which should happen *before*
	// BifEvent::generate_http_connection_upgrade is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::http_connection_upgrade, val_list{
	        c->BuildConnVal(),
	        protocol,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
