// This file was automatically generated by bifcl from /builddir/build/BUILD/zeek-3.0.1/src/analyzer/protocol/icmp/events.bif (plugin mode).


#include "events.bif.h"

EventHandlerPtr icmp_sent; 
void BifEvent::generate_icmp_sent(analyzer::Analyzer* analyzer, Connection* c, Val* icmp)
	{
	// Note that it is intentional that here we do not
	// check if ::icmp_sent is NULL, which should happen *before*
	// BifEvent::generate_icmp_sent is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::icmp_sent, val_list{
	        c->BuildConnVal(),
	        icmp,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr icmp_sent_payload; 
void BifEvent::generate_icmp_sent_payload(analyzer::Analyzer* analyzer, Connection* c, Val* icmp, StringVal* payload)
	{
	// Note that it is intentional that here we do not
	// check if ::icmp_sent_payload is NULL, which should happen *before*
	// BifEvent::generate_icmp_sent_payload is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::icmp_sent_payload, val_list{
	        c->BuildConnVal(),
	        icmp,
	        payload,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr icmp_echo_request; 
void BifEvent::generate_icmp_echo_request(analyzer::Analyzer* analyzer, Connection* c, Val* icmp, bro_uint_t id, bro_uint_t seq, StringVal* payload)
	{
	// Note that it is intentional that here we do not
	// check if ::icmp_echo_request is NULL, which should happen *before*
	// BifEvent::generate_icmp_echo_request is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::icmp_echo_request, val_list{
	        c->BuildConnVal(),
	        icmp,
	        val_mgr->GetCount(id),
	        val_mgr->GetCount(seq),
	        payload,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr icmp_echo_reply; 
void BifEvent::generate_icmp_echo_reply(analyzer::Analyzer* analyzer, Connection* c, Val* icmp, bro_uint_t id, bro_uint_t seq, StringVal* payload)
	{
	// Note that it is intentional that here we do not
	// check if ::icmp_echo_reply is NULL, which should happen *before*
	// BifEvent::generate_icmp_echo_reply is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::icmp_echo_reply, val_list{
	        c->BuildConnVal(),
	        icmp,
	        val_mgr->GetCount(id),
	        val_mgr->GetCount(seq),
	        payload,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr icmp_error_message; 
void BifEvent::generate_icmp_error_message(analyzer::Analyzer* analyzer, Connection* c, Val* icmp, bro_uint_t code, Val* context)
	{
	// Note that it is intentional that here we do not
	// check if ::icmp_error_message is NULL, which should happen *before*
	// BifEvent::generate_icmp_error_message is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::icmp_error_message, val_list{
	        c->BuildConnVal(),
	        icmp,
	        val_mgr->GetCount(code),
	        context,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr icmp_unreachable; 
void BifEvent::generate_icmp_unreachable(analyzer::Analyzer* analyzer, Connection* c, Val* icmp, bro_uint_t code, Val* context)
	{
	// Note that it is intentional that here we do not
	// check if ::icmp_unreachable is NULL, which should happen *before*
	// BifEvent::generate_icmp_unreachable is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::icmp_unreachable, val_list{
	        c->BuildConnVal(),
	        icmp,
	        val_mgr->GetCount(code),
	        context,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr icmp_packet_too_big; 
void BifEvent::generate_icmp_packet_too_big(analyzer::Analyzer* analyzer, Connection* c, Val* icmp, bro_uint_t code, Val* context)
	{
	// Note that it is intentional that here we do not
	// check if ::icmp_packet_too_big is NULL, which should happen *before*
	// BifEvent::generate_icmp_packet_too_big is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::icmp_packet_too_big, val_list{
	        c->BuildConnVal(),
	        icmp,
	        val_mgr->GetCount(code),
	        context,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr icmp_time_exceeded; 
void BifEvent::generate_icmp_time_exceeded(analyzer::Analyzer* analyzer, Connection* c, Val* icmp, bro_uint_t code, Val* context)
	{
	// Note that it is intentional that here we do not
	// check if ::icmp_time_exceeded is NULL, which should happen *before*
	// BifEvent::generate_icmp_time_exceeded is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::icmp_time_exceeded, val_list{
	        c->BuildConnVal(),
	        icmp,
	        val_mgr->GetCount(code),
	        context,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr icmp_parameter_problem; 
void BifEvent::generate_icmp_parameter_problem(analyzer::Analyzer* analyzer, Connection* c, Val* icmp, bro_uint_t code, Val* context)
	{
	// Note that it is intentional that here we do not
	// check if ::icmp_parameter_problem is NULL, which should happen *before*
	// BifEvent::generate_icmp_parameter_problem is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::icmp_parameter_problem, val_list{
	        c->BuildConnVal(),
	        icmp,
	        val_mgr->GetCount(code),
	        context,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr icmp_router_solicitation; 
void BifEvent::generate_icmp_router_solicitation(analyzer::Analyzer* analyzer, Connection* c, Val* icmp, Val* options)
	{
	// Note that it is intentional that here we do not
	// check if ::icmp_router_solicitation is NULL, which should happen *before*
	// BifEvent::generate_icmp_router_solicitation is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::icmp_router_solicitation, val_list{
	        c->BuildConnVal(),
	        icmp,
	        options,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr icmp_router_advertisement; 
void BifEvent::generate_icmp_router_advertisement(analyzer::Analyzer* analyzer, Connection* c, Val* icmp, bro_uint_t cur_hop_limit, int managed, int other, int home_agent, bro_uint_t pref, int proxy, bro_uint_t rsv, double router_lifetime, double reachable_time, double retrans_timer, Val* options)
	{
	// Note that it is intentional that here we do not
	// check if ::icmp_router_advertisement is NULL, which should happen *before*
	// BifEvent::generate_icmp_router_advertisement is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::icmp_router_advertisement, val_list{
	        c->BuildConnVal(),
	        icmp,
	        val_mgr->GetCount(cur_hop_limit),
	        val_mgr->GetBool(managed),
	        val_mgr->GetBool(other),
	        val_mgr->GetBool(home_agent),
	        val_mgr->GetCount(pref),
	        val_mgr->GetBool(proxy),
	        val_mgr->GetCount(rsv),
	        new IntervalVal(router_lifetime, Seconds),
	        new IntervalVal(reachable_time, Seconds),
	        new IntervalVal(retrans_timer, Seconds),
	        options,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr icmp_neighbor_solicitation; 
void BifEvent::generate_icmp_neighbor_solicitation(analyzer::Analyzer* analyzer, Connection* c, Val* icmp, AddrVal* tgt, Val* options)
	{
	// Note that it is intentional that here we do not
	// check if ::icmp_neighbor_solicitation is NULL, which should happen *before*
	// BifEvent::generate_icmp_neighbor_solicitation is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::icmp_neighbor_solicitation, val_list{
	        c->BuildConnVal(),
	        icmp,
	        tgt,
	        options,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr icmp_neighbor_advertisement; 
void BifEvent::generate_icmp_neighbor_advertisement(analyzer::Analyzer* analyzer, Connection* c, Val* icmp, int router, int solicited, int override, AddrVal* tgt, Val* options)
	{
	// Note that it is intentional that here we do not
	// check if ::icmp_neighbor_advertisement is NULL, which should happen *before*
	// BifEvent::generate_icmp_neighbor_advertisement is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::icmp_neighbor_advertisement, val_list{
	        c->BuildConnVal(),
	        icmp,
	        val_mgr->GetBool(router),
	        val_mgr->GetBool(solicited),
	        val_mgr->GetBool(override),
	        tgt,
	        options,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr icmp_redirect; 
void BifEvent::generate_icmp_redirect(analyzer::Analyzer* analyzer, Connection* c, Val* icmp, AddrVal* tgt, AddrVal* dest, Val* options)
	{
	// Note that it is intentional that here we do not
	// check if ::icmp_redirect is NULL, which should happen *before*
	// BifEvent::generate_icmp_redirect is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::icmp_redirect, val_list{
	        c->BuildConnVal(),
	        icmp,
	        tgt,
	        dest,
	        options,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
