// This file was automatically generated by bifcl from /builddir/build/BUILD/zeek-3.0.1/src/analyzer/protocol/irc/events.bif (plugin mode).


#include "events.bif.h"

EventHandlerPtr irc_request; 
void BifEvent::generate_irc_request(analyzer::Analyzer* analyzer, Connection* c, int is_orig, StringVal* prefix, StringVal* command, StringVal* arguments)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_request is NULL, which should happen *before*
	// BifEvent::generate_irc_request is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::irc_request, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        prefix,
	        command,
	        arguments,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr irc_reply; 
void BifEvent::generate_irc_reply(analyzer::Analyzer* analyzer, Connection* c, int is_orig, StringVal* prefix, bro_uint_t code, StringVal* params)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_reply is NULL, which should happen *before*
	// BifEvent::generate_irc_reply is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::irc_reply, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        prefix,
	        val_mgr->GetCount(code),
	        params,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr irc_message; 
void BifEvent::generate_irc_message(analyzer::Analyzer* analyzer, Connection* c, int is_orig, StringVal* prefix, StringVal* command, StringVal* message)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_message is NULL, which should happen *before*
	// BifEvent::generate_irc_message is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::irc_message, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        prefix,
	        command,
	        message,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr irc_quit_message; 
void BifEvent::generate_irc_quit_message(analyzer::Analyzer* analyzer, Connection* c, int is_orig, StringVal* nick, StringVal* message)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_quit_message is NULL, which should happen *before*
	// BifEvent::generate_irc_quit_message is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::irc_quit_message, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        nick,
	        message,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr irc_privmsg_message; 
void BifEvent::generate_irc_privmsg_message(analyzer::Analyzer* analyzer, Connection* c, int is_orig, StringVal* source, StringVal* target, StringVal* message)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_privmsg_message is NULL, which should happen *before*
	// BifEvent::generate_irc_privmsg_message is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::irc_privmsg_message, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        source,
	        target,
	        message,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr irc_notice_message; 
void BifEvent::generate_irc_notice_message(analyzer::Analyzer* analyzer, Connection* c, int is_orig, StringVal* source, StringVal* target, StringVal* message)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_notice_message is NULL, which should happen *before*
	// BifEvent::generate_irc_notice_message is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::irc_notice_message, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        source,
	        target,
	        message,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr irc_squery_message; 
void BifEvent::generate_irc_squery_message(analyzer::Analyzer* analyzer, Connection* c, int is_orig, StringVal* source, StringVal* target, StringVal* message)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_squery_message is NULL, which should happen *before*
	// BifEvent::generate_irc_squery_message is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::irc_squery_message, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        source,
	        target,
	        message,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr irc_join_message; 
void BifEvent::generate_irc_join_message(analyzer::Analyzer* analyzer, Connection* c, int is_orig, Val* info_list)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_join_message is NULL, which should happen *before*
	// BifEvent::generate_irc_join_message is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::irc_join_message, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        info_list,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr irc_part_message; 
void BifEvent::generate_irc_part_message(analyzer::Analyzer* analyzer, Connection* c, int is_orig, StringVal* nick, Val* chans, StringVal* message)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_part_message is NULL, which should happen *before*
	// BifEvent::generate_irc_part_message is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::irc_part_message, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        nick,
	        chans,
	        message,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr irc_nick_message; 
void BifEvent::generate_irc_nick_message(analyzer::Analyzer* analyzer, Connection* c, int is_orig, StringVal* who, StringVal* newnick)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_nick_message is NULL, which should happen *before*
	// BifEvent::generate_irc_nick_message is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::irc_nick_message, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        who,
	        newnick,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr irc_invalid_nick; 
void BifEvent::generate_irc_invalid_nick(analyzer::Analyzer* analyzer, Connection* c, int is_orig)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_invalid_nick is NULL, which should happen *before*
	// BifEvent::generate_irc_invalid_nick is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::irc_invalid_nick, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr irc_network_info; 
void BifEvent::generate_irc_network_info(analyzer::Analyzer* analyzer, Connection* c, int is_orig, bro_uint_t users, bro_uint_t services, bro_uint_t servers)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_network_info is NULL, which should happen *before*
	// BifEvent::generate_irc_network_info is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::irc_network_info, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        val_mgr->GetCount(users),
	        val_mgr->GetCount(services),
	        val_mgr->GetCount(servers),
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr irc_server_info; 
void BifEvent::generate_irc_server_info(analyzer::Analyzer* analyzer, Connection* c, int is_orig, bro_uint_t users, bro_uint_t services, bro_uint_t servers)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_server_info is NULL, which should happen *before*
	// BifEvent::generate_irc_server_info is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::irc_server_info, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        val_mgr->GetCount(users),
	        val_mgr->GetCount(services),
	        val_mgr->GetCount(servers),
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr irc_channel_info; 
void BifEvent::generate_irc_channel_info(analyzer::Analyzer* analyzer, Connection* c, int is_orig, bro_uint_t chans)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_channel_info is NULL, which should happen *before*
	// BifEvent::generate_irc_channel_info is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::irc_channel_info, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        val_mgr->GetCount(chans),
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr irc_who_line; 
void BifEvent::generate_irc_who_line(analyzer::Analyzer* analyzer, Connection* c, int is_orig, StringVal* target_nick, StringVal* channel, StringVal* user, StringVal* host, StringVal* server, StringVal* nick, StringVal* params, bro_uint_t hops, StringVal* real_name)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_who_line is NULL, which should happen *before*
	// BifEvent::generate_irc_who_line is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::irc_who_line, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        target_nick,
	        channel,
	        user,
	        host,
	        server,
	        nick,
	        params,
	        val_mgr->GetCount(hops),
	        real_name,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr irc_names_info; 
void BifEvent::generate_irc_names_info(analyzer::Analyzer* analyzer, Connection* c, int is_orig, StringVal* c_type, StringVal* channel, Val* users)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_names_info is NULL, which should happen *before*
	// BifEvent::generate_irc_names_info is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::irc_names_info, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        c_type,
	        channel,
	        users,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr irc_whois_operator_line; 
void BifEvent::generate_irc_whois_operator_line(analyzer::Analyzer* analyzer, Connection* c, int is_orig, StringVal* nick)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_whois_operator_line is NULL, which should happen *before*
	// BifEvent::generate_irc_whois_operator_line is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::irc_whois_operator_line, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        nick,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr irc_whois_channel_line; 
void BifEvent::generate_irc_whois_channel_line(analyzer::Analyzer* analyzer, Connection* c, int is_orig, StringVal* nick, Val* chans)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_whois_channel_line is NULL, which should happen *before*
	// BifEvent::generate_irc_whois_channel_line is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::irc_whois_channel_line, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        nick,
	        chans,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr irc_whois_user_line; 
void BifEvent::generate_irc_whois_user_line(analyzer::Analyzer* analyzer, Connection* c, int is_orig, StringVal* nick, StringVal* user, StringVal* host, StringVal* real_name)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_whois_user_line is NULL, which should happen *before*
	// BifEvent::generate_irc_whois_user_line is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::irc_whois_user_line, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        nick,
	        user,
	        host,
	        real_name,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr irc_oper_response; 
void BifEvent::generate_irc_oper_response(analyzer::Analyzer* analyzer, Connection* c, int is_orig, int got_oper)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_oper_response is NULL, which should happen *before*
	// BifEvent::generate_irc_oper_response is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::irc_oper_response, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        val_mgr->GetBool(got_oper),
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr irc_global_users; 
void BifEvent::generate_irc_global_users(analyzer::Analyzer* analyzer, Connection* c, int is_orig, StringVal* prefix, StringVal* msg)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_global_users is NULL, which should happen *before*
	// BifEvent::generate_irc_global_users is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::irc_global_users, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        prefix,
	        msg,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr irc_channel_topic; 
void BifEvent::generate_irc_channel_topic(analyzer::Analyzer* analyzer, Connection* c, int is_orig, StringVal* channel, StringVal* topic)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_channel_topic is NULL, which should happen *before*
	// BifEvent::generate_irc_channel_topic is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::irc_channel_topic, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        channel,
	        topic,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr irc_who_message; 
void BifEvent::generate_irc_who_message(analyzer::Analyzer* analyzer, Connection* c, int is_orig, StringVal* mask, int oper)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_who_message is NULL, which should happen *before*
	// BifEvent::generate_irc_who_message is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::irc_who_message, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        mask,
	        val_mgr->GetBool(oper),
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr irc_whois_message; 
void BifEvent::generate_irc_whois_message(analyzer::Analyzer* analyzer, Connection* c, int is_orig, StringVal* server, StringVal* users)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_whois_message is NULL, which should happen *before*
	// BifEvent::generate_irc_whois_message is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::irc_whois_message, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        server,
	        users,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr irc_oper_message; 
void BifEvent::generate_irc_oper_message(analyzer::Analyzer* analyzer, Connection* c, int is_orig, StringVal* user, StringVal* password)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_oper_message is NULL, which should happen *before*
	// BifEvent::generate_irc_oper_message is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::irc_oper_message, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        user,
	        password,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr irc_kick_message; 
void BifEvent::generate_irc_kick_message(analyzer::Analyzer* analyzer, Connection* c, int is_orig, StringVal* prefix, StringVal* chans, StringVal* users, StringVal* comment)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_kick_message is NULL, which should happen *before*
	// BifEvent::generate_irc_kick_message is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::irc_kick_message, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        prefix,
	        chans,
	        users,
	        comment,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr irc_error_message; 
void BifEvent::generate_irc_error_message(analyzer::Analyzer* analyzer, Connection* c, int is_orig, StringVal* prefix, StringVal* message)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_error_message is NULL, which should happen *before*
	// BifEvent::generate_irc_error_message is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::irc_error_message, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        prefix,
	        message,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr irc_invite_message; 
void BifEvent::generate_irc_invite_message(analyzer::Analyzer* analyzer, Connection* c, int is_orig, StringVal* prefix, StringVal* nickname, StringVal* channel)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_invite_message is NULL, which should happen *before*
	// BifEvent::generate_irc_invite_message is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::irc_invite_message, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        prefix,
	        nickname,
	        channel,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr irc_mode_message; 
void BifEvent::generate_irc_mode_message(analyzer::Analyzer* analyzer, Connection* c, int is_orig, StringVal* prefix, StringVal* params)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_mode_message is NULL, which should happen *before*
	// BifEvent::generate_irc_mode_message is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::irc_mode_message, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        prefix,
	        params,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr irc_squit_message; 
void BifEvent::generate_irc_squit_message(analyzer::Analyzer* analyzer, Connection* c, int is_orig, StringVal* prefix, StringVal* server, StringVal* message)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_squit_message is NULL, which should happen *before*
	// BifEvent::generate_irc_squit_message is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::irc_squit_message, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        prefix,
	        server,
	        message,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr irc_dcc_message; 
void BifEvent::generate_irc_dcc_message(analyzer::Analyzer* analyzer, Connection* c, int is_orig, StringVal* prefix, StringVal* target, StringVal* dcc_type, StringVal* argument, AddrVal* address, bro_uint_t dest_port, bro_uint_t size)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_dcc_message is NULL, which should happen *before*
	// BifEvent::generate_irc_dcc_message is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::irc_dcc_message, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        prefix,
	        target,
	        dcc_type,
	        argument,
	        address,
	        val_mgr->GetCount(dest_port),
	        val_mgr->GetCount(size),
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr irc_user_message; 
void BifEvent::generate_irc_user_message(analyzer::Analyzer* analyzer, Connection* c, int is_orig, StringVal* user, StringVal* host, StringVal* server, StringVal* real_name)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_user_message is NULL, which should happen *before*
	// BifEvent::generate_irc_user_message is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::irc_user_message, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        user,
	        host,
	        server,
	        real_name,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr irc_password_message; 
void BifEvent::generate_irc_password_message(analyzer::Analyzer* analyzer, Connection* c, int is_orig, StringVal* password)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_password_message is NULL, which should happen *before*
	// BifEvent::generate_irc_password_message is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::irc_password_message, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        password,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr irc_starttls; 
void BifEvent::generate_irc_starttls(analyzer::Analyzer* analyzer, Connection* c)
	{
	// Note that it is intentional that here we do not
	// check if ::irc_starttls is NULL, which should happen *before*
	// BifEvent::generate_irc_starttls is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::irc_starttls, val_list{
	        c->BuildConnVal(),
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
