// This file was automatically generated by bifcl from /builddir/build/BUILD/zeek-3.0.1/src/analyzer/protocol/mime/events.bif (plugin mode).


#include "events.bif.h"

EventHandlerPtr mime_begin_entity; 
void BifEvent::generate_mime_begin_entity(analyzer::Analyzer* analyzer, Connection* c)
	{
	// Note that it is intentional that here we do not
	// check if ::mime_begin_entity is NULL, which should happen *before*
	// BifEvent::generate_mime_begin_entity is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::mime_begin_entity, val_list{
	        c->BuildConnVal(),
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr mime_end_entity; 
void BifEvent::generate_mime_end_entity(analyzer::Analyzer* analyzer, Connection* c)
	{
	// Note that it is intentional that here we do not
	// check if ::mime_end_entity is NULL, which should happen *before*
	// BifEvent::generate_mime_end_entity is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::mime_end_entity, val_list{
	        c->BuildConnVal(),
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr mime_one_header; 
void BifEvent::generate_mime_one_header(analyzer::Analyzer* analyzer, Connection* c, Val* h)
	{
	// Note that it is intentional that here we do not
	// check if ::mime_one_header is NULL, which should happen *before*
	// BifEvent::generate_mime_one_header is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::mime_one_header, val_list{
	        c->BuildConnVal(),
	        h,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr mime_all_headers; 
void BifEvent::generate_mime_all_headers(analyzer::Analyzer* analyzer, Connection* c, Val* hlist)
	{
	// Note that it is intentional that here we do not
	// check if ::mime_all_headers is NULL, which should happen *before*
	// BifEvent::generate_mime_all_headers is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::mime_all_headers, val_list{
	        c->BuildConnVal(),
	        hlist,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr mime_segment_data; 
void BifEvent::generate_mime_segment_data(analyzer::Analyzer* analyzer, Connection* c, bro_uint_t length, StringVal* data)
	{
	// Note that it is intentional that here we do not
	// check if ::mime_segment_data is NULL, which should happen *before*
	// BifEvent::generate_mime_segment_data is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::mime_segment_data, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetCount(length),
	        data,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr mime_entity_data; 
void BifEvent::generate_mime_entity_data(analyzer::Analyzer* analyzer, Connection* c, bro_uint_t length, StringVal* data)
	{
	// Note that it is intentional that here we do not
	// check if ::mime_entity_data is NULL, which should happen *before*
	// BifEvent::generate_mime_entity_data is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::mime_entity_data, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetCount(length),
	        data,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr mime_all_data; 
void BifEvent::generate_mime_all_data(analyzer::Analyzer* analyzer, Connection* c, bro_uint_t length, StringVal* data)
	{
	// Note that it is intentional that here we do not
	// check if ::mime_all_data is NULL, which should happen *before*
	// BifEvent::generate_mime_all_data is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::mime_all_data, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetCount(length),
	        data,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr mime_event; 
void BifEvent::generate_mime_event(analyzer::Analyzer* analyzer, Connection* c, StringVal* event_type, StringVal* detail)
	{
	// Note that it is intentional that here we do not
	// check if ::mime_event is NULL, which should happen *before*
	// BifEvent::generate_mime_event is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::mime_event, val_list{
	        c->BuildConnVal(),
	        event_type,
	        detail,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr mime_content_hash; 
void BifEvent::generate_mime_content_hash(analyzer::Analyzer* analyzer, Connection* c, bro_uint_t content_len, StringVal* hash_value)
	{
	// Note that it is intentional that here we do not
	// check if ::mime_content_hash is NULL, which should happen *before*
	// BifEvent::generate_mime_content_hash is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::mime_content_hash, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetCount(content_len),
	        hash_value,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
