// This file is automatically generated from /builddir/build/BUILD/zeek-3.0.1/src/analyzer/protocol/ntp/ntp.pac.

#ifndef _builddir_build_BUILD_zeek_3_0_1_src_analyzer_protocol_ntp_ntp_pac_h
#define _builddir_build_BUILD_zeek_3_0_1_src_analyzer_protocol_ntp_ntp_pac_h

#include <vector>

#include "binpac.h"


#include "binpac_bro.h"


	#include "types.bif.h"
	#include "events.bif.h"


	#include <math.h>
	#define FRAC_16 pow(2,-16)
	#define FRAC_32 pow(2,-32)
	// NTP defines the epoch from 1900, not 1970
	#define EPOCH_OFFSET -2208988800

namespace binpac {

namespace NTP {
class ContextNTP;
class NTP_Conn;
class NTP_mode7_msg;
class NTP_PDU;
class NTP_std_msg;
class NTP_control_msg;
class NTP_MAC;
class NTP_MAC_ext;
class NTP_CONTROL_MAC;
class Extension_Field;
class NTP_Short_Time;
class NTP_Time;
class NTP_Flow;
} // namespace NTP

int bytestring_to_int(const_bytestring const & s, int base);
double bytestring_to_double(const_bytestring const & s);
int bytestring_casecmp(const_bytestring const & s1, const_charptr const & s2);
bool bytestring_caseprefix(const_bytestring const & s1, const_charptr const & s2);
double network_time();
StringVal * utf16_bytestring_to_utf8_val(Connection * conn, bytestring const & utf16);
namespace NTP {

class ContextNTP
{
public:
	ContextNTP(NTP_Conn * connection, NTP_Flow * flow);
	~ContextNTP();
	
	// Member access functions
	NTP_Conn * connection() const { return connection_; }
	NTP_Flow * flow() const { return flow_; }
	
protected:
	NTP_Conn * connection_;
	NTP_Flow * flow_;
};


class NTP_Conn : public binpac::ConnectionAnalyzer
{
public:
	NTP_Conn(BroAnalyzer const & bro_analyzer);
	~NTP_Conn();
	
	// Member access functions
	NTP_Flow * upflow() const { return upflow_; }
	NTP_Flow * downflow() const { return downflow_; }
	BroAnalyzer const & bro_analyzer() const { return bro_analyzer_; }
	
	void NewData(bool is_orig, const_byteptr begin, const_byteptr end);
	void NewGap(bool is_orig, int gap_length);
	void FlowEOF(bool is_orig);
	
protected:
	NTP_Flow * upflow_;
	NTP_Flow * downflow_;
	BroAnalyzer bro_analyzer_;
};


class NTP_mode7_msg
{
public:
	NTP_mode7_msg();
	~NTP_mode7_msg();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	uint8 second_byte() const { return second_byte_; }
	uint8 implementation() const { return implementation_; }
	uint8 request_code() const { return request_code_; }
	uint16 err_and_data_len() const { return err_and_data_len_; }
	bytestring const & data() const { return data_; }
	int have_mac_case_index() const	{ return have_mac_case_index_; }
	NTP_MAC * mac() const
		{
		switch ( have_mac_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/zeek-3.0.1/src/analyzer/protocol/ntp/ntp-mode7.pac:114:mac", (int64)have_mac_case_index(), "true");
				break;
			}
		return mac_;
		}
	int byteorder() const { return byteorder_; }
	bool auth_bit() const { return auth_bit_; }
	uint8 sequence() const { return sequence_; }
	uint8 error_code() const { return error_code_; }
	uint16 data_len() const { return data_len_; }
	const_bytestring const & sourcedata() const { return sourcedata_; }
	
protected:
	uint8 second_byte_;
	uint8 implementation_;
	uint8 request_code_;
	uint16 err_and_data_len_;
	bytestring data_;
	int have_mac_case_index_;
	NTP_MAC * mac_;
	int byteorder_;
	bool auth_bit_;
	uint8 sequence_;
	uint8 error_code_;
	uint16 data_len_;
	const_bytestring sourcedata_;
};


class NTP_PDU
{
public:
	NTP_PDU(bool is_orig);
	~NTP_PDU();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, ContextNTP * t_context);
	
	// Member access functions
	uint8 first_byte() const { return first_byte_; }
	int standard_modes_case_index() const	{ return standard_modes_case_index_; }
	NTP_std_msg * std() const
		{
		switch ( standard_modes_case_index() )
			{
			case ((int) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/zeek-3.0.1/src/analyzer/protocol/ntp/ntp-protocol.pac:10:std", (int64)standard_modes_case_index(), "true");
				break;
			}
		return std_;
		}
	uint8 modes_6_7_case_index() const	{ return modes_6_7_case_index_; }
	NTP_control_msg * control() const
		{
		switch ( modes_6_7_case_index() )
			{
			case ((uint8) 6):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/zeek-3.0.1/src/analyzer/protocol/ntp/ntp-protocol.pac:16:control", (int64)modes_6_7_case_index(), "((int) 6)");
				break;
			}
		return control_;
		}
	NTP_mode7_msg * mode7() const
		{
		switch ( modes_6_7_case_index() )
			{
			case ((uint8) 7):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/zeek-3.0.1/src/analyzer/protocol/ntp/ntp-protocol.pac:19:mode7", (int64)modes_6_7_case_index(), "((int) 7)");
				break;
			}
		return mode7_;
		}
	bytestring const & unknown() const
		{
		return unknown_;
		}
	bool is_orig() const { return is_orig_; }
	int byteorder() const { return byteorder_; }
	uint8 leap() const { return leap_; }
	uint8 version() const { return version_; }
	uint8 mode() const { return mode_; }
	bool proc() const { return proc_; }
	const_bytestring const & sourcedata() const { return sourcedata_; }
	
protected:
	uint8 first_byte_;
	int standard_modes_case_index_;
	NTP_std_msg * std_;
	uint8 modes_6_7_case_index_;
	NTP_control_msg * control_;
	NTP_mode7_msg * mode7_;
	bytestring unknown_;
	bool is_orig_;
	int byteorder_;
	uint8 leap_;
	uint8 version_;
	uint8 mode_;
	bool proc_;
	const_bytestring sourcedata_;
};


class NTP_std_msg
{
public:
	NTP_std_msg();
	~NTP_std_msg();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	uint8 stratum() const { return stratum_; }
	int8 poll() const { return poll_; }
	int8 precision() const { return precision_; }
	NTP_Short_Time * root_delay() const { return root_delay_; }
	NTP_Short_Time * root_dispersion() const { return root_dispersion_; }
	bytestring const & reference_id() const { return reference_id_; }
	NTP_Time * reference_ts() const { return reference_ts_; }
	NTP_Time * origin_ts() const { return origin_ts_; }
	NTP_Time * receive_ts() const { return receive_ts_; }
	NTP_Time * transmit_ts() const { return transmit_ts_; }
	int extensions_case_index() const	{ return extensions_case_index_; }
	vector<Extension_Field *> * exts() const
		{
		switch ( extensions_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/zeek-3.0.1/src/analyzer/protocol/ntp/ntp-protocol.pac:47:exts", (int64)extensions_case_index(), "true");
				break;
			}
		return exts_;
		}
	uint32 mac_fields_case_index() const	{ return mac_fields_case_index_; }
	NTP_MAC * mac() const
		{
		switch ( mac_fields_case_index() )
			{
			case ((uint32) 20):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/zeek-3.0.1/src/analyzer/protocol/ntp/ntp-protocol.pac:52:mac", (int64)mac_fields_case_index(), "((int) 20)");
				break;
			}
		return mac_;
		}
	NTP_MAC_ext * mac_ext() const
		{
		switch ( mac_fields_case_index() )
			{
			case ((uint32) 24):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/zeek-3.0.1/src/analyzer/protocol/ntp/ntp-protocol.pac:53:mac_ext", (int64)mac_fields_case_index(), "((int) 24)");
				break;
			}
		return mac_ext_;
		}
	int byteorder() const { return byteorder_; }
	int length() const { return length_; }
	bool has_exts() const { return has_exts_; }
	uint32 mac_len() const { return mac_len_; }
	const_bytestring const & sourcedata() const { return sourcedata_; }
	
protected:
	uint8 stratum_;
	int8 poll_;
	int8 precision_;
	NTP_Short_Time * root_delay_;
	NTP_Short_Time * root_dispersion_;
	bytestring reference_id_;
	NTP_Time * reference_ts_;
	NTP_Time * origin_ts_;
	NTP_Time * receive_ts_;
	NTP_Time * transmit_ts_;
	int extensions_case_index_;
	vector<Extension_Field *> * exts_;
	Extension_Field * exts__elem_;
	uint32 mac_fields_case_index_;
	NTP_MAC * mac_;
	NTP_MAC_ext * mac_ext_;
	int byteorder_;
	int length_;
	bool has_exts_;
	uint32 mac_len_;
	const_bytestring sourcedata_;
};


class NTP_control_msg
{
public:
	NTP_control_msg();
	~NTP_control_msg();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data);
	
	// Member access functions
	uint8 second_byte() const { return second_byte_; }
	uint16 sequence() const { return sequence_; }
	uint16 status() const { return status_; }
	uint16 association_id() const { return association_id_; }
	uint16 offs() const { return offs_; }
	uint16 c() const { return c_; }
	bytestring const & data() const { return data_; }
	int mac_fields_case_index() const	{ return mac_fields_case_index_; }
	NTP_CONTROL_MAC * mac() const
		{
		switch ( mac_fields_case_index() )
			{
			case ((bool) 1):
				break;  // OK
			default:
				throw binpac::ExceptionInvalidCase("/builddir/build/BUILD/zeek-3.0.1/src/analyzer/protocol/ntp/ntp-protocol.pac:74:mac", (int64)mac_fields_case_index(), "true");
				break;
			}
		return mac_;
		}
	int byteorder() const { return byteorder_; }
	bool R() const { return R_; }
	bool E() const { return E_; }
	bool M() const { return M_; }
	uint8 OpCode() const { return OpCode_; }
	int length() const { return length_; }
	bool has_control_mac() const { return has_control_mac_; }
	const_bytestring const & sourcedata() const { return sourcedata_; }
	
protected:
	uint8 second_byte_;
	uint16 sequence_;
	uint16 status_;
	uint16 association_id_;
	uint16 offs_;
	uint16 c_;
	bytestring data_;
	int mac_fields_case_index_;
	NTP_CONTROL_MAC * mac_;
	int byteorder_;
	bool R_;
	bool E_;
	bool M_;
	uint8 OpCode_;
	int length_;
	bool has_control_mac_;
	const_bytestring sourcedata_;
};


class NTP_MAC
{
public:
	NTP_MAC();
	~NTP_MAC();
	int initial_buffer_length() const { return 0; }
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder);
	
	// Member access functions
	uint32 key_id() const { return key_id_; }
	bytestring const & digest() const { return digest_; }
	
protected:
	uint32 key_id_;
	bytestring digest_;
};


class NTP_MAC_ext
{
public:
	NTP_MAC_ext();
	~NTP_MAC_ext();
	int initial_buffer_length() const { return 0; }
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder);
	
	// Member access functions
	uint32 key_id() const { return key_id_; }
	bytestring const & digest() const { return digest_; }
	
protected:
	uint32 key_id_;
	bytestring digest_;
};


class NTP_CONTROL_MAC
{
public:
	NTP_CONTROL_MAC();
	~NTP_CONTROL_MAC();
	int initial_buffer_length() const { return 0; }
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder);
	
	// Member access functions
	uint32 key_id() const { return key_id_; }
	bytestring const & crypto_checksum() const { return crypto_checksum_; }
	
protected:
	uint32 key_id_;
	bytestring crypto_checksum_;
};


class Extension_Field
{
public:
	Extension_Field();
	~Extension_Field();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder);
	
	// Member access functions
	uint8 first_byte_ext() const { return first_byte_ext_; }
	uint8 field_type() const { return field_type_; }
	uint16 len() const { return len_; }
	uint16 association_id() const { return association_id_; }
	uint32 timestamp() const { return timestamp_; }
	uint32 filestamp() const { return filestamp_; }
	uint32 value_len() const { return value_len_; }
	bytestring const & value() const { return value_; }
	uint32 sig_len() const { return sig_len_; }
	bytestring const & signature() const { return signature_; }
	bool R() const { return R_; }
	bool E() const { return E_; }
	uint8 Code() const { return Code_; }
	
protected:
	uint8 first_byte_ext_;
	uint8 field_type_;
	uint16 len_;
	uint16 association_id_;
	uint32 timestamp_;
	uint32 filestamp_;
	uint32 value_len_;
	bytestring value_;
	uint32 sig_len_;
	bytestring signature_;
	bool R_;
	bool E_;
	uint8 Code_;
};


class NTP_Short_Time
{
public:
	NTP_Short_Time();
	~NTP_Short_Time();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder);
	
	// Member access functions
	int16 seconds() const { return seconds_; }
	int16 fractions() const { return fractions_; }
	
protected:
	int16 seconds_;
	int16 fractions_;
};


class NTP_Time
{
public:
	NTP_Time();
	~NTP_Time();
	int Parse(const_byteptr const t_begin_of_data, const_byteptr const t_end_of_data, int t_byteorder);
	
	// Member access functions
	uint32 seconds() const { return seconds_; }
	uint32 fractions() const { return fractions_; }
	
protected:
	uint32 seconds_;
	uint32 fractions_;
};


class NTP_Flow : public binpac::FlowAnalyzer
{
public:
	NTP_Flow(NTP_Conn * connection, bool is_orig);
	~NTP_Flow();
	
	// Member access functions
	NTP_Conn * connection() const { return connection_; }
	bool is_orig() const { return is_orig_; }
	
	void NewData(const_byteptr t_begin_of_data, const_byteptr t_end_of_data);
	void NewGap(int gap_length);
	void FlowEOF();
	
	// Functions
	BroVal BuildNTPStdMsg(NTP_std_msg * nsm);
	BroVal BuildNTPControlMsg(NTP_control_msg * ncm);
	BroVal BuildNTPMode7Msg(NTP_mode7_msg * m7);
	bool proc_ntp_message(NTP_PDU * msg);
	
protected:
	NTP_PDU * dataunit_;
	ContextNTP * context_;
	NTP_Conn * connection_;
	bool is_orig_;
};


	Val* proc_ntp_short(const NTP_Short_Time* t);
	Val* proc_ntp_timestamp(const NTP_Time* t);

} // namespace NTP
}  // namespace binpac
#endif /* _builddir_build_BUILD_zeek_3_0_1_src_analyzer_protocol_ntp_ntp_pac_h */
