// This file was automatically generated by bifcl from /builddir/build/BUILD/zeek-3.0.1/src/analyzer/protocol/rdp/events.bif (plugin mode).


#include "events.bif.h"

EventHandlerPtr rdp_native_encrypted_data; 
void BifEvent::generate_rdp_native_encrypted_data(analyzer::Analyzer* analyzer, Connection* c, int orig, bro_uint_t len)
	{
	// Note that it is intentional that here we do not
	// check if ::rdp_native_encrypted_data is NULL, which should happen *before*
	// BifEvent::generate_rdp_native_encrypted_data is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::rdp_native_encrypted_data, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(orig),
	        val_mgr->GetCount(len),
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr rdp_connect_request; 
void BifEvent::generate_rdp_connect_request(analyzer::Analyzer* analyzer, Connection* c, StringVal* cookie)
	{
	// Note that it is intentional that here we do not
	// check if ::rdp_connect_request is NULL, which should happen *before*
	// BifEvent::generate_rdp_connect_request is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::rdp_connect_request, val_list{
	        c->BuildConnVal(),
	        cookie,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr rdp_negotiation_response; 
void BifEvent::generate_rdp_negotiation_response(analyzer::Analyzer* analyzer, Connection* c, bro_uint_t security_protocol)
	{
	// Note that it is intentional that here we do not
	// check if ::rdp_negotiation_response is NULL, which should happen *before*
	// BifEvent::generate_rdp_negotiation_response is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::rdp_negotiation_response, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetCount(security_protocol),
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr rdp_negotiation_failure; 
void BifEvent::generate_rdp_negotiation_failure(analyzer::Analyzer* analyzer, Connection* c, bro_uint_t failure_code)
	{
	// Note that it is intentional that here we do not
	// check if ::rdp_negotiation_failure is NULL, which should happen *before*
	// BifEvent::generate_rdp_negotiation_failure is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::rdp_negotiation_failure, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetCount(failure_code),
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr rdp_client_core_data; 
void BifEvent::generate_rdp_client_core_data(analyzer::Analyzer* analyzer, Connection* c, Val* data)
	{
	// Note that it is intentional that here we do not
	// check if ::rdp_client_core_data is NULL, which should happen *before*
	// BifEvent::generate_rdp_client_core_data is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::rdp_client_core_data, val_list{
	        c->BuildConnVal(),
	        data,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr rdp_client_security_data; 
void BifEvent::generate_rdp_client_security_data(analyzer::Analyzer* analyzer, Connection* c, Val* data)
	{
	// Note that it is intentional that here we do not
	// check if ::rdp_client_security_data is NULL, which should happen *before*
	// BifEvent::generate_rdp_client_security_data is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::rdp_client_security_data, val_list{
	        c->BuildConnVal(),
	        data,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr rdp_client_network_data; 
void BifEvent::generate_rdp_client_network_data(analyzer::Analyzer* analyzer, Connection* c, Val* channels)
	{
	// Note that it is intentional that here we do not
	// check if ::rdp_client_network_data is NULL, which should happen *before*
	// BifEvent::generate_rdp_client_network_data is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::rdp_client_network_data, val_list{
	        c->BuildConnVal(),
	        channels,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr rdp_client_cluster_data; 
void BifEvent::generate_rdp_client_cluster_data(analyzer::Analyzer* analyzer, Connection* c, Val* data)
	{
	// Note that it is intentional that here we do not
	// check if ::rdp_client_cluster_data is NULL, which should happen *before*
	// BifEvent::generate_rdp_client_cluster_data is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::rdp_client_cluster_data, val_list{
	        c->BuildConnVal(),
	        data,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr rdp_gcc_server_create_response; 
void BifEvent::generate_rdp_gcc_server_create_response(analyzer::Analyzer* analyzer, Connection* c, bro_uint_t result)
	{
	// Note that it is intentional that here we do not
	// check if ::rdp_gcc_server_create_response is NULL, which should happen *before*
	// BifEvent::generate_rdp_gcc_server_create_response is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::rdp_gcc_server_create_response, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetCount(result),
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr rdp_server_security; 
void BifEvent::generate_rdp_server_security(analyzer::Analyzer* analyzer, Connection* c, bro_uint_t encryption_method, bro_uint_t encryption_level)
	{
	// Note that it is intentional that here we do not
	// check if ::rdp_server_security is NULL, which should happen *before*
	// BifEvent::generate_rdp_server_security is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::rdp_server_security, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetCount(encryption_method),
	        val_mgr->GetCount(encryption_level),
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr rdp_server_certificate; 
void BifEvent::generate_rdp_server_certificate(analyzer::Analyzer* analyzer, Connection* c, bro_uint_t cert_type, int permanently_issued)
	{
	// Note that it is intentional that here we do not
	// check if ::rdp_server_certificate is NULL, which should happen *before*
	// BifEvent::generate_rdp_server_certificate is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::rdp_server_certificate, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetCount(cert_type),
	        val_mgr->GetBool(permanently_issued),
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr rdp_begin_encryption; 
void BifEvent::generate_rdp_begin_encryption(analyzer::Analyzer* analyzer, Connection* c, bro_uint_t security_protocol)
	{
	// Note that it is intentional that here we do not
	// check if ::rdp_begin_encryption is NULL, which should happen *before*
	// BifEvent::generate_rdp_begin_encryption is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::rdp_begin_encryption, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetCount(security_protocol),
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
