// This file was automatically generated by bifcl from /builddir/build/BUILD/zeek-3.0.1/src/analyzer/protocol/ssh/events.bif (plugin mode).


#include "events.bif.h"

EventHandlerPtr ssh_server_version; 
void BifEvent::generate_ssh_server_version(analyzer::Analyzer* analyzer, Connection* c, StringVal* version)
	{
	// Note that it is intentional that here we do not
	// check if ::ssh_server_version is NULL, which should happen *before*
	// BifEvent::generate_ssh_server_version is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::ssh_server_version, val_list{
	        c->BuildConnVal(),
	        version,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr ssh_client_version; 
void BifEvent::generate_ssh_client_version(analyzer::Analyzer* analyzer, Connection* c, StringVal* version)
	{
	// Note that it is intentional that here we do not
	// check if ::ssh_client_version is NULL, which should happen *before*
	// BifEvent::generate_ssh_client_version is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::ssh_client_version, val_list{
	        c->BuildConnVal(),
	        version,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr ssh_auth_successful; 
void BifEvent::generate_ssh_auth_successful(analyzer::Analyzer* analyzer, Connection* c, int auth_method_none)
	{
	// Note that it is intentional that here we do not
	// check if ::ssh_auth_successful is NULL, which should happen *before*
	// BifEvent::generate_ssh_auth_successful is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::ssh_auth_successful, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(auth_method_none),
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr ssh_auth_attempted; 
void BifEvent::generate_ssh_auth_attempted(analyzer::Analyzer* analyzer, Connection* c, int authenticated)
	{
	// Note that it is intentional that here we do not
	// check if ::ssh_auth_attempted is NULL, which should happen *before*
	// BifEvent::generate_ssh_auth_attempted is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::ssh_auth_attempted, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(authenticated),
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr ssh_capabilities; 
void BifEvent::generate_ssh_capabilities(analyzer::Analyzer* analyzer, Connection* c, StringVal* cookie, Val* capabilities)
	{
	// Note that it is intentional that here we do not
	// check if ::ssh_capabilities is NULL, which should happen *before*
	// BifEvent::generate_ssh_capabilities is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::ssh_capabilities, val_list{
	        c->BuildConnVal(),
	        cookie,
	        capabilities,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr ssh2_server_host_key; 
void BifEvent::generate_ssh2_server_host_key(analyzer::Analyzer* analyzer, Connection* c, StringVal* key)
	{
	// Note that it is intentional that here we do not
	// check if ::ssh2_server_host_key is NULL, which should happen *before*
	// BifEvent::generate_ssh2_server_host_key is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::ssh2_server_host_key, val_list{
	        c->BuildConnVal(),
	        key,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr ssh1_server_host_key; 
void BifEvent::generate_ssh1_server_host_key(analyzer::Analyzer* analyzer, Connection* c, StringVal* p, StringVal* e)
	{
	// Note that it is intentional that here we do not
	// check if ::ssh1_server_host_key is NULL, which should happen *before*
	// BifEvent::generate_ssh1_server_host_key is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::ssh1_server_host_key, val_list{
	        c->BuildConnVal(),
	        p,
	        e,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr ssh_encrypted_packet; 
void BifEvent::generate_ssh_encrypted_packet(analyzer::Analyzer* analyzer, Connection* c, int orig, bro_uint_t len)
	{
	// Note that it is intentional that here we do not
	// check if ::ssh_encrypted_packet is NULL, which should happen *before*
	// BifEvent::generate_ssh_encrypted_packet is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::ssh_encrypted_packet, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(orig),
	        val_mgr->GetCount(len),
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr ssh2_dh_server_params; 
void BifEvent::generate_ssh2_dh_server_params(analyzer::Analyzer* analyzer, Connection* c, StringVal* p, StringVal* q)
	{
	// Note that it is intentional that here we do not
	// check if ::ssh2_dh_server_params is NULL, which should happen *before*
	// BifEvent::generate_ssh2_dh_server_params is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::ssh2_dh_server_params, val_list{
	        c->BuildConnVal(),
	        p,
	        q,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr ssh2_gss_error; 
void BifEvent::generate_ssh2_gss_error(analyzer::Analyzer* analyzer, Connection* c, bro_uint_t major_status, bro_uint_t minor_status, StringVal* err_msg)
	{
	// Note that it is intentional that here we do not
	// check if ::ssh2_gss_error is NULL, which should happen *before*
	// BifEvent::generate_ssh2_gss_error is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::ssh2_gss_error, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetCount(major_status),
	        val_mgr->GetCount(minor_status),
	        err_msg,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr ssh2_ecc_key; 
void BifEvent::generate_ssh2_ecc_key(analyzer::Analyzer* analyzer, Connection* c, int is_orig, StringVal* q)
	{
	// Note that it is intentional that here we do not
	// check if ::ssh2_ecc_key is NULL, which should happen *before*
	// BifEvent::generate_ssh2_ecc_key is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::ssh2_ecc_key, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        q,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
