// This file was automatically generated by bifcl from /builddir/build/BUILD/zeek-3.0.1/src/analyzer/protocol/ssl/events.bif (plugin mode).


#include "events.bif.h"

EventHandlerPtr ssl_client_hello; 
void BifEvent::generate_ssl_client_hello(analyzer::Analyzer* analyzer, Connection* c, bro_uint_t version, bro_uint_t record_version, double possible_ts, StringVal* client_random, StringVal* session_id, Val* ciphers, Val* comp_methods)
	{
	// Note that it is intentional that here we do not
	// check if ::ssl_client_hello is NULL, which should happen *before*
	// BifEvent::generate_ssl_client_hello is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::ssl_client_hello, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetCount(version),
	        val_mgr->GetCount(record_version),
	        new Val(possible_ts, TYPE_TIME),
	        client_random,
	        session_id,
	        ciphers,
	        comp_methods,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr ssl_server_hello; 
void BifEvent::generate_ssl_server_hello(analyzer::Analyzer* analyzer, Connection* c, bro_uint_t version, bro_uint_t record_version, double possible_ts, StringVal* server_random, StringVal* session_id, bro_uint_t cipher, bro_uint_t comp_method)
	{
	// Note that it is intentional that here we do not
	// check if ::ssl_server_hello is NULL, which should happen *before*
	// BifEvent::generate_ssl_server_hello is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::ssl_server_hello, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetCount(version),
	        val_mgr->GetCount(record_version),
	        new Val(possible_ts, TYPE_TIME),
	        server_random,
	        session_id,
	        val_mgr->GetCount(cipher),
	        val_mgr->GetCount(comp_method),
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr ssl_extension; 
void BifEvent::generate_ssl_extension(analyzer::Analyzer* analyzer, Connection* c, int is_orig, bro_uint_t code, StringVal* val)
	{
	// Note that it is intentional that here we do not
	// check if ::ssl_extension is NULL, which should happen *before*
	// BifEvent::generate_ssl_extension is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::ssl_extension, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        val_mgr->GetCount(code),
	        val,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr ssl_extension_elliptic_curves; 
void BifEvent::generate_ssl_extension_elliptic_curves(analyzer::Analyzer* analyzer, Connection* c, int is_orig, Val* curves)
	{
	// Note that it is intentional that here we do not
	// check if ::ssl_extension_elliptic_curves is NULL, which should happen *before*
	// BifEvent::generate_ssl_extension_elliptic_curves is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::ssl_extension_elliptic_curves, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        curves,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr ssl_extension_ec_point_formats; 
void BifEvent::generate_ssl_extension_ec_point_formats(analyzer::Analyzer* analyzer, Connection* c, int is_orig, Val* point_formats)
	{
	// Note that it is intentional that here we do not
	// check if ::ssl_extension_ec_point_formats is NULL, which should happen *before*
	// BifEvent::generate_ssl_extension_ec_point_formats is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::ssl_extension_ec_point_formats, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        point_formats,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr ssl_extension_signature_algorithm; 
void BifEvent::generate_ssl_extension_signature_algorithm(analyzer::Analyzer* analyzer, Connection* c, int is_orig, Val* signature_algorithms)
	{
	// Note that it is intentional that here we do not
	// check if ::ssl_extension_signature_algorithm is NULL, which should happen *before*
	// BifEvent::generate_ssl_extension_signature_algorithm is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::ssl_extension_signature_algorithm, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        signature_algorithms,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr ssl_extension_key_share; 
void BifEvent::generate_ssl_extension_key_share(analyzer::Analyzer* analyzer, Connection* c, int is_orig, Val* curves)
	{
	// Note that it is intentional that here we do not
	// check if ::ssl_extension_key_share is NULL, which should happen *before*
	// BifEvent::generate_ssl_extension_key_share is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::ssl_extension_key_share, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        curves,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr ssl_extension_pre_shared_key_client_hello; 
void BifEvent::generate_ssl_extension_pre_shared_key_client_hello(analyzer::Analyzer* analyzer, Connection* c, int is_orig, Val* identities, Val* binders)
	{
	// Note that it is intentional that here we do not
	// check if ::ssl_extension_pre_shared_key_client_hello is NULL, which should happen *before*
	// BifEvent::generate_ssl_extension_pre_shared_key_client_hello is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::ssl_extension_pre_shared_key_client_hello, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        identities,
	        binders,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr ssl_extension_pre_shared_key_server_hello; 
void BifEvent::generate_ssl_extension_pre_shared_key_server_hello(analyzer::Analyzer* analyzer, Connection* c, int is_orig, bro_uint_t selected_identity)
	{
	// Note that it is intentional that here we do not
	// check if ::ssl_extension_pre_shared_key_server_hello is NULL, which should happen *before*
	// BifEvent::generate_ssl_extension_pre_shared_key_server_hello is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::ssl_extension_pre_shared_key_server_hello, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        val_mgr->GetCount(selected_identity),
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr ssl_ecdh_server_params; 
void BifEvent::generate_ssl_ecdh_server_params(analyzer::Analyzer* analyzer, Connection* c, bro_uint_t curve, StringVal* point)
	{
	// Note that it is intentional that here we do not
	// check if ::ssl_ecdh_server_params is NULL, which should happen *before*
	// BifEvent::generate_ssl_ecdh_server_params is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::ssl_ecdh_server_params, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetCount(curve),
	        point,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr ssl_dh_server_params; 
void BifEvent::generate_ssl_dh_server_params(analyzer::Analyzer* analyzer, Connection* c, StringVal* p, StringVal* q, StringVal* Ys)
	{
	// Note that it is intentional that here we do not
	// check if ::ssl_dh_server_params is NULL, which should happen *before*
	// BifEvent::generate_ssl_dh_server_params is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::ssl_dh_server_params, val_list{
	        c->BuildConnVal(),
	        p,
	        q,
	        Ys,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr ssl_server_signature; 
void BifEvent::generate_ssl_server_signature(analyzer::Analyzer* analyzer, Connection* c, Val* signature_and_hashalgorithm, StringVal* signature)
	{
	// Note that it is intentional that here we do not
	// check if ::ssl_server_signature is NULL, which should happen *before*
	// BifEvent::generate_ssl_server_signature is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::ssl_server_signature, val_list{
	        c->BuildConnVal(),
	        signature_and_hashalgorithm,
	        signature,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr ssl_ecdh_client_params; 
void BifEvent::generate_ssl_ecdh_client_params(analyzer::Analyzer* analyzer, Connection* c, StringVal* point)
	{
	// Note that it is intentional that here we do not
	// check if ::ssl_ecdh_client_params is NULL, which should happen *before*
	// BifEvent::generate_ssl_ecdh_client_params is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::ssl_ecdh_client_params, val_list{
	        c->BuildConnVal(),
	        point,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr ssl_dh_client_params; 
void BifEvent::generate_ssl_dh_client_params(analyzer::Analyzer* analyzer, Connection* c, StringVal* Yc)
	{
	// Note that it is intentional that here we do not
	// check if ::ssl_dh_client_params is NULL, which should happen *before*
	// BifEvent::generate_ssl_dh_client_params is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::ssl_dh_client_params, val_list{
	        c->BuildConnVal(),
	        Yc,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr ssl_rsa_client_pms; 
void BifEvent::generate_ssl_rsa_client_pms(analyzer::Analyzer* analyzer, Connection* c, StringVal* pms)
	{
	// Note that it is intentional that here we do not
	// check if ::ssl_rsa_client_pms is NULL, which should happen *before*
	// BifEvent::generate_ssl_rsa_client_pms is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::ssl_rsa_client_pms, val_list{
	        c->BuildConnVal(),
	        pms,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr ssl_extension_application_layer_protocol_negotiation; 
void BifEvent::generate_ssl_extension_application_layer_protocol_negotiation(analyzer::Analyzer* analyzer, Connection* c, int is_orig, Val* protocols)
	{
	// Note that it is intentional that here we do not
	// check if ::ssl_extension_application_layer_protocol_negotiation is NULL, which should happen *before*
	// BifEvent::generate_ssl_extension_application_layer_protocol_negotiation is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::ssl_extension_application_layer_protocol_negotiation, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        protocols,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr ssl_extension_server_name; 
void BifEvent::generate_ssl_extension_server_name(analyzer::Analyzer* analyzer, Connection* c, int is_orig, Val* names)
	{
	// Note that it is intentional that here we do not
	// check if ::ssl_extension_server_name is NULL, which should happen *before*
	// BifEvent::generate_ssl_extension_server_name is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::ssl_extension_server_name, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        names,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr ssl_extension_signed_certificate_timestamp; 
void BifEvent::generate_ssl_extension_signed_certificate_timestamp(analyzer::Analyzer* analyzer, Connection* c, int is_orig, bro_uint_t version, StringVal* logid, bro_uint_t timestamp, Val* signature_and_hashalgorithm, StringVal* signature)
	{
	// Note that it is intentional that here we do not
	// check if ::ssl_extension_signed_certificate_timestamp is NULL, which should happen *before*
	// BifEvent::generate_ssl_extension_signed_certificate_timestamp is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::ssl_extension_signed_certificate_timestamp, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        val_mgr->GetCount(version),
	        logid,
	        val_mgr->GetCount(timestamp),
	        signature_and_hashalgorithm,
	        signature,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr ssl_extension_supported_versions; 
void BifEvent::generate_ssl_extension_supported_versions(analyzer::Analyzer* analyzer, Connection* c, int is_orig, Val* versions)
	{
	// Note that it is intentional that here we do not
	// check if ::ssl_extension_supported_versions is NULL, which should happen *before*
	// BifEvent::generate_ssl_extension_supported_versions is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::ssl_extension_supported_versions, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        versions,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr ssl_extension_psk_key_exchange_modes; 
void BifEvent::generate_ssl_extension_psk_key_exchange_modes(analyzer::Analyzer* analyzer, Connection* c, int is_orig, Val* modes)
	{
	// Note that it is intentional that here we do not
	// check if ::ssl_extension_psk_key_exchange_modes is NULL, which should happen *before*
	// BifEvent::generate_ssl_extension_psk_key_exchange_modes is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::ssl_extension_psk_key_exchange_modes, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        modes,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr ssl_established; 
void BifEvent::generate_ssl_established(analyzer::Analyzer* analyzer, Connection* c)
	{
	// Note that it is intentional that here we do not
	// check if ::ssl_established is NULL, which should happen *before*
	// BifEvent::generate_ssl_established is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::ssl_established, val_list{
	        c->BuildConnVal(),
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr ssl_alert; 
void BifEvent::generate_ssl_alert(analyzer::Analyzer* analyzer, Connection* c, int is_orig, bro_uint_t level, bro_uint_t desc)
	{
	// Note that it is intentional that here we do not
	// check if ::ssl_alert is NULL, which should happen *before*
	// BifEvent::generate_ssl_alert is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::ssl_alert, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        val_mgr->GetCount(level),
	        val_mgr->GetCount(desc),
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr ssl_session_ticket_handshake; 
void BifEvent::generate_ssl_session_ticket_handshake(analyzer::Analyzer* analyzer, Connection* c, bro_uint_t ticket_lifetime_hint, StringVal* ticket)
	{
	// Note that it is intentional that here we do not
	// check if ::ssl_session_ticket_handshake is NULL, which should happen *before*
	// BifEvent::generate_ssl_session_ticket_handshake is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::ssl_session_ticket_handshake, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetCount(ticket_lifetime_hint),
	        ticket,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr ssl_heartbeat; 
void BifEvent::generate_ssl_heartbeat(analyzer::Analyzer* analyzer, Connection* c, int is_orig, bro_uint_t length, bro_uint_t heartbeat_type, bro_uint_t payload_length, StringVal* payload)
	{
	// Note that it is intentional that here we do not
	// check if ::ssl_heartbeat is NULL, which should happen *before*
	// BifEvent::generate_ssl_heartbeat is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::ssl_heartbeat, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        val_mgr->GetCount(length),
	        val_mgr->GetCount(heartbeat_type),
	        val_mgr->GetCount(payload_length),
	        payload,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr ssl_plaintext_data; 
void BifEvent::generate_ssl_plaintext_data(analyzer::Analyzer* analyzer, Connection* c, int is_orig, bro_uint_t record_version, bro_uint_t content_type, bro_uint_t length)
	{
	// Note that it is intentional that here we do not
	// check if ::ssl_plaintext_data is NULL, which should happen *before*
	// BifEvent::generate_ssl_plaintext_data is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::ssl_plaintext_data, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        val_mgr->GetCount(record_version),
	        val_mgr->GetCount(content_type),
	        val_mgr->GetCount(length),
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr ssl_encrypted_data; 
void BifEvent::generate_ssl_encrypted_data(analyzer::Analyzer* analyzer, Connection* c, int is_orig, bro_uint_t record_version, bro_uint_t content_type, bro_uint_t length)
	{
	// Note that it is intentional that here we do not
	// check if ::ssl_encrypted_data is NULL, which should happen *before*
	// BifEvent::generate_ssl_encrypted_data is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::ssl_encrypted_data, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        val_mgr->GetCount(record_version),
	        val_mgr->GetCount(content_type),
	        val_mgr->GetCount(length),
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr ssl_stapled_ocsp; 
void BifEvent::generate_ssl_stapled_ocsp(analyzer::Analyzer* analyzer, Connection* c, int is_orig, StringVal* response)
	{
	// Note that it is intentional that here we do not
	// check if ::ssl_stapled_ocsp is NULL, which should happen *before*
	// BifEvent::generate_ssl_stapled_ocsp is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::ssl_stapled_ocsp, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        response,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr ssl_handshake_message; 
void BifEvent::generate_ssl_handshake_message(analyzer::Analyzer* analyzer, Connection* c, int is_orig, bro_uint_t msg_type, bro_uint_t length)
	{
	// Note that it is intentional that here we do not
	// check if ::ssl_handshake_message is NULL, which should happen *before*
	// BifEvent::generate_ssl_handshake_message is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::ssl_handshake_message, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        val_mgr->GetCount(msg_type),
	        val_mgr->GetCount(length),
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
EventHandlerPtr ssl_change_cipher_spec; 
void BifEvent::generate_ssl_change_cipher_spec(analyzer::Analyzer* analyzer, Connection* c, int is_orig)
	{
	// Note that it is intentional that here we do not
	// check if ::ssl_change_cipher_spec is NULL, which should happen *before*
	// BifEvent::generate_ssl_change_cipher_spec is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::ssl_change_cipher_spec, val_list{
	        c->BuildConnVal(),
	        val_mgr->GetBool(is_orig),
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr, c);
	} // event generation
