// This file was automatically generated by bifcl from /builddir/build/BUILD/zeek-3.0.1/src/file_analysis/analyzer/x509/ocsp_events.bif (plugin mode).


#include "ocsp_events.bif.h"

EventHandlerPtr ocsp_request; 
void BifEvent::generate_ocsp_request(analyzer::Analyzer* analyzer, Val* f, bro_uint_t version)
	{
	// Note that it is intentional that here we do not
	// check if ::ocsp_request is NULL, which should happen *before*
	// BifEvent::generate_ocsp_request is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::ocsp_request, val_list{
	        f,
	        val_mgr->GetCount(version),
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr);
	} // event generation
EventHandlerPtr ocsp_request_certificate; 
void BifEvent::generate_ocsp_request_certificate(analyzer::Analyzer* analyzer, Val* f, StringVal* hashAlgorithm, StringVal* issuerNameHash, StringVal* issuerKeyHash, StringVal* serialNumber)
	{
	// Note that it is intentional that here we do not
	// check if ::ocsp_request_certificate is NULL, which should happen *before*
	// BifEvent::generate_ocsp_request_certificate is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::ocsp_request_certificate, val_list{
	        f,
	        hashAlgorithm,
	        issuerNameHash,
	        issuerKeyHash,
	        serialNumber,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr);
	} // event generation
EventHandlerPtr ocsp_response_status; 
void BifEvent::generate_ocsp_response_status(analyzer::Analyzer* analyzer, Val* f, StringVal* status)
	{
	// Note that it is intentional that here we do not
	// check if ::ocsp_response_status is NULL, which should happen *before*
	// BifEvent::generate_ocsp_response_status is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::ocsp_response_status, val_list{
	        f,
	        status,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr);
	} // event generation
EventHandlerPtr ocsp_response_bytes; 
void BifEvent::generate_ocsp_response_bytes(analyzer::Analyzer* analyzer, Val* f, StringVal* status, bro_uint_t version, StringVal* responderId, double producedAt, StringVal* signatureAlgorithm, Val* certs)
	{
	// Note that it is intentional that here we do not
	// check if ::ocsp_response_bytes is NULL, which should happen *before*
	// BifEvent::generate_ocsp_response_bytes is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::ocsp_response_bytes, val_list{
	        f,
	        status,
	        val_mgr->GetCount(version),
	        responderId,
	        new Val(producedAt, TYPE_TIME),
	        signatureAlgorithm,
	        certs,
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr);
	} // event generation
EventHandlerPtr ocsp_response_certificate; 
void BifEvent::generate_ocsp_response_certificate(analyzer::Analyzer* analyzer, Val* f, StringVal* hashAlgorithm, StringVal* issuerNameHash, StringVal* issuerKeyHash, StringVal* serialNumber, StringVal* certStatus, double revokeTime, StringVal* revokeReason, double thisUpdate, double nextUpdate)
	{
	// Note that it is intentional that here we do not
	// check if ::ocsp_response_certificate is NULL, which should happen *before*
	// BifEvent::generate_ocsp_response_certificate is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::ocsp_response_certificate, val_list{
	        f,
	        hashAlgorithm,
	        issuerNameHash,
	        issuerKeyHash,
	        serialNumber,
	        certStatus,
	        new Val(revokeTime, TYPE_TIME),
	        revokeReason,
	        new Val(thisUpdate, TYPE_TIME),
	        new Val(nextUpdate, TYPE_TIME),
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr);
	} // event generation
EventHandlerPtr ocsp_extension; 
void BifEvent::generate_ocsp_extension(analyzer::Analyzer* analyzer, Val* f, Val* ext, int global_resp)
	{
	// Note that it is intentional that here we do not
	// check if ::ocsp_extension is NULL, which should happen *before*
	// BifEvent::generate_ocsp_extension is called to avoid unnecessary Val
	// allocation.

	mgr.QueueEventFast(::ocsp_extension, val_list{
	        f,
	        ext,
	        val_mgr->GetBool(global_resp),
	        },
	    SOURCE_LOCAL, analyzer->GetID(), timer_mgr);
	} // event generation
