/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 1 "rule-parse.y" /* yacc.c:339  */

#include <stdio.h>
#include <netinet/in.h>
#include <vector>
#include "zeek-config.h"
#include "RuleMatcher.h"
#include "Reporter.h"
#include "IPAddr.h"
#include "net_util.h"

extern void begin_PS();
extern void end_PS();

Rule* current_rule = 0;
const char* current_rule_file = 0;

static uint8_t ip4_mask_to_len(uint32_t mask)
	{
	if ( mask == 0xffffffff )
	    return 32;

	uint32_t x = ~mask + 1;
	uint8_t len;
	for ( len = 0; len < 32 && (! (x & (1 << len))); ++len );

	return 32 - len;
	}

#line 95 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "rup.h".  */
#ifndef YY_YY_BUILDDIR_BUILD_BUILD_ZEEK_3_0_1_BUILD_SRC_RUP_H_INCLUDED
# define YY_YY_BUILDDIR_BUILD_BUILD_ZEEK_3_0_1_BUILD_SRC_RUP_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    TOK_COMP = 258,
    TOK_DISABLE = 259,
    TOK_DST_IP = 260,
    TOK_DST_PORT = 261,
    TOK_ENABLE = 262,
    TOK_EVAL = 263,
    TOK_EVENT = 264,
    TOK_MIME = 265,
    TOK_HEADER = 266,
    TOK_IDENT = 267,
    TOK_INT = 268,
    TOK_IP = 269,
    TOK_IP6 = 270,
    TOK_IP_OPTIONS = 271,
    TOK_IP_OPTION_SYM = 272,
    TOK_IP_PROTO = 273,
    TOK_PATTERN = 274,
    TOK_PATTERN_TYPE = 275,
    TOK_PAYLOAD_SIZE = 276,
    TOK_PROT = 277,
    TOK_REQUIRES_SIGNATURE = 278,
    TOK_REQUIRES_REVERSE_SIGNATURE = 279,
    TOK_SIGNATURE = 280,
    TOK_SAME_IP = 281,
    TOK_SRC_IP = 282,
    TOK_SRC_PORT = 283,
    TOK_TCP_STATE = 284,
    TOK_STRING = 285,
    TOK_TCP_STATE_SYM = 286,
    TOK_ACTIVE = 287,
    TOK_BOOL = 288,
    TOK_POLICY_SYMBOL = 289
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 78 "rule-parse.y" /* yacc.c:355  */

	Rule* rule;
	RuleHdrTest* hdr_test;
	maskedvalue_list* vallist;
	vector<IPPrefix>* prefix_val_list;
	IPPrefix* prefixval;

	bool bl;
	int val;
	char* str;
	MaskedValue mval;
	RuleHdrTest::Prot prot;
	Range range;
	Rule::PatternType ptype;

#line 186 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_BUILDDIR_BUILD_BUILD_ZEEK_3_0_1_BUILD_SRC_RUP_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 203 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   108

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  44
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  23
/* YYNRULES -- Number of rules.  */
#define YYNRULES  68
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  119

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   289

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    39,     2,     2,     2,     2,    40,     2,
       2,     2,     2,     2,    41,    42,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    43,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    37,     2,    38,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    35,     2,    36,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,    97,    97,    99,   104,   103,   113,   114,   118,   125,
     132,   132,   132,   137,   140,   146,   179,   188,   191,   194,
     197,   200,   203,   210,   216,   219,   222,   225,   228,   231,
     238,   245,   250,   255,   268,   276,   278,   288,   290,   295,
     299,   307,   312,   317,   322,   330,   335,   339,   353,   355,
     359,   361,   363,   368,   370,   375,   377,   382,   384,   389,
     391,   396,   399,   403,   406,   410,   412,   417,   419
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "TOK_COMP", "TOK_DISABLE", "TOK_DST_IP",
  "TOK_DST_PORT", "TOK_ENABLE", "TOK_EVAL", "TOK_EVENT", "TOK_MIME",
  "TOK_HEADER", "TOK_IDENT", "TOK_INT", "TOK_IP", "TOK_IP6",
  "TOK_IP_OPTIONS", "TOK_IP_OPTION_SYM", "TOK_IP_PROTO", "TOK_PATTERN",
  "TOK_PATTERN_TYPE", "TOK_PAYLOAD_SIZE", "TOK_PROT",
  "TOK_REQUIRES_SIGNATURE", "TOK_REQUIRES_REVERSE_SIGNATURE",
  "TOK_SIGNATURE", "TOK_SAME_IP", "TOK_SRC_IP", "TOK_SRC_PORT",
  "TOK_TCP_STATE", "TOK_STRING", "TOK_TCP_STATE_SYM", "TOK_ACTIVE",
  "TOK_BOOL", "TOK_POLICY_SYMBOL", "'{'", "'}'", "'['", "']'", "'!'",
  "'&'", "','", "'-'", "':'", "$accept", "rule_list", "rule", "$@1",
  "rule_attr_list", "rule_attr", "$@2", "$@3", "hdr_expr", "value_list",
  "prefix_value_list", "prefix_value", "ranged_value", "value", "rangeopt",
  "range", "ipoption_list", "tcpstate_list", "integer", "opt_negate",
  "opt_strength", "string", "pattern", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   123,   125,    91,    93,    33,
      38,    44,    45,    58
};
# endif

#define YYPACT_NINF -87

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-87)))

#define YYTABLE_NINF -1

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int8 yypact[] =
{
     -87,    25,   -87,    -6,   -87,   -87,   -15,   -87,     8,    17,
      52,    56,    43,   -87,    -7,    -7,    54,    57,    72,    33,
      74,     9,    10,   -87,    75,    76,    49,    48,   -87,   -87,
     -87,    42,    50,   -87,    51,   -87,   -87,   -87,    41,    47,
     -87,   -87,    45,    29,   -87,   -87,    -5,   -87,    -3,   -87,
      71,   -87,    77,    42,    50,   -87,    55,   -87,   -87,   -87,
     -87,    59,   -87,   -87,    60,   -87,    62,   -87,   -87,   -87,
      63,   -87,    -3,    70,   -87,    62,   -87,   -87,    -3,    61,
     -87,    64,   -87,   -87,   -87,    59,    62,    66,    46,    78,
      53,   -87,   -87,    79,    68,    65,   -87,   -87,    34,    -3,
     -87,   -87,   -87,   -87,   -87,   -87,   -87,   -87,    -1,    -3,
     -87,   -87,    50,    -3,    62,    85,    58,   -87,   -87
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       3,     0,     1,     0,     2,     4,     0,     7,     0,     0,
       0,     0,     0,    10,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    28,     0,     0,     0,     0,     5,     6,
      20,     0,     0,    19,     0,    66,    65,    17,    64,     0,
      13,    56,    14,     0,    68,    67,     0,    21,     0,    24,
       0,    26,     0,     0,     0,    58,    31,    32,    44,    45,
      46,     8,    43,    40,    48,    49,     9,    39,    38,    11,
      62,    18,     0,     0,    15,    16,    60,    59,     0,     0,
      50,    53,    23,    25,    27,    29,    30,     0,     0,     0,
       0,    12,    61,     0,     0,    53,    55,    51,     0,    52,
      57,    42,    41,    47,    37,    36,    35,    63,     0,     0,
      22,    54,     0,     0,    34,     0,     0,    48,    33
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -87,   -87,   -87,   -87,   -87,   -87,   -87,   -87,   -87,   -43,
      37,     5,     4,   -86,   -87,    23,   -87,   -87,   -45,   -87,
     -87,    83,     3
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
      -1,     1,     4,     6,     8,    29,    34,    91,    40,    66,
      61,    62,    67,    68,    79,    80,    42,    56,   111,    93,
      71,    37,    47
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_uint8 yytable[] =
{
      75,    81,   112,    82,   106,    35,     5,    76,    77,    76,
      77,    86,     9,    10,    11,    12,    13,    14,    15,    16,
       7,    49,    51,    36,    17,     2,    18,    95,    19,    20,
     118,    21,    22,    97,    23,    24,    25,    26,    78,   113,
      27,    63,    64,    65,    28,    44,    44,    30,    50,    52,
       3,    74,    45,    45,    58,    31,    59,    60,   101,    32,
      59,    60,    63,    64,    65,   104,    64,    65,   115,   114,
      46,   117,    65,    33,    41,    43,    39,    48,    53,    54,
      55,    57,    70,    83,    72,    69,    73,    96,   116,    84,
      85,   103,   107,   102,   105,    94,    87,   100,    38,    98,
      88,   110,    89,    90,     0,    92,   108,    99,   109
};

static const yytype_int8 yycheck[] =
{
      43,    46,     3,    48,    90,    12,    12,    12,    13,    12,
      13,    54,     4,     5,     6,     7,     8,     9,    10,    11,
      35,    12,    12,    30,    16,     0,    18,    72,    20,    21,
     116,    23,    24,    78,    26,    27,    28,    29,    43,    40,
      32,    12,    13,    14,    36,    12,    12,    30,    39,    39,
      25,    22,    19,    19,    12,     3,    14,    15,    12,     3,
      14,    15,    12,    13,    14,    12,    13,    14,   113,   112,
      37,    13,    14,    30,    17,     3,    22,     3,     3,     3,
      31,    33,    41,    12,    37,    34,    41,    17,     3,    12,
      53,    13,    13,    88,    90,    72,    41,    31,    15,    38,
      41,    98,    42,    41,    -1,    42,    38,    43,    43
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    45,     0,    25,    46,    12,    47,    35,    48,     4,
       5,     6,     7,     8,     9,    10,    11,    16,    18,    20,
      21,    23,    24,    26,    27,    28,    29,    32,    36,    49,
      30,     3,     3,    30,    50,    12,    30,    65,    65,    22,
      52,    17,    60,     3,    12,    19,    37,    66,     3,    12,
      39,    12,    39,     3,     3,    31,    61,    33,    12,    14,
      15,    54,    55,    12,    13,    14,    53,    56,    57,    34,
      41,    64,    37,    41,    22,    53,    12,    13,    43,    58,
      59,    62,    62,    12,    12,    54,    53,    41,    41,    42,
      41,    51,    42,    63,    59,    62,    17,    62,    38,    43,
      31,    12,    55,    13,    12,    56,    57,    13,    38,    43,
      66,    62,     3,    40,    53,    62,     3,    13,    57
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    44,    45,    45,    47,    46,    48,    48,    49,    49,
      50,    51,    49,    49,    49,    49,    49,    49,    49,    49,
      49,    49,    49,    49,    49,    49,    49,    49,    49,    49,
      49,    49,    49,    52,    52,    53,    53,    53,    53,    53,
      53,    54,    54,    54,    54,    55,    55,    56,    57,    57,
      58,    58,    58,    59,    59,    60,    60,    61,    61,    62,
      62,    63,    63,    64,    64,    65,    65,    66,    66
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     0,     0,     6,     2,     0,     3,     3,
       0,     0,     4,     2,     2,     3,     3,     2,     3,     2,
       2,     2,     5,     3,     2,     3,     2,     3,     1,     3,
       3,     2,     2,     8,     6,     3,     3,     3,     1,     1,
       1,     3,     3,     1,     1,     1,     1,     3,     1,     1,
       1,     2,     2,     1,     3,     3,     1,     3,     1,     1,
       1,     1,     0,     3,     0,     1,     1,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 98 "rule-parse.y" /* yacc.c:1646  */
    { rule_matcher->AddRule((yyvsp[0].rule)); }
#line 1362 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 4:
#line 104 "rule-parse.y" /* yacc.c:1646  */
    {
			Location l(current_rule_file, rules_line_number+1, 0, 0, 0);
			current_rule = new Rule(yylval.str, l);
			}
#line 1371 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 5:
#line 109 "rule-parse.y" /* yacc.c:1646  */
    { (yyval.rule) = current_rule; }
#line 1377 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 8:
#line 119 "rule-parse.y" /* yacc.c:1646  */
    {
			current_rule->AddHdrTest(new RuleHdrTest(
				RuleHdrTest::IPDst,
				(RuleHdrTest::Comp) (yyvsp[-1].val), *((yyvsp[0].prefix_val_list))));
			}
#line 1387 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 9:
#line 126 "rule-parse.y" /* yacc.c:1646  */
    { // Works for both TCP and UDP
			current_rule->AddHdrTest(new RuleHdrTest(
				RuleHdrTest::TCP, 2, 2,
				(RuleHdrTest::Comp) (yyvsp[-1].val), (yyvsp[0].vallist)));
			}
#line 1397 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 10:
#line 132 "rule-parse.y" /* yacc.c:1646  */
    { begin_PS(); }
#line 1403 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 11:
#line 132 "rule-parse.y" /* yacc.c:1646  */
    { end_PS(); }
#line 1409 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 12:
#line 133 "rule-parse.y" /* yacc.c:1646  */
    {
			current_rule->AddCondition(new RuleConditionEval((yyvsp[-1].str)));
			}
#line 1417 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 13:
#line 138 "rule-parse.y" /* yacc.c:1646  */
    { current_rule->AddHdrTest((yyvsp[0].hdr_test)); }
#line 1423 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 14:
#line 141 "rule-parse.y" /* yacc.c:1646  */
    {
			current_rule->AddCondition(
				new RuleConditionIPOptions((yyvsp[0].val)));
			}
#line 1432 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 15:
#line 147 "rule-parse.y" /* yacc.c:1646  */
    {
			int proto = 0;
			switch ( (yyvsp[0].prot) ) {
			case RuleHdrTest::ICMP: proto = IPPROTO_ICMP; break;
			case RuleHdrTest::ICMPv6: proto = IPPROTO_ICMPV6; break;
			// signature matching against outer packet headers of IP-in-IP
			// tunneling not supported, so do a no-op there
			case RuleHdrTest::IP: proto = 0; break;
			case RuleHdrTest::IPv6: proto = 0; break;
			case RuleHdrTest::TCP: proto = IPPROTO_TCP; break;
			case RuleHdrTest::UDP: proto = IPPROTO_UDP; break;
			default:
				rules_error("internal_error: unknown protocol");
			}

			if ( proto )
				{
				maskedvalue_list* vallist = new maskedvalue_list;
				MaskedValue* val = new MaskedValue();

				val->val = proto;
				val->mask = 0xffffffff;
				vallist->push_back(val);

				// offset & size params are dummies, actual next proto value in
				// header is retrieved dynamically via IP_Hdr::NextProto()
				current_rule->AddHdrTest(new RuleHdrTest(
					RuleHdrTest::NEXT, 0, 0,
					(RuleHdrTest::Comp) (yyvsp[-1].val), vallist));
				}
			}
#line 1468 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 16:
#line 180 "rule-parse.y" /* yacc.c:1646  */
    {
			// offset & size params are dummies, actual next proto value in
			// header is retrieved dynamically via IP_Hdr::NextProto()
			current_rule->AddHdrTest(new RuleHdrTest(
				RuleHdrTest::NEXT, 0, 0,
				(RuleHdrTest::Comp) (yyvsp[-1].val), (yyvsp[0].vallist)));
			}
#line 1480 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 17:
#line 189 "rule-parse.y" /* yacc.c:1646  */
    { current_rule->AddAction(new RuleActionEvent((yyvsp[0].str))); }
#line 1486 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 18:
#line 192 "rule-parse.y" /* yacc.c:1646  */
    { current_rule->AddAction(new RuleActionMIME((yyvsp[-1].str), (yyvsp[0].val))); }
#line 1492 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 19:
#line 195 "rule-parse.y" /* yacc.c:1646  */
    { current_rule->AddAction(new RuleActionEnable((yyvsp[0].str))); }
#line 1498 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 20:
#line 198 "rule-parse.y" /* yacc.c:1646  */
    { current_rule->AddAction(new RuleActionDisable((yyvsp[0].str))); }
#line 1504 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 21:
#line 201 "rule-parse.y" /* yacc.c:1646  */
    { current_rule->AddPattern((yyvsp[0].str), (yyvsp[-1].ptype)); }
#line 1510 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 22:
#line 204 "rule-parse.y" /* yacc.c:1646  */
    {
			if ( (yyvsp[-2].range).offset > 0 )
				reporter->Warning("Offsets are currently ignored for patterns");
			current_rule->AddPattern((yyvsp[0].str), (yyvsp[-4].ptype), 0, (yyvsp[-2].range).len);
			}
#line 1520 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 23:
#line 211 "rule-parse.y" /* yacc.c:1646  */
    {
			current_rule->AddCondition(
				new RuleConditionPayloadSize((yyvsp[0].val), (RuleConditionPayloadSize::Comp) ((yyvsp[-1].val))));
			}
#line 1529 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 24:
#line 217 "rule-parse.y" /* yacc.c:1646  */
    { current_rule->AddRequires((yyvsp[0].str), 0, 0); }
#line 1535 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 25:
#line 220 "rule-parse.y" /* yacc.c:1646  */
    { current_rule->AddRequires((yyvsp[0].str), 0, 1); }
#line 1541 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 26:
#line 223 "rule-parse.y" /* yacc.c:1646  */
    { current_rule->AddRequires((yyvsp[0].str), 1, 0); }
#line 1547 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 27:
#line 226 "rule-parse.y" /* yacc.c:1646  */
    { current_rule->AddRequires((yyvsp[0].str), 1, 1); }
#line 1553 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 28:
#line 229 "rule-parse.y" /* yacc.c:1646  */
    { current_rule->AddCondition(new RuleConditionSameIP()); }
#line 1559 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 29:
#line 232 "rule-parse.y" /* yacc.c:1646  */
    {
			current_rule->AddHdrTest(new RuleHdrTest(
				RuleHdrTest::IPSrc,
				(RuleHdrTest::Comp) (yyvsp[-1].val), *((yyvsp[0].prefix_val_list))));
			}
#line 1569 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 30:
#line 239 "rule-parse.y" /* yacc.c:1646  */
    { // Works for both TCP and UDP
			current_rule->AddHdrTest(new RuleHdrTest(
				RuleHdrTest::TCP, 0, 2,
				(RuleHdrTest::Comp) (yyvsp[-1].val), (yyvsp[0].vallist)));
			}
#line 1579 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 31:
#line 246 "rule-parse.y" /* yacc.c:1646  */
    {
			current_rule->AddCondition(new RuleConditionTCPState((yyvsp[0].val)));
			}
#line 1587 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 32:
#line 251 "rule-parse.y" /* yacc.c:1646  */
    { current_rule->SetActiveStatus((yyvsp[0].bl)); }
#line 1593 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 33:
#line 256 "rule-parse.y" /* yacc.c:1646  */
    {
			maskedvalue_list* vallist = new maskedvalue_list;
			MaskedValue* val = new MaskedValue();

			val->val = (yyvsp[0].mval).val;
			val->mask = (yyvsp[-2].val);
			vallist->push_back(val);

			(yyval.hdr_test) = new RuleHdrTest((yyvsp[-7].prot), (yyvsp[-5].range).offset, (yyvsp[-5].range).len,
					(RuleHdrTest::Comp) (yyvsp[-1].val), vallist);
			}
#line 1609 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 34:
#line 269 "rule-parse.y" /* yacc.c:1646  */
    {
			(yyval.hdr_test) = new RuleHdrTest((yyvsp[-5].prot), (yyvsp[-3].range).offset, (yyvsp[-3].range).len,
						(RuleHdrTest::Comp) (yyvsp[-1].val), (yyvsp[0].vallist));
			}
#line 1618 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 35:
#line 277 "rule-parse.y" /* yacc.c:1646  */
    { (yyvsp[-2].vallist)->push_back(new MaskedValue((yyvsp[0].mval))); (yyval.vallist) = (yyvsp[-2].vallist); }
#line 1624 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 36:
#line 279 "rule-parse.y" /* yacc.c:1646  */
    {
			int numVals = (yyvsp[0].vallist)->length();
			for ( int idx = 0; idx < numVals; idx++ )
				{
				MaskedValue* val = (*(yyvsp[0].vallist))[idx];
				(yyvsp[-2].vallist)->push_back(val);
				}
			(yyval.vallist) = (yyvsp[-2].vallist);
			}
#line 1638 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 37:
#line 289 "rule-parse.y" /* yacc.c:1646  */
    { id_to_maskedvallist((yyvsp[0].str), (yyvsp[-2].vallist)); (yyval.vallist) = (yyvsp[-2].vallist); }
#line 1644 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 38:
#line 291 "rule-parse.y" /* yacc.c:1646  */
    {
			(yyval.vallist) = new maskedvalue_list();
			(yyval.vallist)->push_back(new MaskedValue((yyvsp[0].mval)));
			}
#line 1653 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 39:
#line 296 "rule-parse.y" /* yacc.c:1646  */
    {
			(yyval.vallist) = (yyvsp[0].vallist);
			}
#line 1661 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 40:
#line 300 "rule-parse.y" /* yacc.c:1646  */
    {
			(yyval.vallist) = new maskedvalue_list();
			id_to_maskedvallist((yyvsp[0].str), (yyval.vallist));
			}
#line 1670 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 41:
#line 308 "rule-parse.y" /* yacc.c:1646  */
    {
			(yyval.prefix_val_list) = (yyvsp[-2].prefix_val_list);
			(yyval.prefix_val_list)->push_back(*((yyvsp[0].prefixval)));
			}
#line 1679 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 42:
#line 313 "rule-parse.y" /* yacc.c:1646  */
    {
			(yyval.prefix_val_list) = (yyvsp[-2].prefix_val_list);
			id_to_maskedvallist((yyvsp[0].str), 0, (yyvsp[-2].prefix_val_list));
			}
#line 1688 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 43:
#line 318 "rule-parse.y" /* yacc.c:1646  */
    {
			(yyval.prefix_val_list) = new vector<IPPrefix>();
			(yyval.prefix_val_list)->push_back(*((yyvsp[0].prefixval)));
			}
#line 1697 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 44:
#line 323 "rule-parse.y" /* yacc.c:1646  */
    {
			(yyval.prefix_val_list) = new vector<IPPrefix>();
			id_to_maskedvallist((yyvsp[0].str), 0, (yyval.prefix_val_list));
			}
#line 1706 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 45:
#line 331 "rule-parse.y" /* yacc.c:1646  */
    {
			(yyval.prefixval) = new IPPrefix(IPAddr(IPv4, &((yyvsp[0].mval).val), IPAddr::Host),
			                  ip4_mask_to_len((yyvsp[0].mval).mask));
			}
#line 1715 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 47:
#line 340 "rule-parse.y" /* yacc.c:1646  */
    {
			(yyval.vallist) = new maskedvalue_list();
			for ( int val = (yyvsp[-2].val); val <= (yyvsp[0].val); val++ )
				{
				MaskedValue* masked = new MaskedValue();
				masked->val = val;
				masked->mask = 0xffffffff;
				(yyval.vallist)->push_back(masked);
				}
			}
#line 1730 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 48:
#line 354 "rule-parse.y" /* yacc.c:1646  */
    { (yyval.mval).val = (yyvsp[0].val); (yyval.mval).mask = 0xffffffff; }
#line 1736 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 50:
#line 360 "rule-parse.y" /* yacc.c:1646  */
    { (yyval.range) = (yyvsp[0].range); }
#line 1742 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 51:
#line 362 "rule-parse.y" /* yacc.c:1646  */
    { (yyval.range).offset = 0; (yyval.range).len = (yyvsp[0].val); }
#line 1748 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 52:
#line 364 "rule-parse.y" /* yacc.c:1646  */
    { (yyval.range).offset = (yyvsp[-1].val); (yyval.range).len = UINT_MAX; }
#line 1754 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 53:
#line 369 "rule-parse.y" /* yacc.c:1646  */
    { (yyval.range).offset = (yyvsp[0].val); (yyval.range).len = 1; }
#line 1760 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 54:
#line 371 "rule-parse.y" /* yacc.c:1646  */
    { (yyval.range).offset = (yyvsp[-2].val); (yyval.range).len = (yyvsp[0].val); }
#line 1766 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 55:
#line 376 "rule-parse.y" /* yacc.c:1646  */
    { (yyval.val) = (yyvsp[-2].val) | (yyvsp[0].val); }
#line 1772 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 56:
#line 378 "rule-parse.y" /* yacc.c:1646  */
    { (yyval.val) = (yyvsp[0].val); }
#line 1778 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 57:
#line 383 "rule-parse.y" /* yacc.c:1646  */
    { (yyval.val) = (yyvsp[-2].val) | (yyvsp[0].val); }
#line 1784 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 58:
#line 385 "rule-parse.y" /* yacc.c:1646  */
    { (yyval.val) = (yyvsp[0].val); }
#line 1790 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 59:
#line 390 "rule-parse.y" /* yacc.c:1646  */
    { (yyval.val) = (yyvsp[0].val); }
#line 1796 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 60:
#line 392 "rule-parse.y" /* yacc.c:1646  */
    { (yyval.val) = id_to_uint((yyvsp[0].str)); }
#line 1802 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 61:
#line 397 "rule-parse.y" /* yacc.c:1646  */
    { (yyval.bl) = true; }
#line 1808 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 62:
#line 399 "rule-parse.y" /* yacc.c:1646  */
    { (yyval.bl) = false; }
#line 1814 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 63:
#line 404 "rule-parse.y" /* yacc.c:1646  */
    { (yyval.val) = (yyvsp[-1].bl) ? -(yyvsp[0].val) : (yyvsp[0].val); }
#line 1820 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 64:
#line 406 "rule-parse.y" /* yacc.c:1646  */
    { (yyval.val) = 0; }
#line 1826 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 65:
#line 411 "rule-parse.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 1832 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 66:
#line 413 "rule-parse.y" /* yacc.c:1646  */
    { (yyval.str) = id_to_str((yyvsp[0].str)); }
#line 1838 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 67:
#line 418 "rule-parse.y" /* yacc.c:1646  */
    { (yyval.str) = (yyvsp[0].str); }
#line 1844 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;

  case 68:
#line 420 "rule-parse.y" /* yacc.c:1646  */
    { (yyval.str) = id_to_str((yyvsp[0].str)); }
#line 1850 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
    break;


#line 1854 "/builddir/build/BUILD/zeek-3.0.1/build/src/rup.cc" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 423 "rule-parse.y" /* yacc.c:1906  */


void rules_error(const char* msg)
	{
	reporter->Error("Error in signature (%s:%d): %s\n",
			current_rule_file, rules_line_number+1, msg);
	rule_matcher->SetParseError();
	}

void rules_error(const char* msg, const char* addl)
	{
	reporter->Error("Error in signature (%s:%d): %s (%s)\n",
			current_rule_file, rules_line_number+1, msg, addl);
	rule_matcher->SetParseError();
	}

void rules_error(Rule* r, const char* msg)
	{
	const Location& l = r->GetLocation();
	reporter->Error("Error in signature %s (%s:%d): %s\n",
			r->ID(), l.filename, l.first_line, msg);
	rule_matcher->SetParseError();
	}

int rules_wrap(void)
	{
	return 1;
	}
