/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 1 "parse.y" /* yacc.c:339  */

// See the file "COPYING" in the main distribution directory for copyright.
#line 75 "parse.y" /* yacc.c:339  */

#include <stdlib.h>
#include <string.h>
#include <assert.h>

#include "input.h"
#include "Expr.h"
#include "Stmt.h"
#include "Var.h"
/* #include "analyzer/protocol/dns/DNS.h" */
#include "RE.h"
#include "Scope.h"
#include "Reporter.h"
#include "Brofiler.h"
#include "zeekygen/Manager.h"

#include <set>
#include <string>

extern const char* filename;  // Absolute path of file currently being parsed.
extern const char* last_filename; // Absolute path of last file parsed.
extern const char* last_tok_filename;
extern const char* last_last_tok_filename;

YYLTYPE GetCurrentLocation();
extern int yyerror(const char[]);
extern int brolex();

#define YYLLOC_DEFAULT(Current, Rhs, N) \
	(Current) = (Rhs)[(N)];

/*
 * Part of the module facility: while parsing, keep track of which
 * module to put things in.
 */
string current_module = GLOBAL_MODULE_NAME;
bool is_export = false; // true if in an export {} block

/*
 * When parsing an expression for the debugger, where to put the result
 * (obviously not reentrant).
 */
extern Expr* g_curr_debug_expr;
extern bool in_debug;
extern const char* g_curr_debug_error;

#define YYLTYPE yyltype

static int in_hook = 0;
int in_init = 0;
int in_record = 0;
bool resolving_global_ID = false;
bool defining_global_ID = false;
std::vector<int> saved_in_init;

ID* func_id = 0;
EnumType *cur_enum_type = 0;
static ID* cur_decl_type_id = 0;

static void parser_new_enum (void)
	{
	/* Starting a new enum definition. */
	assert(cur_enum_type == NULL);

	if ( cur_decl_type_id )
		cur_enum_type = new EnumType(cur_decl_type_id->Name());
	else
		reporter->FatalError("incorrect syntax for enum type declaration");
	}

static void parser_redef_enum (ID *id)
	{
	/* Redef an enum. id points to the enum to be redefined.
	   Let cur_enum_type point to it. */
	assert(cur_enum_type == NULL);
	if ( ! id->Type() )
		id->Error("unknown identifier");
	else
		{
		cur_enum_type = id->Type()->AsEnumType();
		if ( ! cur_enum_type )
			id->Error("not an enum");
		}
	}

static type_decl_list* copy_type_decl_list(type_decl_list* tdl)
	{
	if ( ! tdl )
		return 0;

	type_decl_list* rval = new type_decl_list();

	for ( const auto& td : *tdl )
		rval->push_back(new TypeDecl(*td));

	return rval;
	}

static attr_list* copy_attr_list(attr_list* al)
	{
	if ( ! al )
		return 0;

	attr_list* rval = new attr_list();

	for ( const auto& a : *al )
		{
		::Ref(a);
		rval->push_back(a);
		}

	return rval;
	}

static void extend_record(ID* id, type_decl_list* fields, attr_list* attrs)
	{
	set<BroType*> types = BroType::GetAliases(id->Name());

	if ( types.empty() )
		{
		id->Error("failed to redef record: no types found in alias map");
		return;
		}

	for ( set<BroType*>::const_iterator it = types.begin(); it != types.end(); )
		{
		RecordType* add_to = (*it)->AsRecordType();
		const char* error = 0;
		++it;

		if ( it == types.end() )
			error = add_to->AddFields(fields, attrs);
		else
			error = add_to->AddFields(copy_type_decl_list(fields),
			                          copy_attr_list(attrs));

		if ( error )
			{
			id->Error(error);
			break;
			}
		}
	}

static bool expr_is_table_type_name(const Expr* expr)
	{
	if ( expr->Tag() != EXPR_NAME )
		return false;

	BroType* type = expr->Type();

	if ( type->IsTable() )
		return true;

	if ( type->Tag() == TYPE_TYPE )
		return type->AsTypeType()->Type()->IsTable();

	return false;
	}

#line 230 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "broparse.h".  */
#ifndef YY_YY_BUILDDIR_BUILD_BUILD_ZEEK_3_0_1_BUILD_SRC_BROPARSE_H_INCLUDED
# define YY_YY_BUILDDIR_BUILD_BUILD_ZEEK_3_0_1_BUILD_SRC_BROPARSE_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    TOK_ADD = 258,
    TOK_ADD_TO = 259,
    TOK_ADDR = 260,
    TOK_ANY = 261,
    TOK_ATENDIF = 262,
    TOK_ATELSE = 263,
    TOK_ATIF = 264,
    TOK_ATIFDEF = 265,
    TOK_ATIFNDEF = 266,
    TOK_BOOL = 267,
    TOK_BREAK = 268,
    TOK_CASE = 269,
    TOK_OPTION = 270,
    TOK_CONST = 271,
    TOK_CONSTANT = 272,
    TOK_COPY = 273,
    TOK_COUNT = 274,
    TOK_COUNTER = 275,
    TOK_DEFAULT = 276,
    TOK_DELETE = 277,
    TOK_DOUBLE = 278,
    TOK_ELSE = 279,
    TOK_ENUM = 280,
    TOK_EVENT = 281,
    TOK_EXPORT = 282,
    TOK_FALLTHROUGH = 283,
    TOK_FILE = 284,
    TOK_FOR = 285,
    TOK_FUNCTION = 286,
    TOK_GLOBAL = 287,
    TOK_HOOK = 288,
    TOK_ID = 289,
    TOK_IF = 290,
    TOK_INT = 291,
    TOK_INTERVAL = 292,
    TOK_LIST = 293,
    TOK_LOCAL = 294,
    TOK_MODULE = 295,
    TOK_NEXT = 296,
    TOK_OF = 297,
    TOK_OPAQUE = 298,
    TOK_PATTERN = 299,
    TOK_PATTERN_END = 300,
    TOK_PATTERN_TEXT = 301,
    TOK_PORT = 302,
    TOK_PRINT = 303,
    TOK_RECORD = 304,
    TOK_REDEF = 305,
    TOK_REMOVE_FROM = 306,
    TOK_RETURN = 307,
    TOK_SCHEDULE = 308,
    TOK_SET = 309,
    TOK_STRING = 310,
    TOK_SUBNET = 311,
    TOK_SWITCH = 312,
    TOK_TABLE = 313,
    TOK_TIME = 314,
    TOK_TIMEOUT = 315,
    TOK_TIMER = 316,
    TOK_TYPE = 317,
    TOK_UNION = 318,
    TOK_VECTOR = 319,
    TOK_WHEN = 320,
    TOK_WHILE = 321,
    TOK_AS = 322,
    TOK_IS = 323,
    TOK_ATTR_ADD_FUNC = 324,
    TOK_ATTR_DEFAULT = 325,
    TOK_ATTR_OPTIONAL = 326,
    TOK_ATTR_REDEF = 327,
    TOK_ATTR_DEL_FUNC = 328,
    TOK_ATTR_EXPIRE_FUNC = 329,
    TOK_ATTR_EXPIRE_CREATE = 330,
    TOK_ATTR_EXPIRE_READ = 331,
    TOK_ATTR_EXPIRE_WRITE = 332,
    TOK_ATTR_RAW_OUTPUT = 333,
    TOK_ATTR_PRIORITY = 334,
    TOK_ATTR_LOG = 335,
    TOK_ATTR_ERROR_HANDLER = 336,
    TOK_ATTR_TYPE_COLUMN = 337,
    TOK_ATTR_DEPRECATED = 338,
    TOK_DEBUG = 339,
    TOK_NO_TEST = 340,
    TOK_OR_OR = 341,
    TOK_AND_AND = 342,
    TOK_LE = 343,
    TOK_GE = 344,
    TOK_EQ = 345,
    TOK_NE = 346,
    TOK_IN = 347,
    TOK_NOT_IN = 348,
    TOK_INCR = 349,
    TOK_DECR = 350,
    TOK_HAS_FIELD = 351,
    TOK_HAS_ATTR = 352
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 236 "parse.y" /* yacc.c:355  */

	bool b;
	char* str;
	ID* id;
	id_list* id_l;
	init_class ic;
	Val* val;
	RE_Matcher* re;
	Expr* expr;
	EventExpr* event_expr;
	Stmt* stmt;
	ListExpr* list;
	BroType* type;
	RecordType* record;
	FuncType* func_type;
	TypeList* type_l;
	TypeDecl* type_decl;
	type_decl_list* type_decl_l;
	Case* c_case;
	case_list* case_l;
	Attr* attr;
	attr_list* attr_l;
	attr_tag attrtag;

#line 393 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


extern YYSTYPE yylval;
extern YYLTYPE yylloc;
int yyparse (void);

#endif /* !YY_YY_BUILDDIR_BUILD_BUILD_ZEEK_3_0_1_BUILD_SRC_BROPARSE_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 424 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  5
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   3322

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  122
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  78
/* YYNRULES -- Number of rules.  */
#define YYNRULES  255
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  709

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   352

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   110,     2,     2,   112,   107,   102,     2,
     115,   116,   105,   103,    86,   104,     2,   106,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    89,   121,
      92,    87,    93,    88,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   113,     2,   114,   101,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   119,   100,   120,   111,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    90,    91,    94,    95,    96,    97,    98,    99,   108,
     109,   117,   118
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   264,   264,   279,   279,   286,   287,   291,   294,   298,
     304,   310,   316,   322,   328,   334,   340,   346,   352,   358,
     364,   370,   376,   382,   388,   394,   400,   406,   412,   418,
     424,   430,   436,   442,   448,   454,   460,   472,   478,   484,
     486,   492,   499,   498,   513,   519,   525,   550,   557,   563,
     563,   563,   570,   576,   583,   589,   582,   631,   631,   640,
     646,   649,   655,   704,   710,   710,   724,   735,   741,   749,
     755,   763,   765,   769,   775,   783,   785,   794,   806,   815,
     824,   829,   834,   839,   844,   849,   854,   859,   864,   869,
     874,   879,   884,   889,   894,   900,   907,   909,   906,   916,
     923,   923,   930,   938,   946,   952,   958,   964,   970,   976,
     982,   988,  1008,  1010,  1018,  1023,  1029,  1040,  1042,  1045,
    1049,  1051,  1053,  1058,  1066,  1072,  1072,  1075,  1081,  1087,
    1093,  1100,  1099,  1107,  1109,  1111,  1106,  1123,  1122,  1131,
    1134,  1137,  1141,  1142,  1145,  1147,  1149,  1151,  1153,  1158,
    1165,  1180,  1188,  1198,  1204,  1197,  1219,  1225,  1216,  1245,
    1253,  1255,  1260,  1263,  1267,  1268,  1269,  1270,  1274,  1274,
    1274,  1277,  1281,  1283,  1285,  1289,  1304,  1306,  1310,  1312,
    1320,  1322,  1324,  1326,  1328,  1330,  1332,  1334,  1336,  1338,
    1340,  1342,  1344,  1346,  1348,  1350,  1366,  1374,  1382,  1390,
    1396,  1402,  1408,  1413,  1418,  1426,  1434,  1442,  1450,  1458,
    1466,  1474,  1482,  1490,  1496,  1505,  1511,  1519,  1528,  1536,
    1542,  1547,  1554,  1558,  1579,  1582,  1586,  1589,  1592,  1597,
    1600,  1608,  1614,  1630,  1656,  1661,  1694,  1715,  1717,  1725,
    1746,  1746,  1751,  1751,  1751,  1756,  1756,  1761,  1797,  1810,
    1813,  1816,  1819,  1822,  1825,  1839
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "TOK_ADD", "TOK_ADD_TO", "TOK_ADDR",
  "TOK_ANY", "TOK_ATENDIF", "TOK_ATELSE", "TOK_ATIF", "TOK_ATIFDEF",
  "TOK_ATIFNDEF", "TOK_BOOL", "TOK_BREAK", "TOK_CASE", "TOK_OPTION",
  "TOK_CONST", "TOK_CONSTANT", "TOK_COPY", "TOK_COUNT", "TOK_COUNTER",
  "TOK_DEFAULT", "TOK_DELETE", "TOK_DOUBLE", "TOK_ELSE", "TOK_ENUM",
  "TOK_EVENT", "TOK_EXPORT", "TOK_FALLTHROUGH", "TOK_FILE", "TOK_FOR",
  "TOK_FUNCTION", "TOK_GLOBAL", "TOK_HOOK", "TOK_ID", "TOK_IF", "TOK_INT",
  "TOK_INTERVAL", "TOK_LIST", "TOK_LOCAL", "TOK_MODULE", "TOK_NEXT",
  "TOK_OF", "TOK_OPAQUE", "TOK_PATTERN", "TOK_PATTERN_END",
  "TOK_PATTERN_TEXT", "TOK_PORT", "TOK_PRINT", "TOK_RECORD", "TOK_REDEF",
  "TOK_REMOVE_FROM", "TOK_RETURN", "TOK_SCHEDULE", "TOK_SET", "TOK_STRING",
  "TOK_SUBNET", "TOK_SWITCH", "TOK_TABLE", "TOK_TIME", "TOK_TIMEOUT",
  "TOK_TIMER", "TOK_TYPE", "TOK_UNION", "TOK_VECTOR", "TOK_WHEN",
  "TOK_WHILE", "TOK_AS", "TOK_IS", "TOK_ATTR_ADD_FUNC", "TOK_ATTR_DEFAULT",
  "TOK_ATTR_OPTIONAL", "TOK_ATTR_REDEF", "TOK_ATTR_DEL_FUNC",
  "TOK_ATTR_EXPIRE_FUNC", "TOK_ATTR_EXPIRE_CREATE", "TOK_ATTR_EXPIRE_READ",
  "TOK_ATTR_EXPIRE_WRITE", "TOK_ATTR_RAW_OUTPUT", "TOK_ATTR_PRIORITY",
  "TOK_ATTR_LOG", "TOK_ATTR_ERROR_HANDLER", "TOK_ATTR_TYPE_COLUMN",
  "TOK_ATTR_DEPRECATED", "TOK_DEBUG", "TOK_NO_TEST", "','", "'='", "'?'",
  "':'", "TOK_OR_OR", "TOK_AND_AND", "'<'", "'>'", "TOK_LE", "TOK_GE",
  "TOK_EQ", "TOK_NE", "TOK_IN", "TOK_NOT_IN", "'|'", "'^'", "'&'", "'+'",
  "'-'", "'*'", "'/'", "'%'", "TOK_INCR", "TOK_DECR", "'!'", "'~'", "'$'",
  "'['", "']'", "'('", "')'", "TOK_HAS_FIELD", "TOK_HAS_ATTR", "'{'",
  "'}'", "';'", "$accept", "bro", "$@1", "decl_list", "opt_expr", "expr",
  "$@2", "$@3", "$@4", "$@5", "$@6", "$@7", "$@8", "expr_list",
  "opt_expr_list", "enum_body", "enum_body_list", "enum_body_elem", "type",
  "$@9", "$@10", "$@11", "type_list", "type_decl_list", "type_decl",
  "formal_args", "formal_args_decl_list", "formal_args_decl", "decl",
  "$@12", "$@13", "$@14", "$@15", "$@16", "$@17", "conditional_list",
  "conditional", "func_hdr", "func_body", "$@18", "$@19",
  "anonymous_function", "$@20", "$@21", "begin_func", "func_params",
  "opt_type", "init_class", "opt_init", "$@22", "$@23", "init",
  "index_slice", "opt_attr", "attr_list", "attr", "stmt", "stmt_list",
  "event", "case_list", "case", "case_type_list", "case_type", "for_head",
  "local_id_list", "local_id", "global_id", "$@24", "def_global_id",
  "$@25", "$@26", "event_id", "$@27", "global_or_event_id", "resolve_id",
  "opt_no_test", "opt_no_test_block", "opt_deprecated", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,    44,    61,    63,    58,
     341,   342,    60,    62,   343,   344,   345,   346,   347,   348,
     124,    94,    38,    43,    45,    42,    47,    37,   349,   350,
      33,   126,    36,    91,    93,    40,    41,   351,   352,   123,
     125,    59
};
# endif

#define YYPACT_NINF -603

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-603)))

#define YYTABLE_NINF -172

#define yytable_value_is_error(Yytable_value) \
  (!!((Yytable_value) == (-172)))

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     -17,  -603,    45,   785,  2756,  -603,  -603,  -603,    -8,    -7,
      -2,  -603,  -603,  -603,    42,  -603,  -603,  -603,   116,   118,
    -603,  -603,  -603,    75,   963,  -603,    39,    49,  -603,  -603,
     131,    63,  2756,    66,    67,    76,  2756,  2756,  2756,  -603,
    2756,  2756,  2756,  2756,   158,  2631,  2756,  2273,  -603,  -603,
    2756,   159,   162,   108,  -603,   108,    49,   166,  -603,    49,
     108,    49,    81,  -603,  -603,  -603,   108,   166,   115,  -603,
      95,   164,  -603,  2756,    89,   131,  2756,   183,    97,   104,
     109,   131,   102,  2756,  2478,  2756,   110,   112,   146,  -603,
     179,  -603,   145,  -603,   963,  2756,   203,   119,  -603,  2756,
    -603,   154,  2756,  1247,  2756,  -603,  2756,  2330,   284,   284,
     197,   284,   284,   284,   284,   -68,  -603,  2273,   -63,  1475,
    2756,  2756,  2966,  2966,  2756,  2855,  2756,  2756,  2756,  2756,
    2756,  2756,  2756,  2756,  2756,  2756,  2756,  2756,  2756,  2756,
    2756,  2756,  2756,  2756,   211,  2855,  -603,   216,  1532,   138,
     139,  2966,    23,  -603,    23,   626,  -603,  -603,  -603,   626,
      23,   626,  -603,   248,    49,  -603,    23,  -603,  -603,  -603,
    -603,  -603,  1019,   171,   108,  1076,   142,   137,   171,    -9,
    2756,    99,   171,   -57,   147,   171,  1133,  1304,  2756,  2756,
    -603,  -603,   171,  2756,  -603,  1589,   174,   144,   -27,  -603,
    -603,  3041,  2756,   -20,   183,   178,   149,  2756,   177,   195,
     242,  2756,   208,  2756,  -603,  -603,  2273,  2273,  -603,  -603,
    -603,  -603,  -603,  -603,   180,   182,   256,    49,   186,  -603,
    -603,  -603,   260,   266,  -603,  -603,   191,   198,  -603,  -603,
     199,  -603,  -603,   201,   275,  -603,  -603,  -603,  2273,  1646,
    2829,  3041,  3082,  3082,  3082,  3082,  3082,  3082,   442,   442,
    3181,   399,   985,   316,   316,   284,   284,   284,  -603,   229,
    1703,   -24,  2756,  -603,  -603,  -603,  -603,  -603,  -603,  -603,
    -603,   265,  -603,   265,   236,   237,  -603,  -603,   238,   243,
     244,   246,   262,  -603,   263,  -603,  -603,   267,   269,  -603,
     626,  -603,   438,  -603,   265,  -603,   210,   626,   349,   265,
    2966,   963,   171,  -603,  -603,    23,   171,  2756,   171,  -603,
      13,   131,  1760,    23,  -603,   171,  2756,  -603,   171,  -603,
    1817,  1874,   618,  -603,  1190,  -603,  2966,   268,   203,   203,
    -603,  2273,  -603,   241,   626,   247,  -603,  -603,  2273,  -603,
    2273,  -603,   203,  2966,  -603,   203,  2966,   324,  -603,  2966,
    2966,  2966,  2966,  2756,  2756,  -603,  -603,   626,  2605,   626,
    2756,  2756,  2756,  2756,  2756,  2756,  2756,  2756,  2756,   348,
    -603,  -603,   626,  -603,  -603,   257,   626,   626,   258,  -603,
     265,  -603,   264,  -603,   345,  2756,     1,  -603,   963,   265,
    -603,  1931,  -603,    35,   963,   963,  -603,   171,   626,  2966,
    -603,  -603,   963,  -603,  -603,  -603,    95,   356,   276,  -603,
     277,  -603,  -603,  -603,  -603,    26,    28,   -60,  -603,   827,
     286,  2273,   282,   281,  2756,  2273,  -603,   285,  2273,  2273,
    2273,  2273,  2273,  2273,  2273,  2273,  2273,  -603,   287,   356,
    -603,   288,   292,  -603,   626,  -603,   309,  1988,   131,    59,
     390,   626,   963,  2730,   326,  -603,  -603,   358,  -603,  -603,
    -603,  -603,   296,   626,  -603,     6,   305,   346,  -603,  -603,
    -603,   402,  2966,  -603,   396,  -603,  -603,  -603,  -603,   354,
     322,  -603,  -603,  -603,   323,  -603,  -603,  -603,   329,  2756,
    -603,  -603,   410,  2756,   963,   330,   392,  3026,    77,    91,
    -603,  -603,  2756,  -603,  -603,   370,     5,  -603,  -603,   356,
     372,   342,  -603,  -603,  2966,  2506,  -603,   347,   402,   171,
    2045,   365,  2102,  -603,   171,  2756,   416,  -603,   415,  -603,
     963,  1361,   468,   403,   470,  -603,  2966,  -603,  -603,  -603,
    -603,   369,  -603,  -603,  2756,  -603,  -603,  1418,   456,   963,
    -603,   963,   146,  -603,  -603,  -603,   626,   626,  2159,   146,
    -603,  -603,   371,   373,  -603,  -603,   733,  -603,  -603,   848,
    -603,  -603,  -603,   131,   376,   378,  2855,  2855,  2855,  2855,
    2855,  2855,   462,  2855,  2855,  3026,  3026,  2855,  2855,  2855,
    2855,  2855,  2855,  2855,  2855,  2855,  2855,  2855,  2855,  2855,
    2855,  2855,  2855,  2855,  2855,  2855,  2855,  2387,   455,   383,
     465,   405,   473,  2855,  2855,   432,  2756,  -603,   343,   343,
     343,   343,   343,   343,    31,  2387,  2387,  2387,  2216,  3000,
    3123,  3164,  3164,  3164,  3164,  3164,  3164,  2528,  2528,  3205,
    2346,  1491,   367,   367,   343,   343,   343,  3026,   203,  3026,
    2966,  3026,  2387,  3123,  2855,   404,  2756,  2855,  2855,   406,
      33,  2387,  1077,   407,  2387,   942,  -603,   483,   439,   440,
     441,   443,   445,   446,   447,   448,   453,  1077,  -603,  3026,
    2855,  2855,  2855,  2855,  2855,  2855,  2855,  2855,  2855,  1077,
    2387,  2387,  2387,  2387,  2387,  2387,  2387,  2387,  2387
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       6,     3,     0,   222,     0,     1,   147,   148,     0,     0,
       0,   242,   242,   245,     0,   242,   242,   242,     0,   240,
     240,     5,   141,     0,     2,    63,     0,     0,    57,    62,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    64,
       0,     0,     0,     0,     0,     0,     0,     4,    60,    39,
       0,     0,     0,   163,   240,   163,     0,     0,   125,     0,
     163,     0,     0,   240,   245,   240,   163,     0,     0,   153,
       0,   142,   139,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   252,   219,
       0,   220,    39,   221,     0,     0,   119,     0,   159,     0,
     239,     0,     0,     0,    72,    49,    72,     0,    16,    15,
       0,    11,    12,    13,    14,     0,    47,    70,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     8,    54,     0,     0,     0,
       0,     0,   164,   243,   164,   177,   247,   246,     6,   177,
     164,   177,   124,     0,     0,   133,   164,   241,   137,   222,
     140,   143,     0,   250,   163,     0,     0,     0,   250,     0,
       0,   163,   250,     0,     0,   250,     0,     0,     0,     0,
     251,   222,   250,     0,   202,     0,     0,     0,   117,   122,
     156,    58,     0,     0,     0,    71,     0,    72,     0,    66,
       0,     0,     0,     0,    46,     9,    18,    20,    91,    93,
      80,    82,    83,    84,     0,     0,   109,     0,     0,   248,
      81,    86,   102,     0,    88,    90,     0,     0,    87,    92,
       0,    85,    89,     0,     0,    67,   111,    68,    36,     0,
      28,    27,    31,    33,    32,    34,    29,    30,    44,    45,
      25,    26,    24,    17,    19,    21,    22,    23,    40,     0,
      70,     0,    72,    59,   144,   145,   146,   162,   166,   167,
     165,   168,   244,   168,     0,     0,   181,   182,     0,     0,
       0,     0,     0,   189,     0,   192,   193,     0,   194,   150,
     176,   179,     0,   149,   168,   151,     0,   177,     0,   168,
       0,   154,   250,   249,   205,   164,   250,    72,   250,   206,
       0,     0,     0,   164,   204,   250,     0,   207,   250,   225,
       0,     0,     0,   218,     0,    10,     0,   161,     0,   118,
     222,    37,    48,     0,   177,     0,    53,    65,    41,    42,
      69,   100,   119,     0,   105,   119,     0,     0,    96,     0,
       0,     0,     0,     0,     8,    38,    55,   177,     0,   177,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     178,   126,   177,   131,   152,     0,   177,   177,     0,   209,
     168,   210,     0,   198,     0,     0,     0,   238,     0,   168,
     197,     0,   208,     0,     0,     0,   196,   250,   177,     0,
     121,   120,   157,    61,    52,    50,     0,     0,     0,   108,
       0,   103,   110,   115,   113,     0,     0,     0,   104,    35,
       0,     7,     0,     0,    72,   174,   169,     0,   183,   180,
     184,   185,   186,   187,   188,   190,   191,   195,     0,     0,
     134,     0,     0,   155,   177,   223,     0,     0,     0,     0,
     199,   177,     0,     0,     0,   201,   224,   213,   203,   217,
     123,   160,     0,   177,    43,   255,     0,    73,    75,   106,
     107,    97,     0,    95,     0,    99,   175,    56,   128,    71,
       0,   170,   129,   127,     0,   115,   130,   138,     0,     0,
     233,   237,     0,     0,     0,     0,   215,     0,     0,     0,
     230,   222,     0,   158,    51,   253,     0,    79,   101,    74,
       0,     0,   114,   112,     0,     0,   172,     0,   135,   250,
       0,     0,     0,   200,   250,     0,   231,   222,     0,   222,
     228,     0,     0,   255,     0,    76,     0,    98,    94,   173,
     132,     0,   212,   235,     0,   234,   211,     0,     0,   226,
     229,   227,   252,   254,    77,    78,   177,   177,     0,   252,
     232,   222,     0,     0,   236,   222,     0,   116,   136,     0,
     214,   216,    57,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    70,   109,     0,
     102,     0,     0,     0,     0,     0,    72,    49,    16,    15,
      11,    12,    13,    14,     0,    18,    20,    36,     0,    28,
      27,    31,    33,    32,    34,    29,    30,    44,    45,    25,
      26,    24,    17,    19,    21,    22,    23,     0,   119,     0,
       0,     0,    69,    58,     0,     0,    72,     0,     0,     0,
       0,    37,   177,     0,    41,    35,   161,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   176,    50,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   177,
     183,   180,   184,   185,   186,   187,   188,   190,   191
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -603,  -603,  -603,   393,   165,    -4,  -603,   -67,  -127,  -603,
    -603,   -19,  -603,   -39,  -102,   113,  -603,    46,  -120,  -603,
    -603,  -603,  -345,    71,  -603,  -342,  -603,  -262,  -603,  -603,
    -603,  -603,  -603,  -603,  -603,   496,    17,  -603,   -61,  -603,
    -603,  -603,  -603,  -603,  -603,    -6,   -12,  -136,  -231,  -603,
    -603,  -603,   -23,  -147,  -602,  -293,   -77,  -134,   364,  -603,
    -603,  -603,    32,  -603,  -603,   -70,    38,  -603,   136,  -603,
    -603,   507,  -603,   505,  -603,  -117,  -413,    30
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     4,     3,   269,    90,   416,   207,   473,   272,
     432,    99,   110,   205,   206,   476,   477,   478,   424,   423,
     521,   417,   425,   481,   522,   197,   198,   199,    21,   158,
     449,   308,   495,   551,   310,    70,    91,    23,    72,   169,
     388,    48,   340,   472,    97,   212,   152,   281,   367,   368,
     491,   436,    49,   414,   300,   301,    93,    24,   177,   403,
     466,   509,   510,    94,   396,   101,    66,    67,    53,    54,
     282,    56,    57,   157,   246,   314,   191,   517
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      47,    92,   245,   247,   208,   174,   118,   380,   299,   170,
     418,   181,   303,   420,   305,   426,   427,   194,   283,   211,
      22,    98,   543,   213,   304,   320,   482,   278,   103,   213,
     309,   277,   107,   108,   109,   311,   111,   112,   113,   114,
      71,   117,   119,   154,   183,     5,   148,    96,   160,   463,
     155,   214,   369,   159,   166,   161,   464,   332,    68,   338,
     485,   319,   213,   203,   325,   324,   213,     1,   327,   172,
     687,    92,   175,   382,   279,   333,   410,   411,   386,   117,
     186,   187,     6,     7,     8,     9,    10,   458,    71,   515,
     365,   195,   153,   516,   339,   201,   342,   687,   117,   394,
     117,   163,   117,   165,   321,   345,   271,    50,    51,   544,
     280,   395,   482,    52,   482,   459,   216,   217,   667,   482,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     483,   270,   484,    63,    64,   502,    96,   677,    55,   571,
      62,    59,    60,    61,    95,   465,   575,   503,   307,   454,
     384,    58,   315,   623,    96,   100,   537,    65,   461,   323,
     366,     6,     7,     8,     9,    10,   322,   538,   102,   390,
     539,   104,   105,   120,   330,   331,   202,   399,   151,   334,
     387,   106,   115,   149,    69,   389,   150,   151,   341,   391,
     156,   393,   162,   117,   168,   260,   412,   348,   400,   350,
     173,   402,    25,    26,    69,   392,   408,   176,   178,   179,
     433,   354,   437,   182,   180,   188,    27,   189,    28,    29,
     121,   190,   193,   419,    30,   448,   421,   196,   200,   451,
     452,   202,   428,   210,    31,   268,   122,   123,    32,    33,
     273,   397,   306,    34,   275,   276,   313,   317,   318,    35,
     337,   470,   326,   336,   213,   344,   124,   125,   117,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   347,    92,   471,
     469,   144,   145,   346,   146,   349,   147,   352,   353,   351,
     192,   355,   356,    40,    41,    42,    43,   498,   357,    92,
     358,   359,   360,   117,   505,   670,   669,   362,   364,    22,
     361,   460,   401,   370,   371,   372,   514,   467,   468,   383,
     373,   374,   490,   375,  -171,  -171,  -171,  -171,  -171,  -171,
    -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,  -171,   376,
     377,   122,   123,   385,   378,   474,   379,   409,   422,   429,
     431,   413,   523,   415,   435,   447,   438,   439,   440,   441,
     442,   443,   444,   445,   446,    92,   450,   540,   453,   456,
     455,    92,    92,   122,   123,   506,  -171,   536,   501,    92,
     475,   457,   479,   480,   380,   489,   144,   145,   487,   146,
     486,   147,   488,   559,   548,   561,   492,   499,   493,   496,
     595,   596,   552,   497,   504,   511,   513,   556,   512,   572,
     573,   141,   142,   143,   508,   518,   566,   533,   144,   145,
     117,   146,   519,   147,   595,   596,   520,   576,   524,    92,
     525,   579,   526,   527,   531,     6,     7,     8,     9,    10,
     529,   534,   535,    11,    12,   144,   145,   542,   146,   617,
     147,   546,   547,   554,    13,    14,   122,   123,   550,    15,
      16,    17,   614,   615,   616,   245,   247,   507,    18,   144,
     145,    92,   146,   558,   147,   563,   515,   565,    19,   567,
     570,   626,   577,   627,   578,   530,   634,   657,   658,   532,
      20,   138,   139,   140,   141,   142,   143,   659,   541,   122,
     123,   144,   145,   625,   146,   661,   147,    92,   660,   664,
     672,   350,   676,   688,   665,   689,   690,   691,   692,   430,
     693,   557,   694,   695,   696,   697,    92,   419,    92,   421,
     698,   428,   136,   137,   138,   139,   140,   141,   142,   143,
     568,   302,   514,    92,   144,   145,    92,   146,   381,   147,
     666,   699,   494,   624,   673,   545,   528,   171,   343,   548,
     560,   164,   167,   564,     0,     0,     0,     0,     0,     0,
       0,     0,   628,   629,   630,   631,   632,   633,     0,   635,
     636,     0,     0,   637,   638,   639,   640,   641,   642,   643,
     644,   645,   646,   647,   648,   649,   650,   651,   652,   653,
     654,   655,   656,   354,     0,     0,     0,     0,     0,   662,
     663,    73,   117,     0,     0,     6,     7,     8,     9,    10,
       0,    74,     0,     0,    75,    25,    26,     0,     0,     0,
      76,     0,     0,     0,    77,     0,    78,     0,    79,    27,
       0,    28,    29,    80,     0,     0,     0,    81,     0,    82,
     671,     0,   117,   674,   675,     0,    83,    31,     0,     0,
      84,    32,    33,     0,     0,    85,    34,     0,     0,     0,
       0,     0,    35,    86,    87,     0,   700,   701,   702,   703,
     704,   705,   706,   707,   708,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
       0,     0,     0,     0,     0,     0,     0,     0,    36,     0,
       0,    37,    38,     0,    39,     0,    40,    41,    42,    43,
      44,    45,     0,    46,     0,     0,    73,    88,   406,    89,
       6,     7,     8,     9,    10,     0,    74,     0,     0,    75,
      25,    26,     0,     0,     0,    76,     0,     0,     0,    77,
       0,    78,     0,    79,    27,     0,    28,    29,    80,     0,
       0,     0,    81,     0,    82,     0,     0,     0,     0,     0,
       0,    83,    31,     0,     0,    84,    32,    33,     0,     0,
      85,    34,     6,     7,     8,     9,    10,    35,    86,    87,
      11,    12,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    13,    14,     0,     0,     0,    15,    16,    17,     0,
       0,     0,     0,     0,     0,    18,     0,     0,     0,     0,
       0,     0,     0,    36,     0,    19,    37,    38,     0,    39,
       0,    40,    41,    42,    43,    44,    45,    20,    46,     0,
       0,    73,    88,   580,    89,     6,     7,     8,     9,    10,
       0,    74,     0,     0,    75,    25,    26,     0,     0,     0,
      76,     0,     0,     0,    77,     0,    78,     0,    79,    27,
       0,    28,    29,    80,     0,     0,     0,    81,     0,    82,
       0,     0,     0,     0,   122,   123,    83,    31,     0,     0,
      84,    32,    33,     0,     0,    85,    34,     0,     0,     0,
       0,     0,    35,    86,    87,   125,     0,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,     0,     0,     0,     0,   144,
     145,     0,   146,     0,   147,     0,     0,     0,    36,     0,
       0,    37,    38,     0,    39,     0,    40,    41,    42,    43,
      44,    45,     0,    46,     0,     0,    73,    88,   581,    89,
       6,     7,     8,     9,    10,     0,    74,     0,     0,    75,
      25,    26,     0,     0,     0,    76,     0,     0,     0,    77,
       0,    78,     0,    79,    27,     0,    28,    29,    80,     0,
       0,     0,    81,     0,    82,     0,     0,     0,     0,   595,
     596,    83,    31,     0,     0,    84,    32,    33,     0,     0,
      85,    34,     0,   120,     0,     0,     0,    35,    86,    87,
     598,     0,   599,   600,   601,   602,   603,   604,   605,   606,
     607,   608,   609,   610,   611,   612,   613,   614,   615,   616,
       0,     0,   122,   123,   144,   145,     0,   146,     0,   147,
       0,     0,     0,    36,     0,     0,    37,    38,     0,    39,
     121,    40,    41,    42,    43,    44,    45,     0,    46,     0,
     120,     0,    88,     0,    89,     0,   122,   123,   139,   140,
     141,   142,   143,     0,     0,     0,     0,   144,   145,     0,
     146,     0,   147,     0,     0,     0,   124,   125,     0,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   121,     0,     0,
       0,   144,   145,     0,   146,     0,   147,   120,     0,     0,
     312,     0,     0,   122,   123,     0,   678,   679,   286,   287,
     680,   681,   682,   683,   684,   293,   685,   295,   296,   686,
     298,     0,     0,   124,   125,     0,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   121,     0,     0,     0,   144,   145,
       0,   146,     0,   147,   120,     0,     0,   316,     0,     0,
     122,   123,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     124,   125,     0,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   121,     0,     0,     0,   144,   145,     0,   146,     0,
     147,   120,     0,     0,   328,     0,     0,   122,   123,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   124,   125,     0,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   121,     0,
       0,     0,   144,   145,     0,   146,     0,   147,   120,     0,
       0,   407,     0,     0,   122,   123,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   124,   125,     0,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   121,     0,     0,     0,   144,
     145,     0,   146,     0,   147,   120,   204,     0,     0,     0,
       0,   122,   123,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   124,   125,     0,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   121,     0,     0,     0,   144,   145,     0,   146,
       0,   147,   120,   329,     0,     0,     0,     0,   122,   123,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   124,   125,
       0,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   121,
       0,     0,     0,   144,   145,     0,   146,     0,   147,   120,
     562,     0,     0,     0,     0,   122,   123,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   124,   125,     0,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   121,     0,     0,     0,
     144,   145,     0,   146,     0,   147,   120,   569,     0,     0,
       0,     0,   122,   123,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   595,   596,
       0,     0,   124,   125,     0,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   121,     0,     0,     0,   144,   145,     0,
     146,   215,   147,   120,   612,   613,   614,   615,   616,   122,
     123,     0,     0,   144,   145,     0,   146,     0,   147,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   124,
     125,     0,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     121,     0,     0,     0,   144,   145,     0,   146,   274,   147,
     593,     0,     0,     0,     0,     0,   122,   123,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   124,   125,     0,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   594,     0,     0,
       0,   144,   145,     0,   146,   335,   147,   593,     0,     0,
       0,     0,     0,   595,   596,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   597,   598,   363,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   594,     0,     0,     0,   144,   145,
       0,   146,     0,   147,   120,     0,     0,     0,     0,     0,
     595,   596,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     597,   598,    -7,   599,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   121,     0,     0,     0,   144,   145,     0,   146,     0,
     147,   120,     0,     0,     0,     0,     0,   122,   123,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   124,   125,     0,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   121,     0,
       0,     0,   144,   145,     0,   146,   398,   147,   120,     0,
       0,     0,     0,     0,   122,   123,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   124,   125,     0,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   121,     0,     0,     0,   144,
     145,     0,   146,   404,   147,   120,     0,     0,     0,     0,
       0,   122,   123,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   124,   125,     0,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   121,     0,     0,     0,   144,   145,     0,   146,
     405,   147,   120,     0,     0,     0,     0,     0,   122,   123,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   124,   125,
       0,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   121,
       0,     0,     0,   144,   145,     0,   146,   462,   147,   120,
       0,     0,     0,     0,     0,   122,   123,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   124,   125,     0,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   121,     0,     0,     0,
     144,   145,     0,   146,   500,   147,   120,     0,     0,     0,
       0,     0,   122,   123,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   124,   125,     0,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   121,     0,     0,     0,   144,   145,     0,
     146,   553,   147,   120,     0,     0,     0,     0,     0,   122,
     123,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   124,
     125,     0,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     121,     0,     0,     0,   144,   145,     0,   146,   555,   147,
     593,     0,     0,     0,     0,     0,   122,   123,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   124,   125,     0,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   594,     0,     0,
       0,   144,   145,     0,   146,   574,   147,   120,     0,     0,
       0,     0,     0,   595,   596,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   597,   598,   668,   599,   600,   601,   602,
     603,   604,   605,   606,   607,   608,   609,   610,   611,   612,
     613,   614,   615,   616,   121,     0,     0,     0,   144,   145,
       0,   146,     0,   147,   120,     0,     0,     0,     0,     0,
     122,   123,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     124,   125,     0,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   121,     0,     0,     0,   144,   145,     0,   146,     0,
     147,   593,     0,     0,     0,     0,     0,   122,   123,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   595,   596,     0,     0,   124,   125,     0,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     209,   137,   138,   139,   140,   141,   142,   143,   594,     0,
       0,     0,   144,   145,     0,   146,     0,   147,   611,   612,
     613,   614,   615,   616,   595,   596,     0,     0,   144,   145,
       0,   146,     0,   147,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   597,   598,     0,   599,   600,   601,
     602,   603,   604,   605,   606,   607,   608,   609,   610,   611,
     612,   613,   614,   615,   616,    25,    26,     0,     0,   144,
     145,     0,   146,     0,   147,     0,     0,     0,     0,    27,
       0,    28,    29,     0,     0,     0,     0,    30,     0,     0,
       0,     0,     0,    25,    26,     0,     0,    31,     0,     0,
       0,    32,    33,     0,     0,     0,    34,    27,     0,    28,
      29,     0,    35,   184,     0,    30,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    31,     0,     0,     0,    32,
      33,     0,     0,     0,    34,     0,     0,     0,     0,     0,
      35,     0,     0,     0,     0,     0,     0,     0,    36,     0,
       0,    37,    38,     0,    39,     0,    40,    41,    42,    43,
      44,    45,     0,    46,     0,   595,   596,     0,     0,   185,
       0,     0,     0,     0,     0,     0,    36,     0,     0,    37,
      38,     0,    39,     0,    40,    41,    42,    43,    44,    45,
       0,    46,    25,    26,     0,     0,   549,     0,   609,   610,
     611,   612,   613,   614,   615,   616,    27,     0,    28,    29,
     144,   145,     0,   146,    30,   147,     0,     0,    25,    26,
       0,     0,     0,     0,    31,     0,     0,     0,    32,    33,
       0,     0,    27,    34,    28,    29,     0,     0,     0,    35,
      30,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      31,     0,     0,     0,    32,    33,     0,     0,     0,    34,
       0,     0,     0,     0,     0,    35,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    36,     0,     0,    37,    38,
       0,    39,     0,    40,    41,    42,    43,    44,    45,     0,
      46,     0,     0,     0,   434,     0,     0,     0,     0,     0,
       0,    36,     0,     0,    37,    38,     0,    39,     0,    40,
      41,    42,    43,    44,    45,   116,    46,    25,    26,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    27,     0,   582,    29,     0,     0,     0,     0,   583,
       0,     0,     0,    25,    26,     0,     0,     0,     0,    31,
       0,     0,     0,    32,   584,     0,     0,    27,   585,    28,
      29,     0,   507,     0,    35,    30,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    31,     0,     0,     0,    32,
      33,     0,     0,     0,    34,     0,     0,     0,     0,     0,
      35,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      36,     0,     0,   586,   587,     0,    39,     0,   588,   589,
     590,   591,   592,    45,     0,    46,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    36,     0,     0,    37,
      38,     0,    39,     0,    40,    41,    42,    43,    44,    45,
       0,    46,    25,    26,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    27,     0,   582,    29,
       0,     0,     0,     0,   583,     0,   122,   123,     0,     0,
       0,     0,     0,     0,    31,     0,     0,     0,    32,   584,
       0,     0,     0,   585,     0,     0,     0,     0,     0,    35,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,     0,     0,     0,
       0,   144,   145,     0,   146,     0,   147,     0,     0,     0,
       0,     0,     0,     0,     0,    36,     0,     0,   586,   587,
       0,    39,     0,   588,   589,   590,   591,   592,    45,     0,
      46,   218,   219,     0,     0,     0,     0,     0,   220,     0,
       0,     0,     0,     0,     0,   221,   222,     0,     0,   223,
       0,   224,   225,     0,     0,   226,     0,   227,     0,   228,
     229,     0,   230,   231,   232,     0,     0,     0,     0,   233,
     234,     0,     0,   235,     0,   236,     0,     0,     0,     0,
     237,   238,   239,     0,   240,   241,     0,   242,     0,   243,
     244,   218,   219,     0,     0,     0,     0,     0,   220,     0,
       0,     0,     0,     0,     0,   221,   222,     0,     0,   223,
       0,   224,   225,     0,     0,   618,     0,   619,     0,   228,
     229,     0,   230,   231,   620,     0,     0,   595,   596,   233,
     234,     0,     0,   235,     0,   236,     0,     0,     0,     0,
     237,   238,   239,     0,   621,   241,     0,   242,     0,   243,
     622,   600,   601,   602,   603,   604,   605,   606,   607,   608,
     609,   610,   611,   612,   613,   614,   615,   616,   122,   123,
       0,     0,   144,   145,     0,   146,     0,   147,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   122,
     123,     0,     0,   144,   145,     0,   146,     0,   147,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  -172,  -172,  -172,  -172,  -172,  -172,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     595,   596,     0,     0,   144,   145,     0,   146,     0,   147,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   611,   612,   613,   614,   615,
     616,   595,   596,     0,     0,   144,   145,     0,   146,     0,
     147,     0,     0,     0,     0,     0,     0,     0,   122,   123,
       0,     0,     0,     0,     0,     0,  -172,  -172,  -172,  -172,
    -172,  -172,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   595,   596,     0,     0,   144,   145,     0,   146,
       0,   147,   137,   138,   139,   140,   141,   142,   143,     0,
       0,     0,     0,   144,   145,     0,   146,     0,   147,     0,
       0,     0,     0,     0,     0,     0,   610,   611,   612,   613,
     614,   615,   616,     0,     0,     0,     0,   144,   145,     0,
     146,     0,   147
};

static const yytype_int16 yycheck[] =
{
       4,    24,   122,   123,   106,    75,    45,   300,   155,    70,
     352,    81,   159,   355,   161,   360,   361,    94,   154,    87,
       3,    27,    17,    86,   160,    34,    86,     4,    32,    86,
     166,   151,    36,    37,    38,   169,    40,    41,    42,    43,
      23,    45,    46,    55,    83,     0,    50,   115,    60,    14,
      56,   114,   283,    59,    66,    61,    21,   191,    20,    86,
     120,   178,    86,   102,   121,   182,    86,    84,   185,    73,
     672,    94,    76,   304,    51,   192,   338,   339,   309,    83,
      84,    85,     7,     8,     9,    10,    11,    86,    71,    83,
     114,    95,    54,    87,   121,    99,   116,   699,   102,    86,
     104,    63,   106,    65,   113,   207,   145,   115,   115,   104,
      87,    98,    86,   115,    86,   114,   120,   121,    87,    86,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     114,   145,   114,    25,    26,    86,   115,   114,    12,   562,
      34,    15,    16,    17,   115,   120,   569,    98,   164,   390,
     307,   119,   174,    86,   115,    34,    89,    49,   399,   181,
     272,     7,     8,     9,    10,    11,   180,    86,   115,   315,
      89,   115,   115,     4,   188,   189,    87,   323,    89,   193,
     310,   115,    34,    34,   119,   312,    34,    89,   202,   316,
      34,   318,   121,   207,    89,   209,   340,   211,   325,   213,
     121,   328,    17,    18,   119,   317,   336,    34,   121,   115,
     367,   227,   369,   121,   115,   115,    31,   115,    33,    34,
      51,    85,    87,   353,    39,   382,   356,    34,   119,   386,
     387,    87,   362,    46,    49,    34,    67,    68,    53,    54,
      34,   321,     4,    58,   116,   116,    85,   115,   121,    64,
     116,   408,   115,    89,    86,   116,    87,    88,   272,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,    45,   311,   409,
     407,   112,   113,   116,   115,    87,   117,   115,    42,   119,
     121,   115,    42,   108,   109,   110,   111,   454,    42,   332,
     119,   113,   113,   317,   461,   660,   658,    42,    89,   302,
     119,   398,   326,    87,    87,    87,   473,   404,   405,   119,
      87,    87,   434,    87,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    87,
      87,    67,    68,     4,    87,   416,    87,    89,    34,   363,
     364,   120,   482,   116,   368,    17,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   398,   119,   511,   120,    34,
     116,   404,   405,    67,    68,   462,   121,   507,   458,   412,
      34,   395,   116,   116,   687,   434,   112,   113,   116,   115,
     114,   117,   121,   537,   524,   539,   121,    98,   121,   121,
      67,    68,   529,   121,    24,    89,   120,   534,    60,   566,
     567,   105,   106,   107,   463,   120,   546,   504,   112,   113,
     434,   115,    86,   117,    67,    68,    34,   571,    42,   462,
      86,   575,   120,   120,    34,     7,     8,     9,    10,    11,
     121,   121,    60,    15,    16,   112,   113,    87,   115,   463,
     117,    89,   120,    98,    26,    27,    67,    68,   121,    31,
      32,    33,   105,   106,   107,   595,   596,    62,    40,   112,
     113,   504,   115,    67,   117,    17,    83,    17,    50,   120,
      34,   115,   121,   115,   121,   499,    34,    42,   115,   503,
      62,   102,   103,   104,   105,   106,   107,    42,   512,    67,
      68,   112,   113,   583,   115,    42,   117,   540,   113,    87,
     116,   525,   116,   116,   626,    42,    87,    87,    87,   364,
      87,   535,    87,    87,    87,    87,   559,   657,   561,   659,
      87,   661,   100,   101,   102,   103,   104,   105,   106,   107,
     554,   158,   699,   576,   112,   113,   579,   115,   120,   117,
     627,   688,   449,   582,   666,   519,   495,    71,   204,   689,
     538,    64,    67,   543,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   586,   587,   588,   589,   590,   591,    -1,   593,
     594,    -1,    -1,   597,   598,   599,   600,   601,   602,   603,
     604,   605,   606,   607,   608,   609,   610,   611,   612,   613,
     614,   615,   616,   619,    -1,    -1,    -1,    -1,    -1,   623,
     624,     3,   626,    -1,    -1,     7,     8,     9,    10,    11,
      -1,    13,    -1,    -1,    16,    17,    18,    -1,    -1,    -1,
      22,    -1,    -1,    -1,    26,    -1,    28,    -1,    30,    31,
      -1,    33,    34,    35,    -1,    -1,    -1,    39,    -1,    41,
     664,    -1,   666,   667,   668,    -1,    48,    49,    -1,    -1,
      52,    53,    54,    -1,    -1,    57,    58,    -1,    -1,    -1,
      -1,    -1,    64,    65,    66,    -1,   690,   691,   692,   693,
     694,   695,   696,   697,   698,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,    -1,
      -1,   103,   104,    -1,   106,    -1,   108,   109,   110,   111,
     112,   113,    -1,   115,    -1,    -1,     3,   119,   120,   121,
       7,     8,     9,    10,    11,    -1,    13,    -1,    -1,    16,
      17,    18,    -1,    -1,    -1,    22,    -1,    -1,    -1,    26,
      -1,    28,    -1,    30,    31,    -1,    33,    34,    35,    -1,
      -1,    -1,    39,    -1,    41,    -1,    -1,    -1,    -1,    -1,
      -1,    48,    49,    -1,    -1,    52,    53,    54,    -1,    -1,
      57,    58,     7,     8,     9,    10,    11,    64,    65,    66,
      15,    16,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    26,    27,    -1,    -1,    -1,    31,    32,    33,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   100,    -1,    50,   103,   104,    -1,   106,
      -1,   108,   109,   110,   111,   112,   113,    62,   115,    -1,
      -1,     3,   119,   120,   121,     7,     8,     9,    10,    11,
      -1,    13,    -1,    -1,    16,    17,    18,    -1,    -1,    -1,
      22,    -1,    -1,    -1,    26,    -1,    28,    -1,    30,    31,
      -1,    33,    34,    35,    -1,    -1,    -1,    39,    -1,    41,
      -1,    -1,    -1,    -1,    67,    68,    48,    49,    -1,    -1,
      52,    53,    54,    -1,    -1,    57,    58,    -1,    -1,    -1,
      -1,    -1,    64,    65,    66,    88,    -1,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,    -1,    -1,    -1,    -1,   112,
     113,    -1,   115,    -1,   117,    -1,    -1,    -1,   100,    -1,
      -1,   103,   104,    -1,   106,    -1,   108,   109,   110,   111,
     112,   113,    -1,   115,    -1,    -1,     3,   119,   120,   121,
       7,     8,     9,    10,    11,    -1,    13,    -1,    -1,    16,
      17,    18,    -1,    -1,    -1,    22,    -1,    -1,    -1,    26,
      -1,    28,    -1,    30,    31,    -1,    33,    34,    35,    -1,
      -1,    -1,    39,    -1,    41,    -1,    -1,    -1,    -1,    67,
      68,    48,    49,    -1,    -1,    52,    53,    54,    -1,    -1,
      57,    58,    -1,     4,    -1,    -1,    -1,    64,    65,    66,
      88,    -1,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
      -1,    -1,    67,    68,   112,   113,    -1,   115,    -1,   117,
      -1,    -1,    -1,   100,    -1,    -1,   103,   104,    -1,   106,
      51,   108,   109,   110,   111,   112,   113,    -1,   115,    -1,
       4,    -1,   119,    -1,   121,    -1,    67,    68,   103,   104,
     105,   106,   107,    -1,    -1,    -1,    -1,   112,   113,    -1,
     115,    -1,   117,    -1,    -1,    -1,    87,    88,    -1,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,    51,    -1,    -1,
      -1,   112,   113,    -1,   115,    -1,   117,     4,    -1,    -1,
     121,    -1,    -1,    67,    68,    -1,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    -1,    -1,    87,    88,    -1,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,    51,    -1,    -1,    -1,   112,   113,
      -1,   115,    -1,   117,     4,    -1,    -1,   121,    -1,    -1,
      67,    68,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      87,    88,    -1,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,    51,    -1,    -1,    -1,   112,   113,    -1,   115,    -1,
     117,     4,    -1,    -1,   121,    -1,    -1,    67,    68,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,    88,    -1,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,    51,    -1,
      -1,    -1,   112,   113,    -1,   115,    -1,   117,     4,    -1,
      -1,   121,    -1,    -1,    67,    68,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    87,    88,    -1,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,    51,    -1,    -1,    -1,   112,
     113,    -1,   115,    -1,   117,     4,   119,    -1,    -1,    -1,
      -1,    67,    68,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    87,    88,    -1,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,    51,    -1,    -1,    -1,   112,   113,    -1,   115,
      -1,   117,     4,   119,    -1,    -1,    -1,    -1,    67,    68,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,    88,
      -1,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,    51,
      -1,    -1,    -1,   112,   113,    -1,   115,    -1,   117,     4,
     119,    -1,    -1,    -1,    -1,    67,    68,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    87,    88,    -1,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,    51,    -1,    -1,    -1,
     112,   113,    -1,   115,    -1,   117,     4,   119,    -1,    -1,
      -1,    -1,    67,    68,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    67,    68,
      -1,    -1,    87,    88,    -1,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,    51,    -1,    -1,    -1,   112,   113,    -1,
     115,   116,   117,     4,   103,   104,   105,   106,   107,    67,
      68,    -1,    -1,   112,   113,    -1,   115,    -1,   117,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
      88,    -1,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
      51,    -1,    -1,    -1,   112,   113,    -1,   115,   116,   117,
       4,    -1,    -1,    -1,    -1,    -1,    67,    68,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    87,    88,    -1,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,    51,    -1,    -1,
      -1,   112,   113,    -1,   115,   116,   117,     4,    -1,    -1,
      -1,    -1,    -1,    67,    68,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,    51,    -1,    -1,    -1,   112,   113,
      -1,   115,    -1,   117,     4,    -1,    -1,    -1,    -1,    -1,
      67,    68,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,    51,    -1,    -1,    -1,   112,   113,    -1,   115,    -1,
     117,     4,    -1,    -1,    -1,    -1,    -1,    67,    68,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,    88,    -1,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,    51,    -1,
      -1,    -1,   112,   113,    -1,   115,   116,   117,     4,    -1,
      -1,    -1,    -1,    -1,    67,    68,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    87,    88,    -1,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,    51,    -1,    -1,    -1,   112,
     113,    -1,   115,   116,   117,     4,    -1,    -1,    -1,    -1,
      -1,    67,    68,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    87,    88,    -1,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,    51,    -1,    -1,    -1,   112,   113,    -1,   115,
     116,   117,     4,    -1,    -1,    -1,    -1,    -1,    67,    68,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,    88,
      -1,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,    51,
      -1,    -1,    -1,   112,   113,    -1,   115,   116,   117,     4,
      -1,    -1,    -1,    -1,    -1,    67,    68,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    87,    88,    -1,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,    51,    -1,    -1,    -1,
     112,   113,    -1,   115,   116,   117,     4,    -1,    -1,    -1,
      -1,    -1,    67,    68,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    87,    88,    -1,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,    51,    -1,    -1,    -1,   112,   113,    -1,
     115,   116,   117,     4,    -1,    -1,    -1,    -1,    -1,    67,
      68,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,
      88,    -1,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
      51,    -1,    -1,    -1,   112,   113,    -1,   115,   116,   117,
       4,    -1,    -1,    -1,    -1,    -1,    67,    68,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    87,    88,    -1,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,    51,    -1,    -1,
      -1,   112,   113,    -1,   115,   116,   117,     4,    -1,    -1,
      -1,    -1,    -1,    67,    68,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,    51,    -1,    -1,    -1,   112,   113,
      -1,   115,    -1,   117,     4,    -1,    -1,    -1,    -1,    -1,
      67,    68,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      87,    88,    -1,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,    51,    -1,    -1,    -1,   112,   113,    -1,   115,    -1,
     117,     4,    -1,    -1,    -1,    -1,    -1,    67,    68,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    67,    68,    -1,    -1,    87,    88,    -1,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,    51,    -1,
      -1,    -1,   112,   113,    -1,   115,    -1,   117,   102,   103,
     104,   105,   106,   107,    67,    68,    -1,    -1,   112,   113,
      -1,   115,    -1,   117,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    87,    88,    -1,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,    17,    18,    -1,    -1,   112,
     113,    -1,   115,    -1,   117,    -1,    -1,    -1,    -1,    31,
      -1,    33,    34,    -1,    -1,    -1,    -1,    39,    -1,    -1,
      -1,    -1,    -1,    17,    18,    -1,    -1,    49,    -1,    -1,
      -1,    53,    54,    -1,    -1,    -1,    58,    31,    -1,    33,
      34,    -1,    64,    65,    -1,    39,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    49,    -1,    -1,    -1,    53,
      54,    -1,    -1,    -1,    58,    -1,    -1,    -1,    -1,    -1,
      64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,    -1,
      -1,   103,   104,    -1,   106,    -1,   108,   109,   110,   111,
     112,   113,    -1,   115,    -1,    67,    68,    -1,    -1,   121,
      -1,    -1,    -1,    -1,    -1,    -1,   100,    -1,    -1,   103,
     104,    -1,   106,    -1,   108,   109,   110,   111,   112,   113,
      -1,   115,    17,    18,    -1,    -1,   120,    -1,   100,   101,
     102,   103,   104,   105,   106,   107,    31,    -1,    33,    34,
     112,   113,    -1,   115,    39,   117,    -1,    -1,    17,    18,
      -1,    -1,    -1,    -1,    49,    -1,    -1,    -1,    53,    54,
      -1,    -1,    31,    58,    33,    34,    -1,    -1,    -1,    64,
      39,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      49,    -1,    -1,    -1,    53,    54,    -1,    -1,    -1,    58,
      -1,    -1,    -1,    -1,    -1,    64,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   100,    -1,    -1,   103,   104,
      -1,   106,    -1,   108,   109,   110,   111,   112,   113,    -1,
     115,    -1,    -1,    -1,   119,    -1,    -1,    -1,    -1,    -1,
      -1,   100,    -1,    -1,   103,   104,    -1,   106,    -1,   108,
     109,   110,   111,   112,   113,   114,   115,    17,    18,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    31,    -1,    33,    34,    -1,    -1,    -1,    -1,    39,
      -1,    -1,    -1,    17,    18,    -1,    -1,    -1,    -1,    49,
      -1,    -1,    -1,    53,    54,    -1,    -1,    31,    58,    33,
      34,    -1,    62,    -1,    64,    39,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    49,    -1,    -1,    -1,    53,
      54,    -1,    -1,    -1,    58,    -1,    -1,    -1,    -1,    -1,
      64,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     100,    -1,    -1,   103,   104,    -1,   106,    -1,   108,   109,
     110,   111,   112,   113,    -1,   115,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,    -1,    -1,   103,
     104,    -1,   106,    -1,   108,   109,   110,   111,   112,   113,
      -1,   115,    17,    18,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    31,    -1,    33,    34,
      -1,    -1,    -1,    -1,    39,    -1,    67,    68,    -1,    -1,
      -1,    -1,    -1,    -1,    49,    -1,    -1,    -1,    53,    54,
      -1,    -1,    -1,    58,    -1,    -1,    -1,    -1,    -1,    64,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,    -1,    -1,    -1,
      -1,   112,   113,    -1,   115,    -1,   117,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   100,    -1,    -1,   103,   104,
      -1,   106,    -1,   108,   109,   110,   111,   112,   113,    -1,
     115,     5,     6,    -1,    -1,    -1,    -1,    -1,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    19,    20,    -1,    -1,    23,
      -1,    25,    26,    -1,    -1,    29,    -1,    31,    -1,    33,
      34,    -1,    36,    37,    38,    -1,    -1,    -1,    -1,    43,
      44,    -1,    -1,    47,    -1,    49,    -1,    -1,    -1,    -1,
      54,    55,    56,    -1,    58,    59,    -1,    61,    -1,    63,
      64,     5,     6,    -1,    -1,    -1,    -1,    -1,    12,    -1,
      -1,    -1,    -1,    -1,    -1,    19,    20,    -1,    -1,    23,
      -1,    25,    26,    -1,    -1,    29,    -1,    31,    -1,    33,
      34,    -1,    36,    37,    38,    -1,    -1,    67,    68,    43,
      44,    -1,    -1,    47,    -1,    49,    -1,    -1,    -1,    -1,
      54,    55,    56,    -1,    58,    59,    -1,    61,    -1,    63,
      64,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,    67,    68,
      -1,    -1,   112,   113,    -1,   115,    -1,   117,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,    67,
      68,    -1,    -1,   112,   113,    -1,   115,    -1,   117,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
      67,    68,    -1,    -1,   112,   113,    -1,   115,    -1,   117,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,    67,    68,    -1,    -1,   112,   113,    -1,   115,    -1,
     117,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    67,    68,
      -1,    -1,    -1,    -1,    -1,    -1,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,    67,    68,    -1,    -1,   112,   113,    -1,   115,
      -1,   117,   101,   102,   103,   104,   105,   106,   107,    -1,
      -1,    -1,    -1,   112,   113,    -1,   115,    -1,   117,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   101,   102,   103,   104,
     105,   106,   107,    -1,    -1,    -1,    -1,   112,   113,    -1,
     115,    -1,   117
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    84,   123,   125,   124,     0,     7,     8,     9,    10,
      11,    15,    16,    26,    27,    31,    32,    33,    40,    50,
      62,   150,   158,   159,   179,    17,    18,    31,    33,    34,
      39,    49,    53,    54,    58,    64,   100,   103,   104,   106,
     108,   109,   110,   111,   112,   113,   115,   127,   163,   174,
     115,   115,   115,   190,   191,   190,   193,   194,   119,   190,
     190,   190,    34,    25,    26,    49,   188,   189,   188,   119,
     157,   158,   160,     3,    13,    16,    22,    26,    28,    30,
      35,    39,    41,    48,    52,    57,    65,    66,   119,   121,
     127,   158,   174,   178,   185,   115,   115,   166,   167,   133,
      34,   187,   115,   127,   115,   115,   115,   127,   127,   127,
     134,   127,   127,   127,   127,    34,   114,   127,   135,   127,
       4,    51,    67,    68,    87,    88,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   112,   113,   115,   117,   127,    34,
      34,    89,   168,   188,   168,   167,    34,   195,   151,   167,
     168,   167,   121,   188,   193,   188,   168,   195,    89,   161,
     160,   157,   127,   121,   187,   127,    34,   180,   121,   115,
     115,   187,   121,   135,    65,   121,   127,   127,   115,   115,
      85,   198,   121,    87,   178,   127,    34,   147,   148,   149,
     119,   127,    87,   135,   119,   135,   136,   129,   136,   100,
      46,    87,   167,    86,   114,   116,   127,   127,     5,     6,
      12,    19,    20,    23,    25,    26,    29,    31,    33,    34,
      36,    37,    38,    43,    44,    47,    49,    54,    55,    56,
      58,    59,    61,    63,    64,   140,   196,   140,   127,   127,
     127,   127,   127,   127,   127,   127,   127,   127,   127,   127,
     127,   127,   127,   127,   127,   127,   127,   127,    34,   126,
     127,   135,   131,    34,   116,   116,   116,   140,     4,    51,
      87,   169,   192,   169,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,   175,
     176,   177,   125,   175,   169,   175,     4,   167,   153,   169,
     156,   179,   121,    85,   197,   168,   121,   115,   121,   197,
      34,   113,   127,   168,   197,   121,   115,   197,   121,   119,
     127,   127,   179,   197,   127,   116,    89,   116,    86,   121,
     164,   127,   116,   180,   116,   136,   116,    45,   127,    87,
     127,   119,   115,    42,   167,   115,    42,    42,   119,   113,
     113,   119,    42,    89,    89,   114,   136,   170,   171,   170,
      87,    87,    87,    87,    87,    87,    87,    87,    87,    87,
     177,   120,   170,   119,   175,     4,   170,   140,   162,   197,
     169,   197,   136,   197,    86,    98,   186,   187,   116,   169,
     197,   127,   197,   181,   116,   116,   120,   121,   140,    89,
     149,   149,   179,   120,   175,   116,   128,   143,   147,   140,
     147,   140,    34,   141,   140,   144,   144,   144,   140,   127,
     126,   127,   132,   175,   119,   127,   173,   175,   127,   127,
     127,   127,   127,   127,   127,   127,   127,    17,   175,   152,
     119,   175,   175,   120,   170,   116,    34,   127,    86,   114,
     178,   170,   116,    14,    21,   120,   182,   178,   178,   197,
     175,   140,   165,   130,   160,    34,   137,   138,   139,   116,
     116,   145,    86,   114,   114,   120,   114,   116,   121,   135,
     136,   172,   121,   121,   137,   154,   121,   121,   175,    98,
     116,   187,    86,    98,    24,   175,   178,    62,   135,   183,
     184,    89,    60,   120,   175,    83,    87,   199,   120,    86,
      34,   142,   146,   140,    42,    86,   120,   120,   145,   121,
     127,    34,   127,   178,   121,    60,   140,    89,    86,    89,
     179,   127,    87,    17,   104,   139,    89,   120,   140,   120,
     121,   155,   197,   116,    98,   116,   197,   127,    67,   179,
     184,   179,   119,    17,   199,    17,   140,   120,   127,   119,
      34,   198,   175,   175,   116,   198,   179,   121,   121,   179,
     120,   120,    33,    39,    54,    58,   103,   104,   108,   109,
     110,   111,   112,     4,    51,    67,    68,    87,    88,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   127,    29,    31,
      38,    58,    64,    86,   133,   187,   115,   115,   127,   127,
     127,   127,   127,   127,    34,   127,   127,   127,   127,   127,
     127,   127,   127,   127,   127,   127,   127,   127,   127,   127,
     127,   127,   127,   127,   127,   127,   127,    42,   115,    42,
     113,    42,   127,   127,    87,   136,   129,    87,    89,   147,
     144,   127,   116,   136,   127,   127,   116,   114,    69,    70,
      73,    74,    75,    76,    77,    79,    82,   176,   116,    42,
      87,    87,    87,    87,    87,    87,    87,    87,    87,   130,
     127,   127,   127,   127,   127,   127,   127,   127,   127
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   122,   123,   124,   123,   125,   125,   126,   126,   127,
     127,   127,   127,   127,   127,   127,   127,   127,   127,   127,
     127,   127,   127,   127,   127,   127,   127,   127,   127,   127,
     127,   127,   127,   127,   127,   127,   127,   127,   127,   127,
     127,   127,   128,   127,   127,   127,   127,   127,   127,   129,
     130,   127,   127,   127,   131,   132,   127,   133,   127,   127,
     127,   127,   127,   127,   134,   127,   127,   127,   127,   135,
     135,   136,   136,   137,   137,   138,   138,   139,   139,   139,
     140,   140,   140,   140,   140,   140,   140,   140,   140,   140,
     140,   140,   140,   140,   140,   140,   141,   142,   140,   140,
     143,   140,   140,   140,   140,   140,   140,   140,   140,   140,
     140,   140,   144,   144,   145,   145,   146,   147,   147,   147,
     148,   148,   148,   149,   150,   151,   150,   150,   150,   150,
     150,   152,   150,   153,   154,   155,   150,   156,   150,   150,
     150,   150,   157,   157,   158,   158,   158,   158,   158,   159,
     159,   159,   159,   161,   162,   160,   164,   165,   163,   166,
     167,   167,   168,   168,   169,   169,   169,   169,   171,   172,
     170,   170,   173,   173,   173,   174,   175,   175,   176,   176,
     177,   177,   177,   177,   177,   177,   177,   177,   177,   177,
     177,   177,   177,   177,   177,   177,   178,   178,   178,   178,
     178,   178,   178,   178,   178,   178,   178,   178,   178,   178,
     178,   178,   178,   178,   178,   178,   178,   178,   178,   178,
     178,   179,   179,   180,   181,   181,   182,   182,   182,   183,
     183,   184,   184,   185,   185,   185,   185,   186,   186,   187,
     189,   188,   191,   192,   190,   194,   193,   195,   196,   197,
     197,   198,   198,   199,   199,   199
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     0,     3,     2,     0,     1,     0,     3,
       4,     2,     2,     2,     2,     2,     2,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     5,     3,     4,     4,     1,
       3,     4,     0,     6,     3,     3,     3,     2,     4,     0,
       0,     7,     5,     4,     0,     0,     6,     0,     3,     3,
       1,     5,     1,     1,     0,     4,     3,     3,     3,     3,
       1,     1,     0,     1,     2,     1,     3,     4,     4,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     6,     4,     0,     0,     6,     4,
       0,     5,     1,     3,     3,     2,     4,     4,     3,     1,
       3,     1,     3,     1,     2,     0,     5,     1,     2,     0,
       3,     3,     1,     4,     3,     0,     5,     7,     7,     7,
       7,     0,     9,     0,     0,     0,    12,     0,     7,     2,
       3,     1,     1,     2,     4,     4,     4,     1,     1,     4,
       4,     4,     5,     0,     0,     5,     0,     0,     7,     1,
       5,     3,     2,     0,     0,     1,     1,     1,     0,     0,
       3,     0,     3,     4,     1,     6,     1,     0,     2,     1,
       3,     1,     1,     3,     3,     3,     3,     3,     3,     1,
       3,     3,     1,     1,     1,     3,     4,     4,     4,     5,
       7,     5,     2,     5,     3,     3,     3,     3,     4,     4,
       4,     8,     8,     5,    11,     6,    12,     5,     3,     1,
       1,     2,     0,     4,     2,     0,     4,     4,     3,     3,
       1,     2,     4,     6,     8,     8,    10,     3,     1,     1,
       0,     2,     0,     0,     3,     0,     2,     1,     1,     1,
       0,     1,     0,     1,     3,     0
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static unsigned
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  unsigned res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (yylocationp);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                       , &(yylsp[(yyi + 1) - (yynrhs)])                       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Location data for the lookahead symbol.  */
YYLTYPE yylloc
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.
       'yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yyls1, yysize * sizeof (*yylsp),
                    &yystacksize);

        yyls = yyls1;
        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 265 "parse.y" /* yacc.c:1646  */
    {
			if ( stmts )
				stmts->AsStmtList()->Stmts().push_back((yyvsp[0].stmt));
			else
				stmts = (yyvsp[0].stmt);

			// Any objects creates from here on out should not
			// have file positions associated with them.
			set_location(no_location);
			}
#line 2613 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 3:
#line 279 "parse.y" /* yacc.c:1646  */
    { in_debug = true; }
#line 2619 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 4:
#line 280 "parse.y" /* yacc.c:1646  */
    {
			g_curr_debug_expr = (yyvsp[0].expr);
			}
#line 2627 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 7:
#line 292 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[0].expr); }
#line 2633 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 8:
#line 294 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = 0; }
#line 2639 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 9:
#line 299 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = (yyvsp[-1].expr); (yyval.expr)->MarkParen();
			}
#line 2648 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 10:
#line 305 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[0]));
			(yyval.expr) = new CloneExpr((yyvsp[-1].expr));
			}
#line 2657 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 11:
#line 311 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyval.expr) = new IncrExpr(EXPR_INCR, (yyvsp[0].expr));
			}
#line 2666 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 12:
#line 317 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyval.expr) = new IncrExpr(EXPR_DECR, (yyvsp[0].expr));
			}
#line 2675 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 13:
#line 323 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyval.expr) = new NotExpr((yyvsp[0].expr));
			}
#line 2684 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 14:
#line 329 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyval.expr) = new ComplementExpr((yyvsp[0].expr));
			}
#line 2693 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 15:
#line 335 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyval.expr) = new NegExpr((yyvsp[0].expr));
			}
#line 2702 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 16:
#line 341 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyval.expr) = new PosExpr((yyvsp[0].expr));
			}
#line 2711 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 17:
#line 347 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new AddExpr((yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2720 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 18:
#line 353 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new AddToExpr((yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2729 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 19:
#line 359 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new SubExpr((yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2738 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 20:
#line 365 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new RemoveFromExpr((yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2747 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 21:
#line 371 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new TimesExpr((yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2756 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 22:
#line 377 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new DivideExpr((yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2765 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 23:
#line 383 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new ModExpr((yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2774 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 24:
#line 389 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new BitExpr(EXPR_AND, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2783 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 25:
#line 395 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new BitExpr(EXPR_OR, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2792 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 26:
#line 401 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new BitExpr(EXPR_XOR, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2801 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 27:
#line 407 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new BoolExpr(EXPR_AND_AND, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2810 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 28:
#line 413 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new BoolExpr(EXPR_OR_OR, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2819 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 29:
#line 419 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new EqExpr(EXPR_EQ, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2828 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 30:
#line 425 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new EqExpr(EXPR_NE, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2837 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 31:
#line 431 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new RelExpr(EXPR_LT, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2846 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 32:
#line 437 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new RelExpr(EXPR_LE, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2855 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 33:
#line 443 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new RelExpr(EXPR_GT, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2864 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 34:
#line 449 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new RelExpr(EXPR_GE, (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2873 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 35:
#line 455 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-4]), (yylsp[0]));
			(yyval.expr) = new CondExpr((yyvsp[-4].expr), (yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2882 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 36:
#line 461 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));

			if ( (yyvsp[-2].expr)->Tag() == EXPR_INDEX && (yyvsp[-2].expr)->AsIndexExpr()->IsSlice() )
				reporter->Error("index slice assignment may not be used"
				                " in arbitrary expression contexts, only"
				                " as a statement");

			(yyval.expr) = get_assign_expr((yyvsp[-2].expr), (yyvsp[0].expr), in_init);
			}
#line 2897 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 37:
#line 473 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = add_and_assign_local((yyvsp[-2].id), (yyvsp[0].expr), val_mgr->GetBool(1));
			}
#line 2906 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 38:
#line 479 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[0]));
			(yyval.expr) = new IndexExpr((yyvsp[-3].expr), (yyvsp[-1].list));
			}
#line 2915 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 40:
#line 487 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new FieldExpr((yyvsp[-2].expr), (yyvsp[0].str));
			}
#line 2924 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 41:
#line 493 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[0]));
			(yyval.expr) = new FieldAssignExpr((yyvsp[-2].str), (yyvsp[0].expr));
			}
#line 2933 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 42:
#line 499 "parse.y" /* yacc.c:1646  */
    {
			func_id = current_scope()->GenerateTemporary("anonymous-function");
			func_id->SetInferReturnType(true);
			begin_func(func_id,
				   current_module.c_str(),
				   FUNC_FLAVOR_FUNCTION,
				   0,
				   (yyvsp[-1].func_type));
			}
#line 2947 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 43:
#line 509 "parse.y" /* yacc.c:1646  */
    {
			(yyval.expr) = new FieldAssignExpr((yyvsp[-4].str), new ConstExpr(func_id->ID_Val()));
			}
#line 2955 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 44:
#line 514 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new InExpr((yyvsp[-2].expr), (yyvsp[0].expr));
			}
#line 2964 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 45:
#line 520 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new NotExpr(new InExpr((yyvsp[-2].expr), (yyvsp[0].expr)));
			}
#line 2973 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 46:
#line 526 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));

			bool is_record_ctor = true;

			// If every expression in the list is a field assignment,
			// then treat it as a record constructor, else as a list
			// used for an initializer.

			for ( int i = 0; i < (yyvsp[-1].list)->Exprs().length(); ++i )
				{
				if ( (yyvsp[-1].list)->Exprs()[i]->Tag() != EXPR_FIELD_ASSIGN )
					{
					is_record_ctor = false;
					break;
					}
				}

			if ( is_record_ctor )
				(yyval.expr) = new RecordConstructorExpr((yyvsp[-1].list));
			else
				(yyval.expr) = (yyvsp[-1].list);
			}
#line 3001 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 47:
#line 551 "parse.y" /* yacc.c:1646  */
    {
			// We interpret this as an empty record constructor.
			(yyval.expr) = new RecordConstructorExpr(new ListExpr);
			}
#line 3010 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 48:
#line 558 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[0]));
			(yyval.expr) = new RecordConstructorExpr((yyvsp[-1].list));
			}
#line 3019 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 49:
#line 563 "parse.y" /* yacc.c:1646  */
    { ++in_init; }
#line 3025 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 50:
#line 563 "parse.y" /* yacc.c:1646  */
    { --in_init; }
#line 3031 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 51:
#line 565 "parse.y" /* yacc.c:1646  */
    { // the ++in_init fixes up the parsing of "[x] = y"
			set_location((yylsp[-6]), (yylsp[-2]));
			(yyval.expr) = new TableConstructorExpr((yyvsp[-3].list), (yyvsp[0].attr_l));
			}
#line 3040 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 52:
#line 571 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-4]), (yylsp[-1]));
			(yyval.expr) = new SetConstructorExpr((yyvsp[-2].list), (yyvsp[0].attr_l));
			}
#line 3049 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 53:
#line 577 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[0]));
			(yyval.expr) = new VectorConstructorExpr((yyvsp[-1].list));
			}
#line 3058 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 54:
#line 583 "parse.y" /* yacc.c:1646  */
    {
			if ( expr_is_table_type_name((yyvsp[-1].expr)) )
				++in_init;
			}
#line 3067 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 55:
#line 589 "parse.y" /* yacc.c:1646  */
    {
			if ( expr_is_table_type_name((yyvsp[-3].expr)) )
				--in_init;
			}
#line 3076 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 56:
#line 595 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-5]), (yylsp[0]));

			BroType* ctor_type = 0;

			if ( (yyvsp[-5].expr)->Tag() == EXPR_NAME &&
			     (ctor_type = (yyvsp[-5].expr)->AsNameExpr()->Id()->AsType()) )
				{
				switch ( ctor_type->Tag() ) {
				case TYPE_RECORD:
					(yyval.expr) = new RecordCoerceExpr(new RecordConstructorExpr((yyvsp[-2].list)),
					                          ctor_type->AsRecordType());
					break;

				case TYPE_TABLE:
					if ( ctor_type->IsTable() )
						(yyval.expr) = new TableConstructorExpr((yyvsp[-2].list), 0, ctor_type);
					else
						(yyval.expr) = new SetConstructorExpr((yyvsp[-2].list), 0, ctor_type);

					break;

				case TYPE_VECTOR:
					(yyval.expr) = new VectorConstructorExpr((yyvsp[-2].list), ctor_type);
					break;

				default:
					(yyvsp[-5].expr)->Error("constructor type not implemented");
					YYERROR;
				}
				}

			else
				(yyval.expr) = new CallExpr((yyvsp[-5].expr), (yyvsp[-2].list), in_hook > 0);
			}
#line 3116 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 57:
#line 631 "parse.y" /* yacc.c:1646  */
    { ++in_hook; }
#line 3122 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 58:
#line 632 "parse.y" /* yacc.c:1646  */
    {
			--in_hook;
			set_location((yylsp[-2]), (yylsp[0]));
			if ( (yyvsp[0].expr)->Tag() != EXPR_CALL )
				(yyvsp[0].expr)->Error("not a valid hook call expression");
			(yyval.expr) = (yyvsp[0].expr);
			}
#line 3134 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 59:
#line 641 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new HasFieldExpr((yyvsp[-2].expr), (yyvsp[0].str));
			}
#line 3143 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 61:
#line 650 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-4]), (yylsp[0]));
			(yyval.expr) = new ScheduleExpr((yyvsp[-3].expr), (yyvsp[-1].event_expr));
			}
#line 3152 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 62:
#line 656 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[0]));

			ID* id = lookup_ID((yyvsp[0].str), current_module.c_str());
			if ( ! id )
				{
				if ( ! in_debug )
					{
/*	// CHECK THAT THIS IS NOT GLOBAL.
					id = install_ID($1, current_module.c_str(),
							false, is_export);
*/

					yyerror(fmt("unknown identifier %s", (yyvsp[0].str)));
					YYERROR;
					}
				else
					{
					yyerror(fmt("unknown identifier %s", (yyvsp[0].str)));
					YYERROR;
					}
				}
			else
				{
				if ( ! id->Type() )
					{
					id->Error("undeclared variable");
					id->SetType(error_type());
					(yyval.expr) = new NameExpr(id);
					}

				else if ( id->IsEnumConst() )
					{
					EnumType* t = id->Type()->AsEnumType();
					int intval = t->Lookup(id->ModuleName(),
							       id->Name());
					if ( intval < 0 )
						reporter->InternalError("enum value not found for %s", id->Name());
					(yyval.expr) = new ConstExpr(t->GetVal(intval));
					}
				else
					(yyval.expr) = new NameExpr(id);

				if ( id->IsDeprecated() )
					reporter->Warning("%s", id->GetDeprecationWarning().c_str());
				}
			}
#line 3204 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 63:
#line 705 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[0]));
			(yyval.expr) = new ConstExpr((yyvsp[0].val));
			}
#line 3213 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 64:
#line 710 "parse.y" /* yacc.c:1646  */
    { begin_RE(); }
#line 3219 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 65:
#line 711 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-1]));

			RE_Matcher* re = new RE_Matcher((yyvsp[-1].str));
			delete [] (yyvsp[-1].str);

			if ( (yyvsp[0].b) )
				re->MakeCaseInsensitive();

			re->Compile();
			(yyval.expr) = new ConstExpr(new PatternVal(re));
			}
#line 3236 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 66:
#line 725 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			auto e = (yyvsp[-1].expr);

			if ( IsIntegral(e->Type()->Tag()) )
				e = new ArithCoerceExpr(e, TYPE_INT);

			(yyval.expr) = new SizeExpr(e);
			}
#line 3250 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 67:
#line 736 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new CastExpr((yyvsp[-2].expr), (yyvsp[0].type));
			}
#line 3259 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 68:
#line 742 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.expr) = new IsExpr((yyvsp[-2].expr), (yyvsp[0].type));
			}
#line 3268 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 69:
#line 750 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyvsp[-2].list)->Append((yyvsp[0].expr));
			}
#line 3277 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 70:
#line 756 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[0]));
			(yyval.list) = new ListExpr((yyvsp[0].expr));
			}
#line 3286 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 72:
#line 765 "parse.y" /* yacc.c:1646  */
    { (yyval.list) = new ListExpr(); }
#line 3292 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 73:
#line 770 "parse.y" /* yacc.c:1646  */
    {
			(yyval.type) = cur_enum_type;
			cur_enum_type = NULL;
			}
#line 3301 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 74:
#line 776 "parse.y" /* yacc.c:1646  */
    {
			(yyval.type) = cur_enum_type;
			cur_enum_type = NULL;
			}
#line 3310 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 77:
#line 795 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[-1]));
			assert(cur_enum_type);

			if ( (yyvsp[-1].val)->Type()->Tag() != TYPE_COUNT )
				reporter->Error("enumerator is not a count constant");
			else
				cur_enum_type->AddName(current_module, (yyvsp[-3].str),
				                       (yyvsp[-1].val)->InternalUnsigned(), is_export, (yyvsp[0].expr));
			}
#line 3325 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 78:
#line 807 "parse.y" /* yacc.c:1646  */
    {
			/* We only accept counts as enumerator, but we want to return a nice
			   error message if users triy to use a negative integer (will also
			   catch other cases, but that's fine.)
			*/
			reporter->Error("enumerator is not a count constant");
			}
#line 3337 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 79:
#line 816 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-1]));
			assert(cur_enum_type);
			cur_enum_type->AddName(current_module, (yyvsp[-1].str), is_export, (yyvsp[0].expr));
			}
#line 3347 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 80:
#line 824 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_BOOL);
				}
#line 3356 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 81:
#line 829 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_INT);
				}
#line 3365 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 82:
#line 834 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_COUNT);
				}
#line 3374 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 83:
#line 839 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_COUNTER);
				}
#line 3383 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 84:
#line 844 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_DOUBLE);
				}
#line 3392 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 85:
#line 849 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_TIME);
				}
#line 3401 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 86:
#line 854 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_INTERVAL);
				}
#line 3410 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 87:
#line 859 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_STRING);
				}
#line 3419 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 88:
#line 864 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_PATTERN);
				}
#line 3428 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 89:
#line 869 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_TIMER);
				}
#line 3437 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 90:
#line 874 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_PORT);
				}
#line 3446 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 91:
#line 879 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_ADDR);
				}
#line 3455 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 92:
#line 884 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_SUBNET);
				}
#line 3464 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 93:
#line 889 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = base_type(TYPE_ANY);
				}
#line 3473 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 94:
#line 895 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[-5]), (yylsp[0]));
				(yyval.type) = new TableType((yyvsp[-3].type_l), (yyvsp[0].type));
				}
#line 3482 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 95:
#line 901 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[-3]), (yylsp[0]));
				(yyval.type) = new SetType((yyvsp[-1].type_l), 0);
				}
#line 3491 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 96:
#line 907 "parse.y" /* yacc.c:1646  */
    { ++in_record; }
#line 3497 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 97:
#line 909 "parse.y" /* yacc.c:1646  */
    { --in_record; }
#line 3503 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 98:
#line 911 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[-5]), (yylsp[-1]));
				(yyval.type) = new RecordType((yyvsp[-2].type_decl_l));
				}
#line 3512 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 99:
#line 917 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[-3]), (yylsp[0]));
				reporter->Error("union type not implemented");
				(yyval.type) = 0;
				}
#line 3522 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 100:
#line 923 "parse.y" /* yacc.c:1646  */
    { set_location((yylsp[-1])); parser_new_enum(); }
#line 3528 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 101:
#line 924 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[-4]), (yylsp[0]));
				(yyvsp[-1].type)->UpdateLocationEndInfo((yylsp[0]));
				(yyval.type) = (yyvsp[-1].type);
				}
#line 3538 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 102:
#line 931 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				// $$ = new TypeList();
				reporter->Error("list type not implemented");
				(yyval.type) = 0;
				}
#line 3549 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 103:
#line 939 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[-2]));
				// $$ = new TypeList($3);
				reporter->Error("list type not implemented");
				(yyval.type) = 0;
				}
#line 3560 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 104:
#line 947 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[-2]), (yylsp[0]));
				(yyval.type) = new VectorType((yyvsp[0].type));
				}
#line 3569 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 105:
#line 953 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[-1]), (yylsp[0]));
				(yyval.type) = (yyvsp[0].func_type);
				}
#line 3578 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 106:
#line 959 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[-3]), (yylsp[-1]));
				(yyval.type) = new FuncType((yyvsp[-1].record), 0, FUNC_FLAVOR_EVENT);
				}
#line 3587 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 107:
#line 965 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[-3]), (yylsp[-1]));
				(yyval.type) = new FuncType((yyvsp[-1].record), base_type(TYPE_BOOL), FUNC_FLAVOR_HOOK);
				}
#line 3596 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 108:
#line 971 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[-2]), (yylsp[0]));
				(yyval.type) = new FileType((yyvsp[0].type));
				}
#line 3605 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 109:
#line 977 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[0]));
				(yyval.type) = new FileType(base_type(TYPE_STRING));
				}
#line 3614 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 110:
#line 983 "parse.y" /* yacc.c:1646  */
    {
				set_location((yylsp[-2]), (yylsp[0]));
				(yyval.type) = new OpaqueType((yyvsp[0].str));
				}
#line 3623 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 111:
#line 989 "parse.y" /* yacc.c:1646  */
    {
			if ( ! (yyvsp[0].id) || ! ((yyval.type) = (yyvsp[0].id)->AsType()) )
				{
				NullStmt here;
				if ( (yyvsp[0].id) )
					(yyvsp[0].id)->Error("not a Zeek type", &here);
				(yyval.type) = error_type();
				}
			else
				{
				Ref((yyval.type));

				if ( (yyvsp[0].id)->IsDeprecated() )
					reporter->Warning("%s", (yyvsp[0].id)->GetDeprecationWarning().c_str());
				}
			}
#line 3644 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 112:
#line 1009 "parse.y" /* yacc.c:1646  */
    { (yyvsp[-2].type_l)->AppendEvenIfNotPure((yyvsp[0].type)); }
#line 3650 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 113:
#line 1011 "parse.y" /* yacc.c:1646  */
    {
			(yyval.type_l) = new TypeList((yyvsp[0].type));
			(yyval.type_l)->Append((yyvsp[0].type));
			}
#line 3659 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 114:
#line 1019 "parse.y" /* yacc.c:1646  */
    {
			(yyvsp[-1].type_decl_l)->push_back((yyvsp[0].type_decl));
			}
#line 3667 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 115:
#line 1023 "parse.y" /* yacc.c:1646  */
    {
			(yyval.type_decl_l) = new type_decl_list();
			}
#line 3675 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 116:
#line 1030 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-4]), (yylsp[-1]));
			(yyval.type_decl) = new TypeDecl((yyvsp[-2].type), (yyvsp[-4].str), (yyvsp[-1].attr_l), (in_record > 0));

			if ( in_record > 0 && cur_decl_type_id )
				zeekygen_mgr->RecordField(cur_decl_type_id, (yyval.type_decl), ::filename);
			}
#line 3687 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 117:
#line 1041 "parse.y" /* yacc.c:1646  */
    { (yyval.record) = new RecordType((yyvsp[0].type_decl_l)); }
#line 3693 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 118:
#line 1043 "parse.y" /* yacc.c:1646  */
    { (yyval.record) = new RecordType((yyvsp[-1].type_decl_l)); }
#line 3699 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 119:
#line 1045 "parse.y" /* yacc.c:1646  */
    { (yyval.record) = new RecordType(new type_decl_list()); }
#line 3705 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 120:
#line 1050 "parse.y" /* yacc.c:1646  */
    { (yyvsp[-2].type_decl_l)->push_back((yyvsp[0].type_decl)); }
#line 3711 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 121:
#line 1052 "parse.y" /* yacc.c:1646  */
    { (yyvsp[-2].type_decl_l)->push_back((yyvsp[0].type_decl)); }
#line 3717 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 122:
#line 1054 "parse.y" /* yacc.c:1646  */
    { (yyval.type_decl_l) = new type_decl_list(); (yyval.type_decl_l)->push_back((yyvsp[0].type_decl)); }
#line 3723 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 123:
#line 1059 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[0]));
			(yyval.type_decl) = new TypeDecl((yyvsp[-1].type), (yyvsp[-3].str), (yyvsp[0].attr_l));
			}
#line 3732 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 124:
#line 1067 "parse.y" /* yacc.c:1646  */
    {
			current_module = (yyvsp[-1].str);
			zeekygen_mgr->ModuleUsage(::filename, current_module);
			}
#line 3741 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 125:
#line 1072 "parse.y" /* yacc.c:1646  */
    { is_export = true; }
#line 3747 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 126:
#line 1073 "parse.y" /* yacc.c:1646  */
    { is_export = false; }
#line 3753 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 127:
#line 1076 "parse.y" /* yacc.c:1646  */
    {
			add_global((yyvsp[-5].id), (yyvsp[-4].type), (yyvsp[-3].ic), (yyvsp[-2].expr), (yyvsp[-1].attr_l), VAR_REGULAR);
			zeekygen_mgr->Identifier((yyvsp[-5].id));
			}
#line 3762 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 128:
#line 1082 "parse.y" /* yacc.c:1646  */
    {
			add_global((yyvsp[-5].id), (yyvsp[-4].type), (yyvsp[-3].ic), (yyvsp[-2].expr), (yyvsp[-1].attr_l), VAR_OPTION);
			zeekygen_mgr->Identifier((yyvsp[-5].id));
			}
#line 3771 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 129:
#line 1088 "parse.y" /* yacc.c:1646  */
    {
			add_global((yyvsp[-5].id), (yyvsp[-4].type), (yyvsp[-3].ic), (yyvsp[-2].expr), (yyvsp[-1].attr_l), VAR_CONST);
			zeekygen_mgr->Identifier((yyvsp[-5].id));
			}
#line 3780 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 130:
#line 1094 "parse.y" /* yacc.c:1646  */
    {
			add_global((yyvsp[-5].id), (yyvsp[-4].type), (yyvsp[-3].ic), (yyvsp[-2].expr), (yyvsp[-1].attr_l), VAR_REDEF);
			zeekygen_mgr->Redef((yyvsp[-5].id), ::filename, (yyvsp[-3].ic), (yyvsp[-2].expr));
			}
#line 3789 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 131:
#line 1100 "parse.y" /* yacc.c:1646  */
    { parser_redef_enum((yyvsp[-2].id)); zeekygen_mgr->Redef((yyvsp[-2].id), ::filename); }
#line 3795 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 132:
#line 1102 "parse.y" /* yacc.c:1646  */
    {
			// Zeekygen already grabbed new enum IDs as the type created them.
			}
#line 3803 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 133:
#line 1107 "parse.y" /* yacc.c:1646  */
    { cur_decl_type_id = (yyvsp[0].id); zeekygen_mgr->Redef((yyvsp[0].id), ::filename); }
#line 3809 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 134:
#line 1109 "parse.y" /* yacc.c:1646  */
    { ++in_record; }
#line 3815 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 135:
#line 1111 "parse.y" /* yacc.c:1646  */
    { --in_record; }
#line 3821 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 136:
#line 1113 "parse.y" /* yacc.c:1646  */
    {
			cur_decl_type_id = 0;

			if ( ! (yyvsp[-9].id)->Type() )
				(yyvsp[-9].id)->Error("unknown identifier");
			else
				extend_record((yyvsp[-9].id), (yyvsp[-4].type_decl_l), (yyvsp[-1].attr_l));
			}
#line 3834 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 137:
#line 1123 "parse.y" /* yacc.c:1646  */
    { cur_decl_type_id = (yyvsp[-1].id); zeekygen_mgr->StartType((yyvsp[-1].id));  }
#line 3840 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 138:
#line 1125 "parse.y" /* yacc.c:1646  */
    {
			cur_decl_type_id = 0;
			add_type((yyvsp[-5].id), (yyvsp[-2].type), (yyvsp[-1].attr_l));
			zeekygen_mgr->Identifier((yyvsp[-5].id));
			}
#line 3850 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 139:
#line 1132 "parse.y" /* yacc.c:1646  */
    { }
#line 3856 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 140:
#line 1135 "parse.y" /* yacc.c:1646  */
    { }
#line 3862 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 144:
#line 1146 "parse.y" /* yacc.c:1646  */
    { do_atif((yyvsp[-1].expr)); }
#line 3868 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 145:
#line 1148 "parse.y" /* yacc.c:1646  */
    { do_atifdef((yyvsp[-1].str)); }
#line 3874 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 146:
#line 1150 "parse.y" /* yacc.c:1646  */
    { do_atifndef((yyvsp[-1].str)); }
#line 3880 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 147:
#line 1152 "parse.y" /* yacc.c:1646  */
    { do_atendif(); }
#line 3886 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 148:
#line 1154 "parse.y" /* yacc.c:1646  */
    { do_atelse(); }
#line 3892 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 149:
#line 1159 "parse.y" /* yacc.c:1646  */
    {
			begin_func((yyvsp[-2].id), current_module.c_str(),
				FUNC_FLAVOR_FUNCTION, 0, (yyvsp[-1].func_type), (yyvsp[0].attr_l));
			(yyval.func_type) = (yyvsp[-1].func_type);
			zeekygen_mgr->Identifier((yyvsp[-2].id));
			}
#line 3903 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 150:
#line 1166 "parse.y" /* yacc.c:1646  */
    {
			// Gracefully handle the deprecation of bro_init, bro_done,
			// and bro_script_loaded
			if ( streq("bro_init", (yyvsp[-2].id)->Name()) )
				(yyvsp[-2].id) = global_scope()->Lookup("zeek_init");
			else if ( streq("bro_done", (yyvsp[-2].id)->Name()) )
				(yyvsp[-2].id) = global_scope()->Lookup("zeek_done");
			else if ( streq("bro_script_loaded", (yyvsp[-2].id)->Name()) )
				(yyvsp[-2].id) = global_scope()->Lookup("zeek_script_loaded");

			begin_func((yyvsp[-2].id), current_module.c_str(),
				   FUNC_FLAVOR_EVENT, 0, (yyvsp[-1].func_type), (yyvsp[0].attr_l));
			(yyval.func_type) = (yyvsp[-1].func_type);
			}
#line 3922 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 151:
#line 1181 "parse.y" /* yacc.c:1646  */
    {
			(yyvsp[-1].func_type)->ClearYieldType(FUNC_FLAVOR_HOOK);
			(yyvsp[-1].func_type)->SetYieldType(base_type(TYPE_BOOL));
			begin_func((yyvsp[-2].id), current_module.c_str(),
				   FUNC_FLAVOR_HOOK, 0, (yyvsp[-1].func_type), (yyvsp[0].attr_l));
			(yyval.func_type) = (yyvsp[-1].func_type);
			}
#line 3934 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 152:
#line 1189 "parse.y" /* yacc.c:1646  */
    {
			begin_func((yyvsp[-2].id), current_module.c_str(),
				   FUNC_FLAVOR_EVENT, 1, (yyvsp[-1].func_type), (yyvsp[0].attr_l));
			(yyval.func_type) = (yyvsp[-1].func_type);
			}
#line 3944 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 153:
#line 1198 "parse.y" /* yacc.c:1646  */
    {
			saved_in_init.push_back(in_init);
			in_init = 0;
			}
#line 3953 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 154:
#line 1204 "parse.y" /* yacc.c:1646  */
    {
			in_init = saved_in_init.back();
			saved_in_init.pop_back();
			}
#line 3962 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 155:
#line 1210 "parse.y" /* yacc.c:1646  */
    {
			end_func((yyvsp[-2].stmt));
			}
#line 3970 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 156:
#line 1219 "parse.y" /* yacc.c:1646  */
    {
			saved_in_init.push_back(in_init);
			in_init = 0;
			}
#line 3979 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 157:
#line 1225 "parse.y" /* yacc.c:1646  */
    {
			in_init = saved_in_init.back();
			saved_in_init.pop_back();
			}
#line 3988 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 158:
#line 1231 "parse.y" /* yacc.c:1646  */
    {
			// Code duplication here is sad but needed. end_func actually instantiates the function
			// and associates it with an ID. We perform that association later and need to return
			// a lambda expression.

			// Gather the ingredients for a BroFunc from the current scope
			std::unique_ptr<function_ingredients> ingredients = gather_function_ingredients(current_scope(), (yyvsp[-2].stmt));
			id_list outer_ids = gather_outer_ids(pop_scope(), (yyvsp[-2].stmt));

			(yyval.expr) = new LambdaExpr(std::move(ingredients), std::move(outer_ids));
			}
#line 4004 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 159:
#line 1246 "parse.y" /* yacc.c:1646  */
    {
			(yyval.id) = current_scope()->GenerateTemporary("anonymous-function");
			begin_func((yyval.id), current_module.c_str(), FUNC_FLAVOR_FUNCTION, 0, (yyvsp[0].func_type));
			}
#line 4013 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 160:
#line 1254 "parse.y" /* yacc.c:1646  */
    { (yyval.func_type) = new FuncType((yyvsp[-3].record), (yyvsp[0].type), FUNC_FLAVOR_FUNCTION); }
#line 4019 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 161:
#line 1256 "parse.y" /* yacc.c:1646  */
    { (yyval.func_type) = new FuncType((yyvsp[-1].record), base_type(TYPE_VOID), FUNC_FLAVOR_FUNCTION); }
#line 4025 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 162:
#line 1261 "parse.y" /* yacc.c:1646  */
    { (yyval.type) = (yyvsp[0].type); }
#line 4031 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 163:
#line 1263 "parse.y" /* yacc.c:1646  */
    { (yyval.type) = 0; }
#line 4037 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 164:
#line 1267 "parse.y" /* yacc.c:1646  */
    { (yyval.ic) = INIT_NONE; }
#line 4043 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 165:
#line 1268 "parse.y" /* yacc.c:1646  */
    { (yyval.ic) = INIT_FULL; }
#line 4049 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 166:
#line 1269 "parse.y" /* yacc.c:1646  */
    { (yyval.ic) = INIT_EXTRA; }
#line 4055 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 167:
#line 1270 "parse.y" /* yacc.c:1646  */
    { (yyval.ic) = INIT_REMOVE; }
#line 4061 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 168:
#line 1274 "parse.y" /* yacc.c:1646  */
    { ++in_init; }
#line 4067 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 169:
#line 1274 "parse.y" /* yacc.c:1646  */
    { --in_init; }
#line 4073 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 170:
#line 1275 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[-1].expr); }
#line 4079 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 171:
#line 1277 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = 0; }
#line 4085 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 172:
#line 1282 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[-1].list); }
#line 4091 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 173:
#line 1284 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = (yyvsp[-2].list); }
#line 4097 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 175:
#line 1290 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-5]), (yylsp[0]));
			Expr* low = (yyvsp[-3].expr) ? (yyvsp[-3].expr) : new ConstExpr(val_mgr->GetCount(0));
			Expr* high = (yyvsp[-1].expr) ? (yyvsp[-1].expr) : new SizeExpr((yyvsp[-5].expr));

			if ( ! IsIntegral(low->Type()->Tag()) || ! IsIntegral(high->Type()->Tag()) )
				reporter->Error("slice notation must have integral values as indexes");

			ListExpr* le = new ListExpr(low);
			le->Append(high);
			(yyval.expr) = new IndexExpr((yyvsp[-5].expr), le, true);
			}
#line 4114 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 177:
#line 1306 "parse.y" /* yacc.c:1646  */
    { (yyval.attr_l) = 0; }
#line 4120 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 178:
#line 1311 "parse.y" /* yacc.c:1646  */
    { (yyvsp[-1].attr_l)->push_back((yyvsp[0].attr)); }
#line 4126 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 179:
#line 1313 "parse.y" /* yacc.c:1646  */
    {
			(yyval.attr_l) = new attr_list;
			(yyval.attr_l)->push_back((yyvsp[0].attr));
			}
#line 4135 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 180:
#line 1321 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_DEFAULT, (yyvsp[0].expr)); }
#line 4141 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 181:
#line 1323 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_OPTIONAL); }
#line 4147 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 182:
#line 1325 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_REDEF); }
#line 4153 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 183:
#line 1327 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_ADD_FUNC, (yyvsp[0].expr)); }
#line 4159 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 184:
#line 1329 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_DEL_FUNC, (yyvsp[0].expr)); }
#line 4165 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 185:
#line 1331 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_EXPIRE_FUNC, (yyvsp[0].expr)); }
#line 4171 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 186:
#line 1333 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_EXPIRE_CREATE, (yyvsp[0].expr)); }
#line 4177 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 187:
#line 1335 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_EXPIRE_READ, (yyvsp[0].expr)); }
#line 4183 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 188:
#line 1337 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_EXPIRE_WRITE, (yyvsp[0].expr)); }
#line 4189 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 189:
#line 1339 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_RAW_OUTPUT); }
#line 4195 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 190:
#line 1341 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_PRIORITY, (yyvsp[0].expr)); }
#line 4201 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 191:
#line 1343 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_TYPE_COLUMN, (yyvsp[0].expr)); }
#line 4207 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 192:
#line 1345 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_LOG); }
#line 4213 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 193:
#line 1347 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_ERROR_HANDLER); }
#line 4219 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 194:
#line 1349 "parse.y" /* yacc.c:1646  */
    { (yyval.attr) = new Attr(ATTR_DEPRECATED); }
#line 4225 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 195:
#line 1351 "parse.y" /* yacc.c:1646  */
    {
			if ( IsString((yyvsp[0].val)->Type()->Tag()) )
				(yyval.attr) = new Attr(ATTR_DEPRECATED, new ConstExpr((yyvsp[0].val)));
			else
				{
				ODesc d;
				(yyvsp[0].val)->Describe(&d);
				reporter->Error("'&deprecated=%s' must use a string literal",
				                d.Description());
				(yyval.attr) = new Attr(ATTR_DEPRECATED);
				}
			}
#line 4242 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 196:
#line 1367 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[0]));
			(yyval.stmt) = (yyvsp[-1].stmt);
			if ( (yyvsp[-2].b) )
			    brofiler.DecIgnoreDepth();
			}
#line 4253 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 197:
#line 1375 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[-1]));
			(yyval.stmt) = new PrintStmt((yyvsp[-2].list));
			if ( ! (yyvsp[0].b) )
			    brofiler.AddStmt((yyval.stmt));
			}
#line 4264 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 198:
#line 1383 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[-1]));
			(yyval.stmt) = new EventStmt((yyvsp[-2].event_expr));
			if ( ! (yyvsp[0].b) )
			    brofiler.AddStmt((yyval.stmt));
			}
#line 4275 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 199:
#line 1391 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-4]), (yylsp[-1]));
			(yyval.stmt) = new IfStmt((yyvsp[-2].expr), (yyvsp[0].stmt), new NullStmt());
			}
#line 4284 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 200:
#line 1397 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-6]), (yylsp[-3]));
			(yyval.stmt) = new IfStmt((yyvsp[-4].expr), (yyvsp[-2].stmt), (yyvsp[0].stmt));
			}
#line 4293 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 201:
#line 1403 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-4]), (yylsp[-3]));
			(yyval.stmt) = new SwitchStmt((yyvsp[-3].expr), (yyvsp[-1].case_l));
			}
#line 4302 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 202:
#line 1409 "parse.y" /* yacc.c:1646  */
    {
			(yyvsp[-1].stmt)->AsForStmt()->AddBody((yyvsp[0].stmt));
			}
#line 4310 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 203:
#line 1414 "parse.y" /* yacc.c:1646  */
    {
			(yyval.stmt) = new WhileStmt((yyvsp[-2].expr), (yyvsp[0].stmt));
			}
#line 4318 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 204:
#line 1419 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[-1]));
			(yyval.stmt) = new NextStmt;
			if ( ! (yyvsp[0].b) )
			    brofiler.AddStmt((yyval.stmt));
			}
#line 4329 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 205:
#line 1427 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[-1]));
			(yyval.stmt) = new BreakStmt;
			if ( ! (yyvsp[0].b) )
			    brofiler.AddStmt((yyval.stmt));
			}
#line 4340 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 206:
#line 1435 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[-1]));
			(yyval.stmt) = new FallthroughStmt;
			if ( ! (yyvsp[0].b) )
				brofiler.AddStmt((yyval.stmt));
			}
#line 4351 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 207:
#line 1443 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[-1]));
			(yyval.stmt) = new ReturnStmt(0);
			if ( ! (yyvsp[0].b) )
			    brofiler.AddStmt((yyval.stmt));
			}
#line 4362 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 208:
#line 1451 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[-2]));
			(yyval.stmt) = new ReturnStmt((yyvsp[-2].expr));
			if ( ! (yyvsp[0].b) )
			    brofiler.AddStmt((yyval.stmt));
			}
#line 4373 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 209:
#line 1459 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[-1]));
			(yyval.stmt) = new AddStmt((yyvsp[-2].expr));
			if ( ! (yyvsp[0].b) )
			    brofiler.AddStmt((yyval.stmt));
			}
#line 4384 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 210:
#line 1467 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[-1]));
			(yyval.stmt) = new DelStmt((yyvsp[-2].expr));
			if ( ! (yyvsp[0].b) )
			    brofiler.AddStmt((yyval.stmt));
			}
#line 4395 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 211:
#line 1475 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-7]), (yylsp[-1]));
			(yyval.stmt) = add_local((yyvsp[-6].id), (yyvsp[-5].type), (yyvsp[-4].ic), (yyvsp[-3].expr), (yyvsp[-2].attr_l), VAR_REGULAR);
			if ( ! (yyvsp[0].b) )
			    brofiler.AddStmt((yyval.stmt));
			}
#line 4406 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 212:
#line 1483 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-7]), (yylsp[-2]));
			(yyval.stmt) = add_local((yyvsp[-6].id), (yyvsp[-5].type), (yyvsp[-4].ic), (yyvsp[-3].expr), (yyvsp[-2].attr_l), VAR_CONST);
			if ( ! (yyvsp[0].b) )
			    brofiler.AddStmt((yyval.stmt));
			}
#line 4417 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 213:
#line 1491 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.stmt) = new WhenStmt((yyvsp[-2].expr), (yyvsp[0].stmt), 0, 0, false);
			}
#line 4426 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 214:
#line 1497 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-8]), (yylsp[-2]));
			(yyval.stmt) = new WhenStmt((yyvsp[-8].expr), (yyvsp[-6].stmt), (yyvsp[-1].stmt), (yyvsp[-4].expr), false);
			if ( (yyvsp[-2].b) )
			    brofiler.DecIgnoreDepth();
			}
#line 4437 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 215:
#line 1506 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[0]));
			(yyval.stmt) = new WhenStmt((yyvsp[-2].expr), (yyvsp[0].stmt), 0, 0, true);
			}
#line 4446 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 216:
#line 1512 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-8]), (yylsp[-2]));
			(yyval.stmt) = new WhenStmt((yyvsp[-8].expr), (yyvsp[-6].stmt), (yyvsp[-1].stmt), (yyvsp[-4].expr), true);
			if ( (yyvsp[-2].b) )
			    brofiler.DecIgnoreDepth();
			}
#line 4457 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 217:
#line 1520 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-4]), (yylsp[-1]));
			(yyval.stmt) = new ExprStmt(get_assign_expr((yyvsp[-4].expr), (yyvsp[-2].expr), in_init));

			if ( ! (yyvsp[0].b) )
				brofiler.AddStmt((yyval.stmt));
			}
#line 4469 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 218:
#line 1529 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-2]), (yylsp[-1]));
			(yyval.stmt) = new ExprStmt((yyvsp[-2].expr));
			if ( ! (yyvsp[0].b) )
			    brofiler.AddStmt((yyval.stmt));
			}
#line 4480 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 219:
#line 1537 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[0]), (yylsp[0]));
			(yyval.stmt) = new NullStmt;
			}
#line 4489 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 220:
#line 1543 "parse.y" /* yacc.c:1646  */
    { (yyval.stmt) = new NullStmt; }
#line 4495 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 221:
#line 1548 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-1]), (yylsp[0]));
			(yyvsp[-1].stmt)->AsStmtList()->Stmts().push_back((yyvsp[0].stmt));
			(yyvsp[-1].stmt)->UpdateLocationEndInfo((yylsp[0]));
			}
#line 4505 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 222:
#line 1554 "parse.y" /* yacc.c:1646  */
    { (yyval.stmt) = new StmtList(); }
#line 4511 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 223:
#line 1559 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-3]), (yylsp[0]));

			ID* id = lookup_ID((yyvsp[-3].str), current_module.c_str());
			if ( id )
				{
				if ( ! id->IsGlobal() )
					{
					yyerror(fmt("local identifier \"%s\" cannot be used to reference an event", (yyvsp[-3].str)));
					YYERROR;
					}
				if ( id->IsDeprecated() )
					reporter->Warning("%s", id->GetDeprecationWarning().c_str());
				}

			(yyval.event_expr) = new EventExpr((yyvsp[-3].str), (yyvsp[-1].list));
			}
#line 4533 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 224:
#line 1580 "parse.y" /* yacc.c:1646  */
    { (yyvsp[-1].case_l)->push_back((yyvsp[0].c_case)); }
#line 4539 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 225:
#line 1582 "parse.y" /* yacc.c:1646  */
    { (yyval.case_l) = new case_list; }
#line 4545 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 226:
#line 1587 "parse.y" /* yacc.c:1646  */
    { (yyval.c_case) = new Case((yyvsp[-2].list), 0, (yyvsp[0].stmt)); }
#line 4551 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 227:
#line 1590 "parse.y" /* yacc.c:1646  */
    { (yyval.c_case) = new Case(0, (yyvsp[-2].id_l), (yyvsp[0].stmt)); }
#line 4557 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 228:
#line 1593 "parse.y" /* yacc.c:1646  */
    { (yyval.c_case) = new Case(0, 0, (yyvsp[0].stmt)); }
#line 4563 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 229:
#line 1598 "parse.y" /* yacc.c:1646  */
    { (yyvsp[-2].id_l)->push_back((yyvsp[0].id)); }
#line 4569 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 230:
#line 1601 "parse.y" /* yacc.c:1646  */
    {
			(yyval.id_l) = new id_list;
			(yyval.id_l)->push_back((yyvsp[0].id));
			}
#line 4578 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 231:
#line 1609 "parse.y" /* yacc.c:1646  */
    {
			(yyval.id) = new ID(0, SCOPE_FUNCTION, 0);
			(yyval.id)->SetType((yyvsp[0].type));
			}
#line 4587 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 232:
#line 1615 "parse.y" /* yacc.c:1646  */
    {
			const char* name = (yyvsp[0].str);
			BroType* type = (yyvsp[-2].type);
			ID* case_var = lookup_ID(name, current_module.c_str());

			if ( case_var && case_var->IsGlobal() )
				case_var->Error("already a global identifier");
			else
				case_var = install_ID(name, current_module.c_str(), false, false);

			add_local(case_var, type, INIT_NONE, 0, 0, VAR_REGULAR);
			(yyval.id) = case_var;
			}
#line 4605 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 233:
#line 1631 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-5]), (yylsp[0]));

			// This rule needs to be separate from the loop
			// body so that we execute these actions - defining
			// the local variable - prior to parsing the body,
			// which might refer to the variable.
			ID* loop_var = lookup_ID((yyvsp[-3].str), current_module.c_str());

			if ( loop_var )
				{
				if ( loop_var->IsGlobal() )
					loop_var->Error("global variable used in for loop");
				}

			else
				loop_var = install_ID((yyvsp[-3].str), current_module.c_str(),
						      false, false);

			id_list* loop_vars = new id_list;
			loop_vars->push_back(loop_var);

			(yyval.stmt) = new ForStmt(loop_vars, (yyvsp[-1].expr));
			}
#line 4634 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 234:
#line 1657 "parse.y" /* yacc.c:1646  */
    {
			(yyval.stmt) = new ForStmt((yyvsp[-4].id_l), (yyvsp[-1].expr));
			}
#line 4642 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 235:
#line 1662 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-7]), (yylsp[0]));
			const char* module = current_module.c_str();

			// Check for previous definitions of key and
			// value variables.
			ID* key_var = lookup_ID((yyvsp[-5].str), module);
			ID* val_var = lookup_ID((yyvsp[-3].str), module);

			// Validate previous definitions as needed.
			if ( key_var )
				{
				if ( key_var->IsGlobal() )
					key_var->Error("global variable used in for loop");
				}
			else
				key_var = install_ID((yyvsp[-5].str), module, false, false);

			if ( val_var )
				{
				if ( val_var->IsGlobal() )
					val_var->Error("global variable used in for loop");
				}
			else
				val_var = install_ID((yyvsp[-3].str), module, false, false);

			id_list* loop_vars = new id_list;
			loop_vars->push_back(key_var);

			(yyval.stmt) = new ForStmt(loop_vars, (yyvsp[-1].expr), val_var);
			}
#line 4678 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 236:
#line 1695 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[-9]), (yylsp[0]));
			const char* module = current_module.c_str();

			// Validate value variable
			ID* val_var = lookup_ID((yyvsp[-3].str), module);

			if ( val_var )
				{
				if ( val_var->IsGlobal() )
					val_var->Error("global variable used in for loop");
				}
			else
				val_var = install_ID((yyvsp[-3].str), module, false, false);

			(yyval.stmt) = new ForStmt((yyvsp[-6].id_l), (yyvsp[-1].expr), val_var);
			}
#line 4700 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 237:
#line 1716 "parse.y" /* yacc.c:1646  */
    { (yyvsp[-2].id_l)->push_back((yyvsp[0].id)); }
#line 4706 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 238:
#line 1718 "parse.y" /* yacc.c:1646  */
    {
			(yyval.id_l) = new id_list;
			(yyval.id_l)->push_back((yyvsp[0].id));
			}
#line 4715 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 239:
#line 1726 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[0]));

			(yyval.id) = lookup_ID((yyvsp[0].str), current_module.c_str());
			if ( (yyval.id) )
				{
				if ( (yyval.id)->IsGlobal() )
					(yyval.id)->Error("already a global identifier");
				delete [] (yyvsp[0].str);
				}

			else
				{
				(yyval.id) = install_ID((yyvsp[0].str), current_module.c_str(),
						false, is_export);
				}
			}
#line 4737 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 240:
#line 1746 "parse.y" /* yacc.c:1646  */
    { resolving_global_ID = 1; }
#line 4743 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 241:
#line 1747 "parse.y" /* yacc.c:1646  */
    { (yyval.id) = (yyvsp[0].id); }
#line 4749 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 242:
#line 1751 "parse.y" /* yacc.c:1646  */
    { defining_global_ID = 1; }
#line 4755 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 243:
#line 1751 "parse.y" /* yacc.c:1646  */
    { defining_global_ID = 0; }
#line 4761 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 244:
#line 1752 "parse.y" /* yacc.c:1646  */
    { (yyval.id) = (yyvsp[-1].id); }
#line 4767 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 245:
#line 1756 "parse.y" /* yacc.c:1646  */
    { resolving_global_ID = 0; }
#line 4773 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 246:
#line 1757 "parse.y" /* yacc.c:1646  */
    { (yyval.id) = (yyvsp[0].id); }
#line 4779 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 247:
#line 1762 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[0]));

			(yyval.id) = lookup_ID((yyvsp[0].str), current_module.c_str(), false, defining_global_ID);
			if ( (yyval.id) )
				{
				if ( ! (yyval.id)->IsGlobal() )
					(yyval.id)->Error("already a local identifier");

				if ( (yyval.id)->IsDeprecated() )
					{
					BroType* t = (yyval.id)->Type();

					if ( t->Tag() != TYPE_FUNC ||
					     t->AsFuncType()->Flavor() != FUNC_FLAVOR_FUNCTION )
						reporter->Warning("%s", (yyval.id)->GetDeprecationWarning().c_str());
					}

				delete [] (yyvsp[0].str);
				}

			else
				{
				const char* module_name =
					resolving_global_ID ?
						current_module.c_str() : 0;

				(yyval.id) = install_ID((yyvsp[0].str), module_name,
						true, is_export);
				}
			}
#line 4815 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 248:
#line 1798 "parse.y" /* yacc.c:1646  */
    {
			set_location((yylsp[0]));
			(yyval.id) = lookup_ID((yyvsp[0].str), current_module.c_str());

			if ( ! (yyval.id) )
				reporter->Error("identifier not defined: %s", (yyvsp[0].str));

			delete [] (yyvsp[0].str);
			}
#line 4829 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 249:
#line 1811 "parse.y" /* yacc.c:1646  */
    { (yyval.b) = true; }
#line 4835 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 250:
#line 1813 "parse.y" /* yacc.c:1646  */
    { (yyval.b) = false; }
#line 4841 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 251:
#line 1817 "parse.y" /* yacc.c:1646  */
    { (yyval.b) = true; brofiler.IncIgnoreDepth(); }
#line 4847 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 252:
#line 1819 "parse.y" /* yacc.c:1646  */
    { (yyval.b) = false; }
#line 4853 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 253:
#line 1823 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = new ConstExpr(new StringVal("")); }
#line 4859 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 254:
#line 1826 "parse.y" /* yacc.c:1646  */
    {
			if ( IsString((yyvsp[0].val)->Type()->Tag()) )
				(yyval.expr) = new ConstExpr((yyvsp[0].val));
			else
				{
				ODesc d;
				(yyvsp[0].val)->Describe(&d);
				reporter->Error("'&deprecated=%s' must use a string literal",
				                d.Description());
				(yyval.expr) = new ConstExpr(new StringVal(""));
				}
			}
#line 4876 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;

  case 255:
#line 1839 "parse.y" /* yacc.c:1646  */
    { (yyval.expr) = nullptr; }
#line 4882 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
    break;


#line 4886 "/builddir/build/BUILD/zeek-3.0.1/build/src/p.cc" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 1841 "parse.y" /* yacc.c:1906  */


int yyerror(const char msg[])
	{
	if ( in_debug )
		g_curr_debug_error = copy_string(msg);

	if ( last_tok[0] == '\n' )
		reporter->Error("%s, on previous line", msg);
	else if ( last_tok[0] == '\0' )
		{
		if ( last_filename )
			reporter->Error("%s, at end of file %s", msg, last_filename);
		else
			reporter->Error("%s, at end of file", msg);
		}
	else
		{
		if ( last_last_tok_filename && last_tok_filename &&
		     ! streq(last_last_tok_filename, last_tok_filename) )
			reporter->Error("%s, at or near \"%s\" or end of file %s",
			                msg, last_tok, last_last_tok_filename);
		else
			reporter->Error("%s, at or near \"%s\"", msg, last_tok);
		}

	return 0;
	}
